<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri = "http://java.sun.com/jsp/jstl/functions"%>

<jsp:include page="main/header.jsp" />
<jsp:include page="main/menu-esquerdo.jsp" />

<!-- fullCalendar 2.2.5-->
<link rel="stylesheet" href="${pageContext.request.contextPath}/plugins/fullcalendar/fullcalendar.css">
<link rel="stylesheet" href="${pageContext.request.contextPath}/plugins/fullcalendar/fullcalendar.print.css" media="print">
  

<%-- CONTEUDO CENTRAL --%>
  <div class="content-wrapper">
  
	<section class="content-header">
		<h1>
			Situa&ccedil;&atilde;o das quadras <small>-  Visualiza&ccedil;&atilde;o</small>
		</h1>
		<ol class="breadcrumb">
			<li><a href="#"><i class="fa fa-dashboard"></i>Rela&ccedil;&atilde;o das quadras</a></li>
			<li>Relat&oacute;rios</li>
			<li class="active">Quadras</li>
		</ol>
	</section>

	<!-- Main content -->
	<section class="content">
	<div class="row">
		

		<!-- BLOCO COM AS CATEGORIA, SEPARADAS POR CORES -->
		<div class="col-md-3">
			<div class="box box-solid box-info">
				<div class="box-header with-border">
					<h4 class="box-title">Tipos de reservas</h4>
				</div>
				<div class="box-body">
					<div class="external-event reservaCategoria" style="background-color:#1b3aff;color:white" title="Torneio">Torneio</div>
					<div class="external-event reservaCategoria" style="background-color:#ff6723;color:white" title="Escolinha">Escolinha</div>
					<div class="external-event reservaCategoria" style="background-color:#5d993d;color:white" title="Manutencao">Manuten&ccedil;&atilde;o</div>
					<div class="external-event reservaCategoria" style="background-color:#9a1bff;color:white" title="Associado">Associado</div>
				</div>
		
			</div>
		</div>


		<!-- CALENDARIO DIVISAO !-->
		<div class="col-md-9">
			<div class="box box-info">
				<div class="box-body">
					<!-- THE CALENDAR -->
					<div id="calendar"></div>
				</div>
			</div>
		</div>

	</div>
	</section>
  </div>



<%-- CARREGAR PRIMEIRO O FOOTER, PARA TER ACESSO AO JQUERY E DEMAIS PLUGINS --%>
<jsp:include page="main/footer.jsp" />

<!-- fullCalendar 2.2.5 -->
<script src="${pageContext.request.contextPath}/plugins/fullcalendar/moment.js"></script>
<script src="${pageContext.request.contextPath}/plugins/fullcalendar/fullcalendar.js"></script>
<script src='${pageContext.request.contextPath}/plugins/fullcalendar/pt-br.js'></script>

<!-- Page specific script -->
<script>

	var cores = {
		itens: [
			{categoria:'Torneio', cor:'teal', rgb:'#1b3aff'}
			,{categoria:'Escolinha', cor:'orange', rgb:'#ff6723'}//Manutencao nao tem acento
			,{categoria:'Manutencao', cor:'olive', rgb:'#5d993d'}
			,{categoria:'Associado', cor:'purple', rgb:'#9a1bff'}
			,{categoria:'', cor:'aqua', rgb:'#00c0ef'}
			,{categoria:'', cor:'navy', rgb:'#001f3f'}
			,{categoria:'', cor:'lime', rgb:'#01ff70'}
		]
	};
  	
	$('.reservaCategoria').each(function(){
		var texto = $(this).attr('title');
		var returnedData = $.grep(cores.itens, function (item, index) {
			return item.categoria == texto;
		});
		$(this).css('background-color',returnedData[0].rgb);
	});
	
	
    function carregarCalendario(data){
    	
		//POPULAR O FULL CALENDAR COM AS RESERVAS
		for (var i = 0; i < data.length; i++) {
			  
			var returnedData = $.grep(cores.itens, function (item, index) {
				return item.categoria == data[i].categoria;
			});
			
			var d1 = data[i].dia1,
				m1 = data[i].mes1,//SOMAR 1, GregorianCalendar o mes comeca em ZERO
				y1 = data[i].ano1,
				h1 = data[i].hora1,
				min1 = data[i].min1, 
					d2 = data[i].dia2,
					m2 = data[i].mes2,//SOMAR 1, GregorianCalendar o mes comeca em ZERO
					y2 = data[i].ano2,
					h2 = data[i].hora2,
					min2 = data[i].min2,
					 	desc = '('+data[i].codReserva+') '+data[i].descricao,
					  	rgb = returnedData[0].rgb;
			
			var eventObject = {
					title: desc,
					start: new Date(y1, m1, d1, h1, min1),
					end: new Date(y2, m2, d2, h2, min2),
					backgroundColor: rgb
			};
		    $('#calendar').fullCalendar('renderEvent', eventObject, true);
		}
    }

	
	//CARREGAR DADOS ON ONLOAD DA PAGINA
	$(function () {

		//DEFINICOES PADROES PARA O FULL CALENDAR
		//https://fullcalendar.io/docs/views/Available_Views/
		$('#calendar').fullCalendar({
			//nao alterar os seletores do header, nÃ£o sao textos de botao
			header: {
				left: 'prev,today,next',
				center: 'title',
				right: 'month,agendaWeek,agendaDay'
			},
			locale: 'pt-br',
			editable: false,
			droppable: false
		});

		var URLAJAX = "minhaquadra/reservas/listar/calendario";
	    $.ajax({
		    url: URLAJAX,
		    type: "GET",
		    async: false
	    })
	    .done(function(data) {
			//console.table(data);
			carregarCalendario(data);
		})
		.fail(function(data) {
			console.log(data);
		});
	});
	    
</script>