<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<jsp:include page="main/header.jsp" />
<jsp:include page="main/menu-esquerdo.jsp" />


  <%-- DataTables --%>
  <link rel="stylesheet" href="${pageContext.request.contextPath}/plugins/datatables/dataTables.bootstrap.css">

  <%-- CONTEUDO CENTRAL --%>
  <div class="content-wrapper">
	<section class="content-header">
	  <h1>Relao de Itens <small> Pesquisa e cadastro.</small></h1>
	  <ol class="breadcrumb">
		<li><a href="#"><i class="fa fa-dashboard"></i> Level</a></li>
		<li class="active">Here</li>
	  </ol>
	</section>

	<section class="content">

		<div class="row">
		
			<div class="col-md-4 col-md-auto">
		
				<%-- CADASTRO DE TIPOS DE QUADRAS --%>
		        <div class="box box-solid box-info">
		            <div class="box-header with-border text-center">
		              <h3 class="box-title">Cadastrar novo item de manuteno</h3>
		            </div><!-- /.box-header -->
		            
		            <!-- form start -->
		            <form method="post" class="form-horizontal">
			              <div class="box-body">
			                <div class="form-group">
			                  <label for="codItem" class="col-md-3 control-label">Cdigo</label>
			
			                  <div class="col-md-9">
			                    <input type="text" class="form-control" id="codItem" name="codigo" placeholder="cdigo" readonly>
			                  </div>
			                </div>
					        <div class="form-group">
			                  <label for="descItem" class="col-md-3 control-label">Item</label>
			
			                  <div class="col-md-9">
			                    <input type="text" class="form-control" id="descItem" name="descricao" placeholder="item">
			                  </div>
			                </div>
					        <div class="form-group">
			                  <label for="valItem" class="col-md-3 control-label">Valor</label>
			
			                  <div class="col-md-9">
			                    <input type="text" step="0.01" class="form-control" id="valItem" name="valor" placeholder="valor" onKeyUp="validaNumero()">
			                  </div>
			                </div>
			              </div><!-- /.box-body -->
			              
						<div class="box-footer">
							<div class="col-sm-12">
								<button type="reset" class="btn btn-default">Limpar</button>
								<button type="submit" id="cadastrar" class="btn btn-info pull-right">Salvar</button>
							</div>
						</div>
		            </form>
		            
			        <div class="hide statusMessage callout">
						<p></p>
			        </div>
			        
		        </div><!-- box box-success -->
		
			</div><!-- col-md-6 col-md-auto -->
		
			<div class="col-md-8 col-md-auto">
		
				<%-- LISTAGEM DE ITENS --%>
				<div class="box box-info">
		            <div class="box-header text-center">
		              <h3 class="box-title">Relao dos Itens.</h3>
		            </div>
		            <!-- /.box-header -->
		            <div class="box-body">
		              <table id="example1" name="listaItens" class="table table-bordered table-striped">
		                
		                <thead>
			                <tr>
			                  <th>Cdigo</th>
			                  <th>Descrio</th>
			                  <th>Valor</th>
			                  <th>Aes</th>
			                </tr>
		                </thead>
		
		                <tbody>
						  <c:forEach var="itens" items="${itens}">
						    <tr id="${itens.codItem}">
						      <td>${itens.codItem}</td>
						      <td>${itens.descricao}</td>
						      <td>${itens.valor}</td>
		  		      		  <td>
									<div class="acoesBtn btn-group">
										<div class="col align-self-center">
		           							<form method="post" id="btnItens" class="form-horizontal">
												<button type="button" class="btn btn-default btn-sm"
													onclick="Alterar(${itens.codItem},'${itens.descricao}',${itens.valor})">
													<i class="fa fa-edit"></i></button>
												<button type="button" class="btn btn-default btn-sm" 
													 onclick="Deletar(${itens.codItem})">
													<i class="fa fa-trash-o"></i></button>
											</form>
										</div>
				                    </div>
						      </td>
						    </tr>
						  </c:forEach>
		
		                </tbody>
		                
		                <tfoot style="display:none">
			                <tr>
			                  <th>Rendering engine1</th>
			                  <th>Browser</th>
			                  <th>Platform(s)</th>
			                  <th>Engine version</th>
			                  <th>CSS grade</th>
			                </tr>
		                </tfoot>
		                
		              </table>
		            </div><!-- /.box-body -->
		          </div><!-- /.box -->
			
			</div><!-- .col -->
			
		</div>

	</section><!-- /.content -->
  </div><!-- /.content-wrapper -->

<%-- CARREGAR PRIMEIRO O FOOTER, PARA TER ACESSO AO JQUERY E DEMAIS PLUGINS --%>
<jsp:include page="main/footer.jsp" />

	<%-- DataTables --%>
	<script src="${pageContext.request.contextPath}/plugins/datatables/jquery.dataTables.min.js"></script>
	<script src="${pageContext.request.contextPath}/plugins/datatables/dataTables.bootstrap.min.js"></script>
	<!-- Select2 -->
	<script src="${pageContext.request.contextPath}/plugins/select2/select2.full.min.js"></script>
	
	<%-- Page script --%>
	<script>
    var form = $('#form1');
    
  	$(function () {
		//Initialize Select2 Elements
	    $(".select2").select2();

	    //iCheck for checkbox and radio inputs
	    $('input[type="checkbox"].minimal, input[type="radio"].minimal').iCheck({
	      checkboxClass: 'icheckbox_minimal-blue',
	      radioClass: 'iradio_minimal-blue'
	    });
	    //Red color scheme for iCheck
	    $('input[type="checkbox"].minimal-red, input[type="radio"].minimal-red').iCheck({
	      checkboxClass: 'icheckbox_minimal-red',
	      radioClass: 'iradio_minimal-red'
	    });
	    //Flat red color scheme for iCheck
	    $('input[type="checkbox"].flat-red, input[type="radio"].flat-red').iCheck({
	      checkboxClass: 'icheckbox_flat-green',
	      radioClass: 'iradio_flat-green'
	    });
	});
  	
  	function validaNumero(){
		var valor = $("input[name*='valor']").val().trim();
  		var tamanho = valor.length;
		var aux = "";
  		
		for (var i = 0; i < tamanho; i++){
			if (valor[i] >= 0 || valor[i] <= 9){
				aux += valor[i];
			}else if (valor[i] == ","){
				valor[i] = ".";
			}
			
			if ( valor[i] == "." && valor.indexOf(".") == i ){
				aux += valor[i];
			}
		}
		
		if (aux.indexOf(".") >= 0)
			aux = aux.substring(0,aux.indexOf(".")+3)
		
		$("input[name*='valor']").val(aux);
  	}
</script>
	
	<%-- ALTERAR --%>
	<script>		
	  	function Alterar(codItem,descItem,valItem){
    		$('#codItem').val(codItem);
    		$('#descItem').val(descItem);
    		$('#valItem').val(valItem);	  		
    		$('#acao').val('editar');	  		
	  	}
	</script>
	
	<%-- CADASTRAR --%>
	<script>		
		$("#cadastrar").click( function(){

			var URLAJAX = "minhaquadra/item/cadastrar/banco";
			var codItem = $("input[name*='codigo']").val().trim();
			var descricao = $("input[name*='descricao']").val().trim();
			var valor = $("input[name*='valor']").val().trim();
			$(".statusMessage").addClass("hide");

			if(descricao == ""){
				Mensagem(erro,"Preencha a descrio.");	
				$("input[name*='descricao']").focus();
				return false;
			
			}else if(valor == "" || parseFloat(valor) == 0 ){
				Mensagem(erro,"Preencha o valor.");	
				$("input[name*='valor']").focus();
				return false;
			
			}else{
			    $.ajax({
				    url: URLAJAX,
				    type: "PUT",
				    async: false,//!IMPORTANT incluir async:false
				    data: {"codItem":codItem, "descricao":descricao, "valor":valor},
				    dataType: "json"
			    })
			 	.done(function(data) {
			 		if(data==1){
						//Mensagem(sucesso,"Dados gravados com sucesso.");
			 		}else{
						//Mensagem(erro,"No foi possvel gravar os dados.");	 			
			 		}
				})
				.fail(function(data) {
					//Mensagem(erro,"No foi possvel gravar os dados.");
				});
			}
		});
	</script>

	<%-- EXCLUIR --%>
	<script>
		function Deletar(codigo){

			var URLAJAX = "minhaquadra/item/excluir/banco";
			$(".statusMessage").addClass("hide");
			
		    $.ajax({
			    url: URLAJAX,
			    type: "DELETE",
			    async: false,//!IMPORTANT incluir async:false
		   		data: {"codigo":codigo},
			    dataType: "json"
		    })
		    .done(function(data) {
				if(data==1){
					Mensagem(sucesso,"Dados excludos com sucesso.");
					
					var row = document.getElementById(codigo);
					row.remove();
				}else{
					Mensagem(erro,"Item foi usado em manutenes.");	
				}
			})
			.fail(function(data) {
				Mensagem(erro, "No foi possvel excluir os dados.");
			});
		}

	</script>
	
	<%-- page script --%>
	<script>
	  $(function () {
	    $("#example1").DataTable();
	    $('#example2').DataTable({
	      "paging": true,
	      "lengthChange": false,
	      "searching": false,
	      "ordering": true,
	      "info": true,
	      "pageLength": 5,
	      "autoWidth": false
	    });
	  });
	</script>	