<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>

<jsp:include page="main/header.jsp" />
<jsp:include page="main/menu-esquerdo.jsp" />

  <%-- DataTables --%>
  <link rel="stylesheet" href="${pageContext.request.contextPath}/plugins/datatables/dataTables.bootstrap.css">

  <%-- CONTEUDO CENTRAL --%>
  <div class="content-wrapper">
	<section class="content-header">
	  <h1>Relao de Manutenes <small> Pesquisa e cadastro.</small></h1>
	  <ol class="breadcrumb">
		<li><a href="#"><i class="fa fa-dashboard"></i> Level</a></li>
		<li class="active">Here</li>
	  </ol>
<!-- 	</section> -->
<%-- 	<c:forEach var="tipos" items="${quadras}"> --%>
<%-- 		<input type="text" value="${tipos.codQuadra}">	 --%>
<%-- 	</c:forEach> --%>
	</section>
	<section class="content">

		<div class="row">
		
			<div class="col-md-6 col-md-auto">
		
				<%-- CADASTRO DE TIPOS DE QUADRAS --%>
		        <div class="box box-solid box-info">
		            <div class="box-header with-border text-center">
		              <h3 class="box-title">Cadastrar nova manuteno</h3>
		            </div><!-- /.box-header -->
		            
		            <!-- form start -->
		            <form method="post" class="form-horizontal">
			              <div class="box-body">
			                <div class="form-group">
			                  <label for="codItem" class="col-md-2 control-label">Cdigo</label>
			
			                  <div class="col-md-10">
			                    <input type="text" class="form-control" id="codManutencao" name="codigo" placeholder="cdigo" readonly>
			                  </div>
			                </div>

				 			<div class="form-group">
		                 		<label class="col-md-2 control-label">Perodo</label>
			                 	<div class="col-md-10">
				                 	<div class="input-group">
					                  	<input type="text" class="form-control pull-right" id="datacombopicker" />
									  	<div class="input-group-addon showdatacombopicker">
											<i class="fa fa-calendar"></i>
					                  	</div>
					                </div>
				                </div>
			                </div>
							
						    <div class="form-group">
								<label class="col-xs-2 control-label">Tipo</label>
								<div class="col-xs-10 selectContainer">
									<select id="cbtipos" class="form-control select2" data-fv-field="tipos" name="tipos" data-placeholder="Selecione o esporte."> 
										<c:forEach var="tipos" items="${tipos}">
									  		<option value="${tipos.codTipo}" >${tipos.descricao}</option>
							  			</c:forEach>
						  			</select>
						  		</div>
							</div>	
							
						    <div class="form-group">
								<label class="col-xs-2 control-label">Quadra</label>
								<div class="col-xs-10 selectContainer">
									<select class="form-control select2" name="quadras" data-placeholder="Selecione as quadras"></select>
						  		</div>
							</div>	
							
						    <div class="form-group">
								<label class="col-xs-2 control-label">Itens</label>
								<div class="col-xs-7 selectContainer">
									<select id="cbItens" class="form-control select2" data-fv-field="itens"> 
										<c:forEach var="itens" items="${itens}">
									  		<option value="${itens.codItem}">${itens.descricao}</option>
							  			</c:forEach>
						  			</select>
						  		</div>
								<div class="col-xs-3">
			                    	<input type="button" class="form-control" id="btnAddItem" onclick="addItem()" value="+">
						  		</div>
						  	</div>			  	
						  	
						  	<div class="box-body">
				              <table id="tblItens" class="table table-bordered">
				                <thead>
					                <tr>
					                  <th>Item</th>
					                  <th>Qtd</th>
					                </tr>
				                </thead>
				                <tbody>
				                	
				                </tbody>
				              </table>
				            </div><!-- /.box-body -->
			              </div><!-- /.box-body -->
			              
						<div class="box-footer">
							<div class="col-sm-12">
								<button type="reset" class="btn btn-default">Limpar</button>
								<button type="submit" id="cadastrar" class="btn btn-info pull-right">Salvar</button>
							</div>
						</div>
		            </form>
			            
	  		        <div class="hide statusMessage callout">
						<p></p>
			        </div>

		        </div><!-- box box-success -->
		
			</div><!-- col-md-6 col-md-auto -->
			
			<div class="col-md-6 col-md-auto">
		
<!-- 				LISTAGEM DE ITENS -->
		        <div class="box box-info">
		            <div class="box-header text-center">
		              <h3 class="box-title">Relao das Manutenes.</h3>
		            </div><!-- /.box-header -->
		            <div class="box-body">
		              <table id="example1" class="table table-bordered table-striped">
		                
		                <thead>
			                <tr>
			                  <th>Quadra</th>
								<th>Incio</th><!-- 12/12/2012 -->
								<th>Fim</th><!-- 31/12/2012 -->
								<th>Horrio</th><!-- 11h a 12h -->
			                  <th>Valor Total</th>
			                </tr>
		                </thead>
		
		                <tbody>
						  <c:forEach var="reservas" items="${reservas}">
						    <tr>
							    <td>${reservas.quadras[0].codQuadra}</td>
							    <fmt:formatDate type="date" pattern="dd/MM/yyyy" value="${reservas.dataInicial}" var="campoDataI" />
								<td><c:out value="${campoDataI}"/></td>
								<fmt:formatDate type="date" pattern="dd/MM/yyyy" value="${reservas.dataFinal}" var="campoDataF" />
								<td><c:out value="${campoDataF}"/></td>
								<td><fmt:formatDate type="time" pattern="HH:mm" value="${reservas.horaInicial}" /> &aacute;
									<fmt:formatDate type="time" pattern="HH:mm" value="${reservas.horaFinal}" />
								</td>
						        <td>${reservas.manutencoes.valor_total}</td>
						    </tr>
						  </c:forEach>
		
		                </tbody>
		                
		              </table>
		            </div>
		          </div>			
			</div>			
		</div>
	</section><!-- /.content -->
  </div><!-- /.content-wrapper -->

<%-- CARREGAR PRIMEIRO O FOOTER, PARA TER ACESSO AO JQUERY E DEMAIS PLUGINS --%>
<jsp:include page="main/footer.jsp" />

<%-- PLUGINS UTILIZADOS SOMENTE PARA ESTA PAGINA --%>
<script src="${pageContext.request.contextPath}/plugins/daterangepicker/moment.js"></script>
<script src="${pageContext.request.contextPath}/plugins/daterangepicker/daterangepicker.js"></script>
<%-- <script src="${pageContext.request.contextPath}/plugins/datepicker/bootstrap-datepicker.js"></script> --%>
<script src="${pageContext.request.contextPath}/plugins/timepicker/bootstrap-timepicker.min.js"></script>
	
	<%-- DataTables --%>
	<script src="${pageContext.request.contextPath}/plugins/datatables/jquery.dataTables.min.js"></script>
	<script src="${pageContext.request.contextPath}/plugins/datatables/dataTables.bootstrap.min.js"></script>
	<!-- Select2 -->
	<script src="${pageContext.request.contextPath}/plugins/select2/select2.full.min.js"></script>
		
	<%-- Page script --%>
	<script>
	
	
	$(document).ready(function() {
		//https://select2.github.io/examples.html#events
		$("select[name='tipos']").val("").trigger("change");
		var $eventSelect = $("select[name*='tipos']");
		$eventSelect.on("change", function (e) {
			if($eventSelect.val()!=null && $eventSelect.val()!="")
				SelecionaTipo();
				//pesquisar_quadras($eventSelect.val());	
		});
	});	
	
    var form = $('#form1');
	  	$(function () {
// 	  		$("select[name='tipos']").trigger("change");
	  		
			//Initialize Select2 Elements
		    $(".select2").select2();

		    //iCheck for checkbox and radio inputs
		    $('input[type="checkbox"].minimal, input[type="radio"].minimal').iCheck({
		      checkboxClass: 'icheckbox_minimal-blue',
		      radioClass: 'iradio_minimal-blue'
		    });
		    //Red color scheme for iCheck
		    $('input[type="checkbox"].minimal-red, input[type="radio"].minimal-red').iCheck({
		      checkboxClass: 'icheckbox_minimal-red',
		      radioClass: 'iradio_minimal-red'
		    });
		    //Flat red color scheme for iCheck
		    $('input[type="checkbox"].flat-red, input[type="radio"].flat-red').iCheck({
		      checkboxClass: 'icheckbox_flat-green',
		      radioClass: 'iradio_flat-green'
		    });
		    
		  	//Date range picker with time picker
			$('#datacombopicker').daterangepicker({
				locale:{format: 'hh:mm A DD/MM/YYYY', separator: " at "},
			    timePicker24Hour: true,
				timePicker: true,
				timePickerIncrement: 10, 
				format: 'DD/MM/YYYY hh:mm',
				opens: 'right',
				}, function(start, end, label) {
					console.log('Nova data selecionada: ' + start.format('DD/MM/YYYY') + ' a ' + end.format('DD/MM/YYYY') );
				}
			);
			
			$('.showdatacombopicker').click(function(){
				$(this).prev().click();
			});
			
		});

		$(function () {
			$("form").bind("reset", function(e){
				e.preventDefault();
				$("select[id='cbItens']").val("").trigger("change");
				
				$("select[name='quadras']").val("").trigger("change");
				$("select[name='tipos']").val("").trigger("change");
				$('#datacombopicker').data('daterangepicker').setStartDate(new Date());
				$('#datacombopicker').data('daterangepicker').setEndDate(new Date());				
			});
// 			$("form").bind("submit", function(e){
// 				e.preventDefault();//nao redirecionar com o submit do formulario
// 			});
		});
		
	
	  	function SelecionaTipo(){
	  	    var cbtipos = document.getElementById("cbtipos");
	  	    var esporte = cbtipos.options[cbtipos.selectedIndex].text;

	  	  	console.log(esporte);
			//$(".statusMessage").addClass("hide");
			
			var dataInicial = $("#datacombopicker").data('daterangepicker').startDate.format('DD/MM/YYYY');
			var dataFinal = $("#datacombopicker").data('daterangepicker').endDate.format('DD/MM/YYYY');
			var horaInicial = $("#datacombopicker").data('daterangepicker').startDate.format('HH:mm');
			var horaFinal = $("#datacombopicker").data('daterangepicker').endDate.format('HH:mm');
			
			var URLAJAX = "minhaquadra/quadra/buscar/esporte/data";
		    $.ajax({
			    url: URLAJAX,//VIA GET PASSAR NA URL O PARAMETRO
			    type: "POST",
			    async: false,//!IMPORTANT incluir async:false
			    data: {
			    	"esporte": ""+esporte,
			    	"dataInicial": ""+dataInicial,
			    	"dataFinal": ""+dataFinal,
			    	"horaInicial": ""+horaInicial,
			    	"horaFinal": ""+horaFinal
		    		}
		    })
		    .done(function(data) {
		    	if(data!='undefined'){
		    		var listaQuadras = data.split(";");
				    var found = 0;
		    		$("select[name*='quadras']").html("");
				    for (var i = 0, j = 0, len = listaQuadras.length; i < len; i+=3) {
				    	if(listaQuadras[i].length > 0){
				    		var CODIGO = i;
				    		var NOME = i+1;
				    		var STATUS = i+2;
				    		var indiceOf = listaQuadras[STATUS].search("Dispon");//-1 nao encontrou
				    		if(indiceOf>-1){
				    			found = 1;
					    		$("select[name*='quadras']").append("<option value='"+listaQuadras[CODIGO]+"'>"+listaQuadras[CODIGO]+"-"+listaQuadras[STATUS]+"</option>");
					    		$("select[name*='quadras']").trigger('change');
				    		}
				    		else{
					    		$("select[name*='quadras']").append("<option value='"+listaQuadras[CODIGO]+"' disabled='disabled'>"+listaQuadras[CODIGO]+"-"+listaQuadras[STATUS]+"</option>");
				    		}
				    	} 
		    		}
					if(found == 0){
						Mensagem(erro, "Somente foram encontradas quadras fechadas para este tipo.");
					}else{
						Mensagem(sucesso, "Selecione as quadras disponveis.");
					}
				}
				//atualizarMensagens(1)
			})
			.fail(function(data) {
				$("select[name*='quadras'] option").html("");
				$("select[name*='quadras']").val("").trigger('change');
				Mensagem(erro, "No existem quadras cadastradas para este tipo.");
			});
		}
	  	
	  	function addItem(){
	  		var existe = false;
		    var comboItens = document.getElementById("cbItens");
			var codItem = comboItens.options[comboItens.selectedIndex].value;
			var descItem = comboItens.options[comboItens.selectedIndex].text;
			var indexItem = document.getElementById("tblItens").rows.length;

			for (var i = 1; i < indexItem; i++){
				if(codItem == $("input[name*='codItem"+i+"']").val()){
					existe = true;
				}
			}
			
			if(!existe){
				$(".statusMessage.callout-danger").addClass("hide");
				$('#tblItens tbody').append(""+
					'<tr>'+
						"<td class='hidden'><input type='hidden' name=codItem"+indexItem+" value="+codItem+" /></td>"+
						"<td>"+descItem+"</td>"+
						"<td align='right'><input type='number' min=0 name='qtdItem"+indexItem+"' value=0 style='text-align: right' /></td>"+
					'</tr>');
			}else{
				Mensagem(erro, "Item j incluso.");
			}
	  	}
	</script>
	
	
	<%-- CADASTRAR --%>
	<script>
		$(document).ready(function() {
			$(".dataTables_filter").append("<input type='button' value='Atualizar' class='btn btn-info pull-right' />");
			$( "input[value*='Atualizar']" ).click(function() {
				location.href = "itens_cadastro";
			});
		});

		$("#cadastrar").click(function(){
			var URLAJAX = "minhaquadra/reservas/cadastrar/manutencao";
			var tem_item = false;

			var a_pInicial = $("#datacombopicker").data('daterangepicker').startDate.format('A');
			var horaInicial = $("#datacombopicker").data('daterangepicker').startDate.format('hh');

			if(a_pInicial == "PM"){
				horaInicial += 12;
			}else{
				if(horaInicial == "12"){
					horaInicial = "00";
				}
			}
			
			var a_pFinal = $("#datacombopicker").data('daterangepicker').endDate.format('A');
			var horaFinal = $("#datacombopicker").data('daterangepicker').endDate.format('hh');

			if(a_pFinal == "PM"){
				horaFinal = parseInt(horaFinal)+12;
			}else{
				if(horaFinal == "12"){
					horaFinal = "00";
				}
			}
			
			var horaInicial = horaInicial+$("#datacombopicker").data('daterangepicker').startDate.format(':mm');
			var horaFinal = horaFinal+$("#datacombopicker").data('daterangepicker').endDate.format(':mm');
			
			var dataInicial = $("#datacombopicker").data('daterangepicker').startDate.format('DD/MM/YYYY');
			var dataFinal = $("#datacombopicker").data('daterangepicker').endDate.format('DD/MM/YYYY');

			var quadra = $("select[name='quadras']").val();

			var arrayCodsItens = "";
			var arrayQtdsItens = "";
			var qtdItens = document.getElementById("tblItens").rows.length;
			for (var i = 1; i < qtdItens; i++){
				arrayCodsItens += $("input[name*='codItem"+i+"']").val() + ";";
				arrayQtdsItens += $("input[name*='qtdItem"+i+"']").val() + ";";
				
				if(!tem_item && $("input[name*='qtdItem"+i+"']").val() > 0)
					tem_item = true;
			}
			
			$(".statusMessage").addClass("hide");
			
			if(dataInicial == ""){
				Mensagem(erro, "Selecione o perodo.");
				return false;
			}else if(quadra == null){
				Mensagem(erro, "Selecione uma quadra.");
				return false;
			}else if(!tem_item){
				Mensagem(erro, "Insira um item.");
				return false;
			}else{
			    $.ajax({
				    url: URLAJAX,
				    type: "PUT",
				    async: false,//!IMPORTANT incluir async:false
				    data: {
				    	"horaInicial":horaInicial,	
				    	"dataInicial":dataInicial, 
				    	
				    	"horaFinal":horaFinal,		
				    	"dataFinal":dataFinal,
				    	
				    	"quadra":quadra,
				    	"arrayCodsItens":arrayCodsItens,
				    	"arrayQtdsItens":arrayQtdsItens
				    },
				    dataType: "json"
			    })
			    .done(function(data) {
					if(data==1){
						Mensagem(sucesso, "Dados gravados com sucesso.");
					}else{
						Mensagem(erro, "No foi possvel gravar os dados.");
					}
				})
				.fail(function(data) {
					Mensagem(erro, "No foi possvel gravar os dados.");
				});
			}
		});
	</script>
	
	<%-- page script --%>
	<script>
	  $(function () {
	    $("#example1").DataTable();
	    $('#example2').DataTable({
	      "paging": true,
	      "lengthChange": false,
	      "searching": false,
	      "ordering": true,
	      "info": true,
	      "pageLength": 5,
	      "autoWidth": false
	    });
	  });
	</script>