<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<jsp:include page="main/header.jsp" />
<jsp:include page="main/menu-esquerdo.jsp" />

  <%-- CONTEUDO CENTRAL --%>
  <div class="content-wrapper">
    <section class="content-header">
      <h1>Gestor de Quadras <small> Cadastro e edi&ccedil;&atilde;o</small></h1>
      <ol class="breadcrumb">
        <li><a href="#"><i class="fa fa-dashboard"></i> Minhas Quadras</a></li>
        <li>Quadras</li>
		<li class="active">Visualiza&ccedil;&atilde;o</li>
      </ol>
    </section>

	<section class="content">

		<div class="row">

			<div class="col-md-4 col-md-auto">

				<%-- CADASTRO DE TIPOS DE QUADRAS --%>
		        <div class="box box-solid box-info">
		            <div class="box-header with-border text-center">
		              <h3 class="box-title">Cadastrar novo tipo de quadra</h3>
		            </div><!-- /.box-header -->

		            <!-- form start -->
		            <form class="form-horizontal" action="#" method="post">
			              <div class="box-body">
			                <div class="form-group">
			                  <label for="descricao1" class="col-md-3 control-label">C&oacute;digo</label>

			                  <div class="col-md-9">
			                    <input type="text" class="form-control" name="tipo_codigo" placeholder="C&oacute;digo" disabled>
			                  </div>
			                </div>
					        <div class="form-group">
			                  <label for="descricao1" class="col-md-3 control-label">Tipo</label>

			                  <div class="col-md-9">
			                    <input type="text" class="form-control" name="tipo_descricao" placeholder="Tipo">
			                  </div>
			                </div>
			              </div><!-- /.box-body -->

			              <div class="box-footer">
			                <button type="reset" class="btn btn-default">Limpar</button>
       						<input type="submit" id="cadastrarTipo" class="btn btn-info pull-right" value="Salvar" />
			              </div><!-- /.box-footer -->
		            </form>

		        <div class="hide statusTipo callout">
					<p></p>
		        </div>

		        </div><!-- box box-success -->



				<%-- CADASTRO DAS INFO DE QUADRAS --%>
		        <div class="box box-solid box-info">
		            <div class="box-header with-border text-center">
		              <h3 class="box-title">Cadastrar/Editar uma nova quadra</h3>
		            </div><!-- /.box-header -->

		            <form class="form-horizontal" action="#" method="post">
		              <div class="box-body">

		                <div class="form-group">
						    <div class="col-md-3"><label>Selecione o tipo de quadra</label></div>
						    <div class="col-md-9">
							    <select class="form-control select2" name="tipo_quadra" data-placeholder="Selecione uma op&ccedil;&atilde;o" style="width: 100%;">
							    	<c:forEach var="tiposquadras" items="${tiposquadras}">
							    		<option>${tiposquadras.descricao}</option>
							    	</c:forEach>
							  	</select>
							</div>
		                </div>

		                <div class="form-group">
		                  <label for="descricao1" class="col-md-3 control-label">Descri&ccedil;&atilde;o</label>

		                  <div class="col-md-9">
		                    <input type="text" class="form-control" name="descricao_quadra" placeholder="Quadra">
		                  </div>
		                </div>

		                <div class="form-group">
		                  <div class="col-md-offset-3 col-md-4">
		                      <label><input type="checkbox" name="eDisponivel">&nbsp;&nbsp;Quadra em manuten&ccedil;&atilde;o</label>
		                   </div>
		                  <div class="col-md-4">
		                      <label><input type="checkbox" name="eCoberta">&nbsp;&nbsp;Quadra coberta</label>
		                   </div>
		                 </div>

		              </div><!-- /.box-body -->

		              <div class="box-footer">
		                <button type="reset" class="btn btn-default">Limpar</button>
   						<input type="submit" id="cadastrarQuadra" class="btn btn-info pull-right" value="Salvar" />
		              </div><!-- /.box-footer -->

		            </form>

		        <div class="hide statusMessage callout">
					<p></p>
		        </div>

	          </div>

			</div><!-- col-md-6 col-md-auto -->

			<div class="col-md-8 col-md-auto">

				<%-- LISTAGEM DE QUADRAS --%>
		        <div class="box box-info">
		            <div class="box-header text-center">
		              <h3 class="box-title">Rela&ccedil;&atilde;o das Quadras.</h3>
		            </div>
		            <!-- /.box-header -->
		            <div class="box-body">
		              <table id="example1" class="table table-bordered table-striped">

		                <thead>
			                <tr>
			                  <th>C&oacute;d</th>
			                  <th>Tipo</th>
			                  <th>Descri&ccedil;&atilde;o</th>
			                  <th>Em manuten&ccedil;&atilde;o</th>
			                  <th>Coberta</th>
			                  <th>A&ccedil;&otilde;es</th>
			                </tr>
		                </thead>

		                <tbody>
						  <c:forEach var="quadras" items="${quadras}">
						    <input type="hidden" class="codtipo_quadra" value="${quadras.codQuadra}">
						    <tr id="${quadras.codQuadra}">
						      <td>${quadras.codQuadra}</td>
						      <td>${quadras.esporte}</td>
						      <td>${quadras.descricao}</td>
		  		      		  <td>
								<c:choose>
									<c:when test="${quadras.eDisponivel=='0'}">
										<%-- DESABILITA O CAMPO COM CSS - style="pointer-events:none"" --%>
								 		<label style="pointer-events:none"><input type="checkbox" class="iCheck"></label>
									</c:when>
									<c:otherwise>
								 		<label style="pointer-events:none"><input type="checkbox" class="iCheck" checked="checked"></label>
									</c:otherwise>
								</c:choose>
		  		      		  </td>
						      <td>
								<c:choose>
									<c:when test="${quadras.eCoberta=='0'}">
								 		<label style="pointer-events:none"><input type="checkbox" class="iCheck"></label>
									</c:when>
									<c:otherwise>
								 		<label style="pointer-events:none"><input type="checkbox" class="iCheck" checked="checked"></label>
									</c:otherwise>
								</c:choose>
		  		      		  </td>
		  		      		  <td>
						        	<div class="btn-group">
										<div class="col text-center align-self-center">
											<%-- <button type="button" class="btn btn-default btn-sm"><i class="fa fa-eye"></i></button> --%>
											<button type="button" onclick="editar_quadra(${quadras.codQuadra},'${quadras.tipo}','${quadras.esporte}','${quadras.descricao}',${quadras.eDisponivel},${quadras.eCoberta})" class="editar_quadra btn btn-default btn-sm" aria-pressed="false"><i class="fa fa-edit"></i></button>
											<button type="button" onclick="excluir_quadra(${quadras.codQuadra})" class="excluir_quadra btn btn-default btn-sm"><i class="fa fa-trash-o" aria-pressed="false"></i></button>
										</div>
				                    </div>
						      </td>
						    </tr>
						  </c:forEach>

		                </tbody>

		              </table>
		            </div><!-- /.box-body -->
		          </div><!-- /.box -->

			</div><!-- .col -->

		</div>


	</section><!-- /.content -->
  </div><!-- /.content-wrapper -->


<%-- CARREGAR PRIMEIRO O FOOTER, PARA TER ACESSO AO JQUERY E DEMAIS PLUGINS --%>
<jsp:include page="main/footer.jsp" />

<%-- PLUGINS UTILIZADOS SOMENTE PARA ESTA PAGINA --%>


	<%-- Page script --%>
	<script type="text/javascript">
	var codQuadra = 0;
		$(function() {
			//Initialize Select2 Elements
			$(".select2").select2();
			
			//Flat GREEN color scheme for iCheck
			$('input[type="checkbox"].iCheck, input[type="radio"].iCheck').iCheck({
				checkboxClass : 'icheckbox_flat-green', radioClass : 'iradio_flat-green'
			});
			
			$("#example1").DataTable();
		});
		
		/*
		$(function () {
		  $('[data-toggle="popover"]').popover()
		});
		
		data-loading-text="Loading..."  Loading no retorno do dao coloca um  reset, no botao clicado
		
		*/
		/*$(function () {
			$("form").bind("reset", function(e){
				e.preventDefault();
				$('#datacombopicker').data('daterangepicker').setStartDate(new Date());
				$('#datacombopicker').data('daterangepicker').setEndDate(new Date());
				$("select[name='dias_semana']").val("").trigger("change");
				$("select[name='tipo_quadra']").val("").trigger("change");
				$("input[name*='timepickerInicial']").timepicker('setTime', "");
				$("input[name*='timepickerFinal']").timepicker('setTime', "");
				$("input[name*='descricao']").val("");
			});
		});*/
	</script>

	<%-- EDITAR --%>
	<script>
	
	function editar_quadra(codigo, codtipo, esporte, descricao, eDisponivel, eCoberta){
		codQuadra = codigo;
		//$("input[name*='tipo_codigo']").val(codtipo);
		//$("input[name*='tipo_descricao']").val(esporte);
		
		$("select[name='tipo_quadra']").val(esporte).trigger("change");
		$("input[name*='descricao_quadra']").val(descricao);
		if(eDisponivel==1)
			$("input[name*='eDisponivel']").prop('checked', true);
		else
			$("input[name*='eDisponivel']").prop('checked', false);
		if(eCoberta==1)
			$("input[name*='eCoberta']").prop('checked', true);
		else
			$("input[name*='eCoberta']").prop('checked', false);
	}


	</script>

	<%-- EXCLUIR --%>
	<script>

		function excluir_quadra(codQuadra){
			var URLAJAX = "minhaquadra/quadra/excluir/banco";
			$(".statusMessage").addClass("hide");
			
		    $.ajax({
			    url: URLAJAX,
			    type: "DELETE",
			    async: false,//!IMPORTANT incluir async:false
			    data: {"codQuadra":codQuadra},
			    dataType: "json"
		    })
		    .done(function(data) {
				if(data==1){
					Mensagem(sucesso, "Dados exclu&iacute;dos com sucesso.");

					var row = document.getElementById(codQuadra);
					row.remove();
				}else{
					Mensagem(erro, "A quadra est&aacute; reservada.");
				}
			})
			.fail(function(data) {
				Mensagem(erro, "N&atilde;o foi poss&iacute;vel excluir o registro.");
			});
		}
	</script>

	<%-- CADASTRAR --%>
	<script>

		$(document).ready(function() {
			$(".dataTables_filter").append("<input type='button' value='Atualizar' class='btn btn-info pull-right' />");
			$( "input[value*='Atualizar']" ).click(function() {
				location.href = "quadras_cadastro";
			});
		});

		$( "#cadastrarQuadra" ).click(function() {
			var URLAJAX = "minhaquadra/quadra/cadastrar/banco";

			var tipo = $("select[name='tipo_quadra'] option:selected").val();
			var descricao = $("input[name*='descricao_quadra']").val();
			
			var eDisponivel= 0;
			if($("input[name*='eDisponivel']").is(':checked')){ eDisponivel=1; }
			var eCoberta= 0;
			if($("input[name*='eCoberta']").is(':checked')){ eCoberta=1; }
			
			$(".statusMessage").addClass("hide");

			if(descricao == ""){
				Mensagem(erro,"Preencha a descri&ccedil;&atilde;o.");	
				$("input[name*='descricao_quadra']").focus();
				return false;
			}else{
			    $.ajax({
				    url: URLAJAX,
				    type: "PUT",
				    async: false,//!IMPORTANT incluir async:false
				    data: {"codQuadra":codQuadra, "tipo":tipo, "descricao":descricao, "eDisponivel":eDisponivel, "eCoberta":eCoberta},
				    dataType: "json"
			    })
			    .done(function(data) {
					if(data==1){
						//Mensagem(sucesso,"Dados gravados com sucesso.");
					}else{
						//Mensagem(erro,"N&atilde;o foi poss&iacute;vel gravar os dados.");	 	
					}
				})
				.fail(function(data) {
					Mensagem(erro,"N&atilde;o foi poss&iacute;vel gravar os dados.");	 	
				});
			}
		});

		$( "#cadastrarTipo" ).click(function() {
			var URLAJAX = "minhaquadra/quadra/cadastrar/tipo";
			var codTipo = $("input[name*='tipo_codigo']").val();
			var descricao = $("input[name*='tipo_descricao']").val();
			$(".statusTipo").addClass("hide");
			
			if(descricao == ""){
				MensagemTipo(erro,"Preencha o tipo.");	
				$("input[name*='tipo']").focus();
				return false;
			
			}else{ 
			    $.ajax({
				    url: URLAJAX,
				    type: "PUT",
				    async: false,//!IMPORTANT incluir async:false
				    data: {"codTipo":codTipo, "descricao":descricao},
				    dataType: "json"
			    })
			    .done(function(data) {
					if(data==1){
						//MensagemTipo(sucesso, "Dados gravados com sucesso.");
						//atualiza o outro combo com os tipos
						$("select[name='tipo_quadra']").append("<option selected>"+descricao+"<option>");
					}else{
						MensagemTipo(erro, "N&atilde;o foi poss&iacute;vel gravar os dados.");
					}
				})
				.fail(function(data) {
					MensagemTipo(erro, "N&atilde;o foi poss&iacute;vel gravar os dados.");
				});
			}
		});

		function MensagemTipo(codigo, texto){
			if (codigo==sucesso){
				$(".statusTipo").addClass("callout-success");
				$(".statusTipo").removeClass("callout-danger");
			}else{
				$(".statusTipo").addClass("callout-danger");
				$(".statusTipo").removeClass("callout-success");
			}
			
			$(".statusTipo").removeClass("hide");
			$(".statusTipo p").html(texto);
		}
	</script>
