<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri = "http://java.sun.com/jsp/jstl/functions"%>

<jsp:include page="main/header.jsp" />
<jsp:include page="main/menu-esquerdo.jsp" />

<%-- CONTEUDO CENTRAL --%>
<div class="content-wrapper">
	<section class="content-header">
		<h1>
			Reservas de Associados <small> Cadastro e edi&ccedil;&atilde;o</small>
		</h1>
		<ol class="breadcrumb">
			<li><a href="#"><i class="fa fa-dashboard"></i>Rela&ccedil;&atilde;o para Associados</a></li>
			<li>Reservas</li>
			<li class="active">Associados</li>
		</ol>
	</section>

	<section class="content">

		<div class="row">

		<div class="col-xl-3 col-lg-5 col-md-12">
			<div class="box box-solid box-info">
				<div class="box-header text-center">
					<h3 class="box-title">Atualizar Reservas para Associados</h3>
				</div>

	            <form action="#" method="post">
					<div class="box-body">

					<div class="row">

						<div class="col-md-12">
							<div class="col-md-3 form-group">
								<label>Cd:</label>
								<input disabled="disabled" type="text" class="form-control" name="codReserva" placeholder="Novo"/>
							</div>
							<div class="col-md-3 form-group">
								<label>Matr&iacute;cula:</label>
								<input type="text" class="form-control" id="matricula" title="R-1010" name="matricula" placeholder="Matr&iacute;cula" onblur="BuscarNome()"/>
							</div>
							<div class="col-md-6 form-group">
								<label>Nome do associado:</label>
								<input disabled="disabled" type="text" class="form-control" name="nome" placeholder="Nome"/>
							</div>
						</div>

						<div class="col-md-12">
							<%-- CAMPO DATA ESTA DESABILITADO, REMOVER FUTURAMENTE --%>
							<div class="col-lg-4 form-group hide">
								<label>Selecione o per&iacute;odo:</label>
								<div class="input-group">
									<input type="text" class="form-control pull-right" id="datacombopicker">
									<div class="input-group-addon showdatacombopicker">
										<i class="fa fa-calendar"></i>
									</div>
								</div>
							</div>
							<div class="col-lg-6 form-group">
							  <div class="bootstrap-timepicker">
								  <label>In&iacute;cio &aacute;s:</label>
								  <div class="input-group">
									<input type="text" name="timepickerInicial" class="form-control timepicker">
									<div class="input-group-addon showtimepicker">
									  <i class="fa fa-clock-o"></i>
									</div>
								  </div>
							  </div>
							</div>
							<div class="col-lg-6 form-group">
							  	<div class="bootstrap-timepicker">
								  <label>T&eacute;rmino &aacute;s:</label>
								  <div class="input-group">
									<input type="text" name="timepickerFinal" class="form-control timepicker">
									<div class="input-group-addon showtimepicker">
									  <i class="fa fa-clock-o"></i>
									</div>
								  </div>
								</div>
							</div>
						</div>
						
						<div class="col-md-12">
							<div class="col-md-6 form-group">
								<label>Tipo de Quadra: </label>
								<select class="form-control select2" name="tipo_quadra" data-placeholder="Selecione o tipo">
							    	<c:forEach var="tiposquadras" items="${tiposquadras}">
							    		<option>${tiposquadras.descricao}</option>
							    	</c:forEach>
								</select>
							</div>
							<div class="col-md-6 form-group">
								 <label>Quadra dispon&iacute;veis: </label>
								<select class="form-control select2" name="quadras" multiple="multiple" data-placeholder="Selecione as quadras">

								</select>
							</div>
						</div>
	
					</div><!-- .row -->
				</div><!-- .box -->
	
				<div class="box-footer">
					<div class="col-md-12">
						<input type="reset" class="btn btn-default" value="Limpar"/>
						<input type="submit" id="cadastrar" class="btn btn-info pull-right" value="Salvar" /><!-- onclick="gravar_dados()" !-->
					</div>
				</div>
	
	            </form>
	
		        <div class="hide statusMessage callout">
					<p></p>
		        </div>
		        <!--<div class="hide statusMessage callout callout-warning">
					<p></p>
		        </div>
		       <div class="hide statusMessage callout callout-info">
		          <p></p>
		        </div>
		        <div class="hide statusMessage callout callout-success">
					<p></p>
		        </div>!-->

			</div>
		</div>


		<%-- TABELAS DE LISTAGEM --%>
		<div class="col-xl-9 col-lg-7 col-md-12">

<%--
		<div class="box box-info">
			<div class="box-header text-center">
				<h3 class="box-title">Rela&ccedil;&atilde;o dos Associados.</h3>
			</div>
			<div class="box-body">
				<table id="tabelaAssociadosDadosPessoais" class="table table-bordered table-striped">

					<thead>
						<tr>
							<th>#</th>
							<th>Cat</th>
							<th>Matr&iacute;cula</th>
							<th>Dep</th>
							<th>Nome</th>
							<th>Sobrenome</th>
							<th>Celular</th>
							<th>Aç&otilde;es</th>
						</tr>
					</thead>
					<tbody>
						<c:forEach var="associados" items="${associados}">
							<tr>
								<td class="text-center">${associados.codAssociado}</td>
								<td>${associados.categoria}</td>
								<td>${associados.matricula}</td>
								<td>${associados.numDependentes}</td>
								<td>${associados.nome}</td>
								<td>${associados.sobrenome}</td>
								<td>${associados.celular}</td>
								<td>
									<div class="btn-group">
										<div class="col text-center align-self-center">
											BOTAO ADICIONAR
											<button type="button" onclick="editar_conteudo('${associados.matricula}',
																							'${associados.nome}')"
												class="editar_conteudo btn btn-default btn-md">
												<i class="fa fa-edit"></i>
											</button>
											BOTAO EXCLUIR
											<button type="button" onclick="excluir_associado'${associados.codAssociado}')" class="excluir_associado btn btn-default btn-md"><i class="fa fa-trash-o"></i></button>
										</div>
									</div>
								</td>
							</tr>
						</c:forEach>
					</tbody>
				</table>
			</div>
		</div>
 --%>
 	
		<!-- LISTAGEM DAS RESERVAS -->
		<div class="box box-info">
			<div class="box-header text-center">
				<h3 class="box-title">Reservas para Associados</h3>
			</div>
			<!-- /.box-header -->
			<div class="box-body">
				<table id="tabelaReservasAssociados" class="table table-bordered table-striped">
					<thead>
						<tr>
							<th>Cd</th>
							<th>Mat</th>
							<th>Associado</th>
							<th>Tipo</th>
							<th>Quadra</th>
							<th class='hide'>In&iacute;cio</th>
							<th class='hide'>Fim</th>
							<th>In&iacute;cio</th>
							<th>Fim</th>
							<th>Aes</th>
						</tr>
					</thead>
					<tbody>
						<c:forEach var="reservas" items="${reservas}">
						<tr>
							
							<td class="text-center">${reservas.codReserva}</td>
							<td>${reservas.associados.matricula}</td>
							<td>${reservas.associados.nome}</td>

							<td>
								<c:set var="campoEsporte" value="" />
								<c:forEach var="quadras" items="${reservas.quadras}">
									<c:set var="campoEsporte" value="${quadras.esporte};${campoEsporte}" />
								</c:forEach>
								<%-- ASSUMIMOS QUE AS QUADRAS DEVEM SER DO MESMO TIPO --%>
								<c:out value="${reservas.quadras[0].esporte}" />
								<%-- RESET O CAMPO PARA EDITAR CONTEUDO --%>								
								<c:set var="campoEsporte" value="${reservas.quadras[0].esporte}" />
							</td>
							<td>
								<c:set var="campoCodQuadras" value="" />
								<c:forEach var="quadras" items="${reservas.quadras}">
									<c:set var="campoCodQuadras" value="${campoCodQuadras};${quadras.codQuadra}" />
								</c:forEach>
								<c:out value="${fn:replace(campoCodQuadras, ';', ' ')}" />
							</td>
							
							<fmt:formatDate type="date" pattern="dd/MM/yyyy" value="${reservas.dataInicial}" var="campoDataI" />
							<td class='hide'><c:out value="${campoDataI}"/></td>
							<fmt:formatDate type="date" pattern="dd/MM/yyyy" value="${reservas.dataFinal}" var="campoDataF" />
							<td class='hide'><c:out value="${campoDataF}"/></td>
							<td>
								<fmt:formatDate type="time" pattern="HH:mm" value="${reservas.horaInicial}" />
							</td>
							<td>
								<fmt:formatDate type="time" pattern="HH:mm" value="${reservas.horaFinal}" />
							</td>
							<td>
								<div class="btn-group">
									<div class="col text-center align-self-center">
										<button type="button" onclick="editar_reservas('${reservas.codReserva}',
																						'${reservas.associados.matricula}',
																						'${reservas.associados.nome}',
																						'${campoDataI}',
																						'${campoDataF}',
																						'${reservas.horaInicial}',
																						'${reservas.horaFinal}',
																						'${campoCodQuadras}',
																						'${campoEsporte}')"
											class="editar_reservas btn btn-default btn-sm">
											<i class="fa fa-edit"></i>
										</button>
										<button type="button" onclick="excluir_registro(this, '${reservas.codReserva}')" class="btn btn-default btn-sm excluir_registro"><i class="fa fa-trash-o"></i></button>
									</div>
								</div>
							</td>
							
						</tr>
						</c:forEach>
					</tbody>
				</table>
			</div>
		</div>
			
	</div><%-- TABELAS DE LISTAGEM --%>

	</div>


</section>
</div>


<%-- CARREGAR PRIMEIRO O FOOTER, PARA TER ACESSO AO JQUERY E DEMAIS PLUGINS --%>
<jsp:include page="main/footer.jsp" />

<%-- PLUGINS UTILIZADOS SOMENTE PARA ESTA PAGINA --%>
	<script src="${pageContext.request.contextPath}/plugins/daterangepicker/moment.js"></script>
	<script src="${pageContext.request.contextPath}/plugins/daterangepicker/daterangepicker.js"></script>
	<%-- <script src="${pageContext.request.contextPath}/plugins/datepicker/bootstrap-datepicker.js"></script> --%>
	<script src="${pageContext.request.contextPath}/plugins/timepicker/bootstrap-timepicker.min.js"></script>

<%-- Page script --%>
	<script type="text/javascript">
		$(function() {
			//Initialize Select2 Elements
			$(".select2").select2();

			//Flat GREEN color scheme for iCheck
			$('input[type="checkbox"].iCheck, input[type="radio"].iCheck').iCheck({
				checkboxClass : 'icheckbox_flat-green', radioClass : 'iradio_flat-green'
			});
			
			//Cannot read property 'mData' of undefined - http://stackoverflow.com/questions/25377637/datatables-cannot-read-property-mdata-of-undefined
			$("#tabelaAssociadosDadosPessoais").DataTable();
			$("#tabelaReservasAssociados").DataTable();
		});

		//http://www.daterangepicker.com/
		$(function () {
			//Date range picker
			$('#datacombopicker').daterangepicker({
				timePicker: false,
				timePickerIncrement: 15, locale:{format: 'DD/MM/YYYY'},
				opens: 'right',
				}, function(start, end, label) {
					//console.log('Nova data selecionada: ' + start.format('DD/MM/YYYY') + ' a ' + end.format('DD/MM/YYYY') );
				}
			);
				$('.showdatacombopicker').click(function(){
					$(this).prev().click();
				});


			//https://jdewit.github.io/bootstrap-timepicker/
			$(".timepicker").timepicker({
				showInputs: false,
				showMeridian: false,//24HS
				minuteStep: 15
			});
				$('.showtimepicker').click(function(){
					$(this).prev().click();
				});
		});
		
		$(function () {
			$("input[name*='matricula']").mask('A-9999');
			
			$("form").bind("reset", function(e){e.preventDefault();
				$("input[name*='codReserva']").val("");
				$("input[name*='matricula']").val("");
				$("input[name*='nome']").val("");
				$("input[name*='matricula']").val("");
				$("select[name*='quadras']").val("").trigger("change");
				$("select[name='tipo_quadra']").val("").trigger("change");
				$("input[name='timepickerInicial']").data("timepicker").setTime("00:00");
				$("input[name='timepickerFinal']").data("timepicker").setTime("00:00");
				
				var today = new Date();
				var dd = today.getDate();
				var mm = today.getMonth()+1; //January is 0!
				var yyyy = today.getFullYear();
					$('#datacombopicker').data('daterangepicker').setStartDate(dd+"/"+mm+"/"+yyyy);
					$('#datacombopicker').data('daterangepicker').setEndDate(dd+"/"+mm+"/"+yyyy);
					
				$("select[name='tipo_quadra']").removeAttr('disabled');
				$("select[name='quadras']").removeAttr('disabled');
					
				atualizarMensagens(-1);
			});
		});

		$(document).ready(function() {
			$(".dataTables_filter").append("<input type='button' value='Atualizar' class='btn btn-info pull-right' />");
			$( "input[value*='Atualizar']" ).click(function() {
				location.href = "reservas_associados";
			});
		});
	</script>

	<%-- MENSAGEM DE SUCESSO OU FALHA --%>
	<script type="text/javascript">
		function atualizarMensagens(okAjaxRetorno){
			var statusMessage = okAjaxRetorno;
			$(".statusMessage").addClass("hide");

			if(statusMessage>=1){
				Mensagem(sucesso, "Dados processados com sucesso.");
				//$(".statusMessage.callout-success").removeClass("hide");
				//$(".statusMessage.callout-success p").html("Dados processados com sucesso.");
			}else if(statusMessage==0){
				Mensagem(erro, "N&atilde;o foi poss&iacute;vel processar a informa&ccedil;&atilde;o.");
				//$(".statusMessage.callout-warning").removeClass("hide");
				//$(".statusMessage.callout-warning p").html("N&atilde;o foi poss&iacute;vel processar a informa&ccedil;&atilde;o.");

			}else{
				//ERRO -1 TRATAR DIRETO NAS NO FAIL DO AJAX, MOSTRANDO UMA MENSAGEM CUSTOMIZADA
			}
		}
	</script>

	<%-- PESQUISAR --%>
	<script type="text/javascript">
	
		$(document).ready(function() {
			//https://select2.github.io/examples.html#events
			$("select[name='tipo_quadra']").val("").trigger("change");
			var $eventSelect = $("select[name*='tipo_quadra']");
			$eventSelect.on("change", function (e) {
				if($eventSelect.val()!=null && $eventSelect.val()!="")
					pesquisar_quadras($eventSelect.val());	
			});
		});
	
		function pesquisar_quadras(esporte){

			$(".statusMessage").addClass("hide");
			
			//var esporteQuadra = $("select[name='tipo_quadra']").select2("val");
			var horaInicial = $("input[name='timepickerInicial']").data("timepicker").getTime();
			var horaFinal = $("input[name='timepickerFinal']").data("timepicker").getTime();
			
			var URLAJAX = "minhaquadra/quadra/buscar/esporte/hora";
		    $.ajax({
			    url: URLAJAX,//VIA GET PASSAR NA URL O PARAMETRO
			    type: "POST",
			    async: false,//!IMPORTANT incluir async:false
			    data: {
			    	"esporte": ""+esporte,
			    	"horaInicial": ""+horaInicial,
			    	"horaFinal": ""+horaFinal
		    		}
		    })
		    .done(function(data) {
		    	if(data!='undefined'){
		    		var listaQuadras = data.split(";");
				    var found = 0;
		    		$("select[name*='quadras']").html("");
				    for (var i = 0, j = 0, len = listaQuadras.length; i < len; i+=3) {
				    	if(listaQuadras[i].length > 0){
				    		var CODIGO = i;
				    		var NOME = i+1;
				    		var STATUS = i+2;
				    		var indiceOf = listaQuadras[STATUS].search("Dispon");//-1 nao encontrou
				    		if(indiceOf>-1){
				    			found = 1;
					    		$("select[name*='quadras']").append("<option value='"+listaQuadras[CODIGO]+"'>"+listaQuadras[CODIGO]+"-"+listaQuadras[STATUS]+"</option>");
					    		$("select[name*='quadras']").trigger('change');
				    		}
				    		else{
					    		$("select[name*='quadras']").append("<option value='"+listaQuadras[CODIGO]+"' disabled='disabled'>"+listaQuadras[CODIGO]+"-"+listaQuadras[STATUS]+"</option>");
				    		}
				    	} 
		    		}
					if(found == 0){
						atualizarMensagens(-1);
						//$(".statusMessage.callout-warning").addClass("hide");
						//$(".statusMessage.callout-warning p").html("Somente foram encontradas quadras fechadas para este tipo.");					
					}else{
						atualizarMensagens(-1);
						Mensagem(sucesso, "Selecione as quadras dispon&iacute;veis.");
					}
				}
				//atualizarMensagens(1)
			})
			.fail(function(data) {
				$("select[name*='quadras'] option").html("");
				$("select[name*='quadras']").val("").trigger('change');
				atualizarMensagens(-1);
				//$(".statusMessage.callout-warning").removeClass("hide");
				Mensagem(sucesso, "N&atilde;o existem quadras cadastradas para este tipo.");
			});
		}
	</script>
	
	<%-- EXCLUIR --%>
	<script type="text/javascript">
		function excluir_associado(codAssociado){

			var URLAJAX = "minhaquadra/reservas/excluir/associado";
			$(".statusMessage").addClass("hide");

		    $.ajax({
			    url: URLAJAX,
			    type: "DELETE",
			    async: false,//!IMPORTANT incluir async:false
			    data: {"codAssociado":codAssociado}
		    })
		    .done(function(data) {
				atualizarMensagens(1)
			})
			.fail(function(data) {
				atualizarMensagens(-1);
			});
		}
		function excluir_registro(event, codReserva){

			var URLAJAX = "minhaquadra/reservas/excluir/registro";
			$(".statusMessage").addClass("hide");

		    $.ajax({
			    url: URLAJAX,
			    type: "DELETE",
			    async: false,//!IMPORTANT incluir async:false
			    data: {"codReserva":codReserva}
		    })
		    .done(function(data) {
				atualizarMensagens(1);
		    	//REMOVER VIA AJAX DINAMICAMENTE O CONTEUDO DA TABELA
	    		var table = $('#tabelaReservasAssociados').DataTable();
	    	    var linha = $(event).parents('tr');
	    	    table.row( linha ).remove().draw();	
	    	    return false;
			})
			.fail(function(data) {
				atualizarMensagens(0);
			});
		}
	</script>

	<%-- EDITAR --%>
	<script type="text/javascript">
	
	
		function editar_reservas(
				COD,
				MAT,
				NOM,
				DTI,
				DTF,
				HOI,
				HOF,
				QUA,
				TIP
				){
			$("form").trigger("reset");//simula o click no button='reset'
			
			$("input[name*='codReserva']").val(COD);
			$("input[name*='matricula']").val(MAT);
			$("input[name*='nome']").val(NOM);
			$('#datacombopicker').data('daterangepicker').setStartDate(DTI);
			$('#datacombopicker').data('daterangepicker').setEndDate(DTF);
			$("input[name='timepickerInicial']").data("timepicker").setTime(HOI);
			$("input[name='timepickerFinal']").data("timepicker").setTime(HOF);
			$("select[name='tipo_quadra']").val(TIP).trigger("change");

			var arrayQuadras = QUA.split(";");
			arrayQuadras.shift();//REMOVE O PRIMEIRO ELEMENTO VAZIO
			$("select[name='quadras']").val(arrayQuadras).trigger("change");
			
			//$("select[name='tipo_quadra']").attr('disabled','disabled');
			//$("select[name='quadras']").attr('disabled','disabled');
			
			atualizarMensagens(-1);//REMOVE AS MSG DE TELA
		}
	
	
		function editar_conteudo(
				MAT,
				NOM
			){
			
			$("form").trigger("reset");//simula o click no button='reset'
			
			//seta os campos
			$("input[name*='nome']").val(NOM);
			$("input[name*='matricula']").val(MAT);

		}
	</script>
	
	<%-- GRAVAR OU ATUALIZAR --%>
	<script type="text/javascript">
		$("#cadastrar").click(function(){
			//function gravar_dados(){
				
			var codReserva = $("input[name*='codReserva']").val();//PK
			var codTipoReserva = 0;//pegar futuramente do codigo da reserva

			var nome = $("input[name*='nome']").val();
			var matricula = $("input[name*='matricula']").val();
			var numMatricula = $("input[name*='matricula']").attr("title");

			var dataInicial = $("#datacombopicker").data('daterangepicker').startDate.format('DD/MM/YYYY');
			var dataFinal = $("#datacombopicker").data('daterangepicker').endDate.format('DD/MM/YYYY');
			var horaInicial = $("input[name='timepickerInicial']").data("timepicker").getTime();
			var horaFinal = $("input[name='timepickerFinal']").data("timepicker").getTime();

			var quadras = $("select[name='quadras']").select2("val");//(3) ["1", "2", "3"]
			var tipo_quadra = $("select[name='tipo_quadra']").select2("val");

			var okhora = isHoraInicialMenorHoraFinal(horaInicial, horaFinal);
			
			if(matricula.length <= 1){
				Mensagem(erro, "Preencha a matricula.");
				$("input[name*='matricula']").focus();
				return false;
			}
			else if(okhora == false){
				Mensagem(erro, "Hora Inicial deve ser vir antes da Hora Final");
				$("input[name='timepickerInicial']").focus();
				return false;
			}
			else if(quadras == null){
				Mensagem(erro, "Escolha as quadras participantes");
				if($("select[name='tipo_quadra']").select2("val") == null){
					$("select[name='tipo_quadra']").select2('open');
				}else{
					$("select[name='quadras']").select2('open');					
				}				
				return false;				
			}else{

				var tipoReserva = 'A';
				var URLAJAX = "minhaquadra/reservas/cadastrar/associado";
			    $.ajax({
				    url: URLAJAX,
				    type: "PUT",
				    async: false,//!IMPORTANT incluir async:false
				    data: { "codReserva":codReserva,
				    	"tipoReserva":tipoReserva,
				    	"codTipoReserva":codTipoReserva,
				    	"dataInicial":dataInicial,
				    	"dataFinal":dataFinal,
				    	"horaInicial":horaInicial,
				    	"horaFinal":horaFinal,
				    	"quadras":""+quadras,
				    	"tipo_quadra":""+tipo_quadra,
				    	"nome":nome,
				    	"matricula":numMatricula
			    		}
		    	})
			    .done(function(data) {
					//atualizarMensagens(data);
				})
				.fail(function(data) {
					atualizarMensagens(-1);
				});
			    
			}
			
		});
	</script>
	
	<script>
		function BuscarNome(){
			var URLAJAX = "minhaquadra/reservas/buscar/associado";

			var matricula = $("input[name*='matricula']").val();
			
		    $.ajax({
			    url: URLAJAX,
			    type: "PUT",
			    async: false,//!IMPORTANT incluir async:false
			    data: {"matricula":matricula}
	    	})
		    .done(function(data) {
		    	$("input[name*='nome']").val(data.nome);
		    	$("input[name*='matricula']").attr("title", data.matricula);//Moca o numero de matricula, sem a letra
			})
			.fail(function(data) {
				$("input[name*='nome']").val("Invlida");
			});
		}
	
		function isHoraInicialMenorHoraFinal(horaInicial, horaFinal)
		{ 
			horaIni = horaInicial.split(':'); horaFim = horaFinal.split(':'); 
			
			// Verifica as horas. Se forem diferentes,  s ver se a inicial 
			//  menor que a final. 
			hIni = parseInt(horaIni[0], 10); 
			hFim = parseInt(horaFim[0], 10); 
			if(hIni != hFim) 
				return hIni < hFim; 
			
			// Se as horas so iguais, verifica os minutos ento. 
			mIni = parseInt(horaIni[1], 10); 
			mFim = parseInt(horaFim[1], 10); 
			if(mIni != mFim) 
				return mIni < mFim; 
		}
	</script>