<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri = "http://java.sun.com/jsp/jstl/functions"%>

<jsp:include page="main/header.jsp" />
<jsp:include page="main/menu-esquerdo.jsp" />

<%-- CONTEUDO CENTRAL --%>
<div class="content-wrapper">
	<section class="content-header">
		<h1>
			Reservas de escolinhas <small> Cadastro e edi&ccedil;&atilde;o</small>
		</h1>
		<ol class="breadcrumb">
			<li><a href="#"><i class="fa fa-dashboard"></i>Rela&ccedil;&atilde;o das Escolinhas</a></li>
			<li>Reservas</li>
			<li class="active">Escolinhas</li>
		</ol>
	</section>

	<section class="content">

		<div class="row">

			<div class="col-xl-3 col-lg-5 col-md-12">
				<div class="box box-solid box-info">
					<div class="box-header text-center">
						<h3 class="box-title">Atualizar reservas de escolinhas</h3>
					</div>

            <form action="#" method="post">
				<div class="box-body">

						<div class="col-sm-12">
							<div class="col-sm-3 form-group">
								<label>C&oacute;d:</label>
								<input disabled="disabled" type="text" class="form-control" name="codReserva" placeholder="Novo"/>
							</div>
							
							<div class="col-sm-9 form-group">
									<label for="descricao" class=" control-label">T&iacute;tulo do evento</label>
									<input type="text" class="form-control" name="descricao" placeholder="Descri&ccedil;&atilde;o">
							</div>
						</div>

						<div class="col-sm-12">
							<div class="col-sm-12 form-group">
								<label>Selecione o per&iacute;odo:</label>
								<div class="input-group">
									<input type="text" class="form-control pull-right" id="datacombopicker">
									<div class="input-group-addon showdatacombopicker">
										<i class="fa fa-calendar"></i>
									</div>
								</div>
							</div>
						</div>

						<div class="col-sm-12">
							<!-- time Picker -->
							<div class="col-sm-6 form-group">
							  <div class="bootstrap-timepicker">
								  <label>In&iacute;cio &aacute;s:</label>

								  <div class="input-group">
									<input type="text" name="timepickerInicial" class="form-control timepicker">

									<div class="input-group-addon showtimepicker">
									  <i class="fa fa-clock-o"></i>
									</div>
								  </div>
							  </div>
							</div>
													
							<div class="col-sm-6 form-group">
							  <div class="bootstrap-timepicker">
								  <label>T&eacute;rmino &aacute;s:</label>

									  <div class="input-group">
										<input type="text" name="timepickerFinal" class="form-control timepicker">
	
										<div class="input-group-addon showtimepicker">
										  <i class="fa fa-clock-o"></i>
										</div>
									</div>
							  </div>
							</div>
						</div>

						
						<div class="col-sm-12">
							<div class="col-sm-6 form-group">
								<label>Tipo de Quadra: </label>
								<select class="form-control select2" name="tipo_quadra" data-placeholder="Selecione o tipo">
							    	<c:forEach var="tiposquadras" items="${tiposquadras}">
							    		<option>${tiposquadras.descricao}</option>
							    	</c:forEach>
								</select>
							</div>
							<div class="col-sm-6 form-group">
								 <label>Quadra dispon&iacute;veis: </label>
								<select class="form-control select2" name="quadras" multiple="multiple" data-placeholder="Selecione as quadras">

								</select>
							</div>
						</div>
						
						<div class="col-sm-12">
							<div class="col-sm-12 form-group">
								<label>Selecione os dias necess&aacute;rios</label>
									<!-- SE FOR COLOCAR ACENTUACAO HTML ENTITIES, MODIFICAR O VALUE E MODIFICAR O JAVASCRIPT !-->
									<select class="form-control select2" name="dias_semana"  multiple="multiple" data-placeholder="Selecione v&aacute;rios dias abaixo." style="width: 100%;">
									<option>Domingo</option>
									<option>Segunda</option>
									<option>Tera</option>
									<option>Quarta</option>
									<option>Quinta</option>
									<option>Sexta</option>
									<option>Sbado</option>
								</select>
							</div>
						</div>

				</div>

				<div class="box-footer">
					<div class="col-sm-12">
						<input type="reset" class="btn btn-default" value="Limpar"/>
						<input type="submit" id="cadastrar" class="btn btn-info pull-right" value="Salvar" /><!-- onclick="gravar_dados()" !-->
					</div>
				</div>

            </form>

		        <div class="hide statusMessage callout">
					<p></p>
		        </div>
		        <!--<div class="hide statusMessage callout callout-warning">
					<p></p>
		        </div>
		       <div class="hide statusMessage callout callout-info">
		          <p></p>
		        </div>
		        <div class="hide statusMessage callout callout-success">
					<p></p>
		        </div>-->

			</div>
		</div>


		<!-- LISTAGEM DE QUADRAS -->
		<div class="col-xl-9 col-lg-7 col-md-12">

			<div class="box box-info">
				<div class="box-header text-center">
					<h3 class="box-title">Rela&ccedil;&atilde;o das Escolinhas.</h3>
				</div>
				<!-- /.box-header -->
				<div class="box-body">
					<table id="tabela1" class="table table-bordered table-striped">

						<thead>
							<tr>
								<th>C&oacute;d</th>
								<th>T&iacute;tulo</th>
								<th>Quadra</th>
								<th>In&iacute;cio</th>
								<th>Fim</th>
								<th>Hor&aacute;rio</th>
								<th>Semana</th>
								<th>A&ccedil;&otilde;es</th>
							</tr>
						</thead>

						<tbody>
							<c:forEach var="reservas" items="${reservas}">
								<tr>
									<td class="text-center">${reservas.codReserva}</td>
									<td>${reservas.escolinha.descricao}</td><%-- campo da tabela escolinha --%>
									<!--  <td>${reservas.tipoReserva}</td> !-->
									<td>
										<c:set var="campoCodQuadras" value="" />
										<c:forEach var="quadras" items="${reservas.quadras}">
											<c:set var="campoCodQuadras" value="${campoCodQuadras};${quadras.codQuadra}" />
										</c:forEach>
										<c:out value="${fn:replace(campoCodQuadras, ';', ' ')}" />
									</td>
									<fmt:formatDate type="date" pattern="dd/MM/yyyy" value="${reservas.dataInicial}" var="campoDataI" />
									<td><c:out value="${campoDataI}"/></td>
									<fmt:formatDate type="date" pattern="dd/MM/yyyy" value="${reservas.dataFinal}" var="campoDataF" />
									<td><c:out value="${campoDataF}"/></td>
									<td><fmt:formatDate type="time" pattern="HH:mm" value="${reservas.horaInicial}" /> &aacute;
										<fmt:formatDate type="time" pattern="HH:mm" value="${reservas.horaFinal}" />
									</td>
									<td>
											<c:set var="DO" value="0"/>
											<c:set var="SE" value="0"/>
											<c:set var="TE" value="0"/>
											<c:set var="QA" value="0"/>
											<c:set var="QI" value="0"/>
											<c:set var="SE" value="0"/>
											<c:set var="SA" value="0"/>
											<c:if test="${reservas.escolinha.dom=='true'}">DOM <c:set var="DO" value="1"/></c:if>
											<c:if test="${reservas.escolinha.seg=='true'}">SEG <c:set var="SE" value="1"/></c:if>
											<c:if test="${reservas.escolinha.ter=='true'}">TER <c:set var="TE" value="1"/></c:if>
											<c:if test="${reservas.escolinha.qua=='true'}">QUA <c:set var="QA" value="1"/></c:if>
											<c:if test="${reservas.escolinha.qui=='true'}">QUI <c:set var="QI" value="1"/></c:if>
											<c:if test="${reservas.escolinha.sex=='true'}">SEX <c:set var="SE" value="1"/></c:if>
											<c:if test="${reservas.escolinha.sab=='true'}">SAB <c:set var="SA" value="1"/></c:if>
											<c:set var="semana" value="[${DO}, ${SE}, ${TE}, ${QA}, ${QI}, ${SE}, ${SA}]"/>
									</td>
									<td>
										<div class="acoesBtn btn-group">
											<div class="col text-center align-self-center">
												<!-- function editar_conteudo(desc,dataI,dataF,horaI,horaF,semI,semF,codQ){-->
												<button type="button" onclick="editar_conteudo('${reservas.codReserva}','${reservas.escolinha.descricao}','${campoDataI}','${campoDataF}','${reservas.horaInicial}','${reservas.horaFinal}', '${campoCodQuadras}', ${semana})"
													class="editar_conteudo btn btn-default btn-sm">
													<i class="fa fa-edit"></i>
												</button>
												<button type="button" onclick="excluir_registro(this, ${reservas.codReserva})" class="excluir_registro btn btn-default btn-sm"><i class="fa fa-trash-o"></i></button>
											</div>
										</div>
									</td>
								</tr>
							</c:forEach>
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>

</section>
</div>


<%-- CARREGAR PRIMEIRO O FOOTER, PARA TER ACESSO AO JQUERY E DEMAIS PLUGINS --%>
<jsp:include page="main/footer.jsp" />

<%-- PLUGINS UTILIZADOS SOMENTE PARA ESTA PAGINA --%>
	<script src="${pageContext.request.contextPath}/plugins/daterangepicker/moment.js"></script>
	<script src="${pageContext.request.contextPath}/plugins/daterangepicker/daterangepicker.js"></script>
	<%-- <script src="${pageContext.request.contextPath}/plugins/datepicker/bootstrap-datepicker.js"></script> --%>
	<script src="${pageContext.request.contextPath}/plugins/timepicker/bootstrap-timepicker.min.js"></script>

<%-- Page script --%>
	<script type="text/javascript">

		$(function() {
			//Initialize Select2 Elements
			$(".select2").select2();

			//iCheck for checkbox and radio inputs
			$('input[type="checkbox"].minimal, input[type="radio"].minimal').iCheck({checkboxClass : 'icheckbox_minimal-blue', radioClass : 'iradio_minimal-blue'});
			//Red color scheme for iCheck
			$('input[type="checkbox"].minimal-red, input[type="radio"].minimal-red').iCheck({checkboxClass : 'icheckbox_minimal-red',radioClass : 'iradio_minimal-red'});
			//Flat red color scheme for iCheck
			$('input[type="checkbox"].flat-red, input[type="radio"].flat-red').iCheck({checkboxClass : 'icheckbox_flat-green',radioClass : 'iradio_flat-green'});
		});

		$("#tabela1").DataTable();

		//http://www.daterangepicker.com/
		$(function () {
			//Date range picker
			$('#datacombopicker').daterangepicker({
				timePicker: false,
				timePickerIncrement: 15, locale:{format: 'DD/MM/YYYY'},
				opens: 'right',
				}, function(start, end, label) {
					//console.log('Nova data selecionada: ' + start.format('DD/MM/YYYY') + ' a ' + end.format('DD/MM/YYYY') );
				}
			);
				$('.showdatacombopicker').click(function(){
					$(this).prev().click();
				});


			//https://jdewit.github.io/bootstrap-timepicker/
			$(".timepicker").timepicker({
				showInputs: false,
				showMeridian: false,//24HS
				minuteStep: 15
			});
				$('.showtimepicker').click(function(){
					$(this).prev().click();
				});
		});

		$(function () {
			$("form").bind("reset", function(e){
				e.preventDefault();
				$("input[name*='codReserva']").val("");
				$('#datacombopicker').data('daterangepicker').setStartDate(new Date());
				$('#datacombopicker').data('daterangepicker').setEndDate(new Date());
				$("select[name='dias_semana']").val("").trigger("change");
				$("select[name='tipo_quadra']").val("").trigger("change");
				$("input[name*='timepickerInicial']").timepicker('setTime', "");
				$("input[name*='timepickerFinal']").timepicker('setTime', "");
				$("input[name*='descricao']").val("");
				atualizarMensagens(-1);//No message
			});
		});

		$(document).ready(function() {
			$(".dataTables_filter").append("<input type='button' value='Atualizar' class='btn btn-info pull-right' />");
			$( "input[value*='Atualizar']" ).click(function() {
				location.href = "reservas_escolinha";
			});
		});
	</script>

	<%-- MENSAGEM DE SUCESSO OU FALHA --%>
	<script type="text/javascript">
		function atualizarMensagens(okAjaxRetorno){
			var statusMessage = okAjaxRetorno;
			$(".statusMessage").addClass("hide");
	
			if(statusMessage>=1){
				Mensagem(sucesso, "Dados processados com sucesso.");
				//$(".statusMessage.callout-success").removeClass("hide");
				//$(".statusMessage.callout-success p").html("Dados processados com sucesso.");
			}else if(statusMessage==0){
				Mensagem(erro, "N&atilde;o foi poss&iacute;vel processar a informa&ccedil;&atilde;o.");
				//$(".statusMessage.callout-warning").removeClass("hide");
				//$(".statusMessage.callout-warning p").html("N&atilde;o foi poss&iacute;vel processar a informa&ccedil;&atilde;o.");
	
			}else{
				//ERRO -1 TRATAR DIRETO NAS NO FAIL DO AJAX, MOSTRANDO UMA MENSAGEM CUSTOMIZADA
			}
		}
	</script>

	<%-- GRAVAR OU ATUALIZAR --%>
	<script type="text/javascript">
	
		$("#cadastrar").click(function(){
		//function gravar_dados(){
			//Reservas
			var codReserva = $("input[name*='codReserva']").val();//PK
			var dataInicial = $("#datacombopicker").data('daterangepicker').startDate.format('DD/MM/YYYY');
			var dataFinal = $("#datacombopicker").data('daterangepicker').endDate.format('DD/MM/YYYY');
			var horaInicial = $("input[name='timepickerInicial']").data("timepicker").getTime();
			var horaFinal = $("input[name='timepickerFinal']").data("timepicker").getTime();

			var descricao = $("input[name=descricao]").val();

			var codTipoReserva = 0;//pegar futuramente do codigo da reserva
			var quadras = $("select[name='quadras']").select2("val");//(3) ["1", "2", "3"]
			var dias_semana = $("select[name='dias_semana']").select2("val");//(5) ["Segunda", "Tera", "Quarta", "Quinta", "Sexta"]

			var okhora = isHoraInicialMenorHoraFinal(horaInicial, horaFinal);
			
			if(descricao.length <= 1){
				Mensagem(erro, "Preencha a descrio.");
				$("input[name=descricao]").focus();
				return false;
			}
			else if(okhora == false){
				Mensagem(erro, "Hora Inicial deve ser vir antes da Hora Final");
				$("input[name='timepickerInicial']").focus();
				return false;
			}
			else if(quadras == null){
				Mensagem(erro, "Escolha as quadras participantes");
				if($("select[name='tipo_quadra']").select2("val") == null){
					$("select[name='tipo_quadra']").select2('open');
				}else{
					$("select[name='quadras']").select2('open');					
				}				
				return false;				
			}else if(dias_semana == null){
				Mensagem(erro, "Escolha os dias da semana");
				$("select[name='dias_semana']").select2('open');
				return false;				
			}
			else{
				
				var tipoReserva = 'E';
				var URLAJAX = "minhaquadra/reservas/cadastrar/escolinha";
			    $.ajax({
				    url: URLAJAX,
				    type: "PUT",
				    async: false,//!IMPORTANT incluir async:false
				    data: {"descricao":descricao,
					    	"codReserva":codReserva,
					    	"tipoReserva":tipoReserva,
					    	"codTipoReserva":codTipoReserva,
					    	"dataInicial":dataInicial,
					    	"dataFinal":dataFinal,
					    	"horaInicial":horaInicial,
					    	"horaFinal":horaFinal,
					    	"quadras":""+quadras,
					    	"dias_semana": ""+dias_semana
					    	}
			    })
			    .done(function(data) {
			    	//Mensagem(sucesso, "Dados cadastrados com sucesso.");
				})
				.fail(function(data) {
					atualizarMensagens(-1);
				});
				
			}
			
		});
	</script>

	<%-- EXCLUIR --%>
	<script type="text/javascript">
		function excluir_registro(event, codReserva){

			var URLAJAX = "minhaquadra/reservas/excluir/registro";
			$(".statusMessage").addClass("hide");

		    $.ajax({
			    url: URLAJAX,
			    type: "DELETE",
			    async: false,//!IMPORTANT incluir async:false
			    data: {"codReserva":codReserva},
		    })
		    .done(function(data) {
		    	Mensagem(sucesso, "Dados exclu&iacute;dos com sucesso.");
		    	//https://datatables.net/reference/api/row().remove()
	    		var table = $('#tabela1').DataTable();
	    	    var linha = $(event).parents('tr');
	    	    table.row( linha ).remove().draw();
	    	    return false;
			})
			.fail(function(data) {
				atualizarMensagens(0);
			});
		}
	</script>

	<%-- EDITAR --%>
	<script type="text/javascript">
		function editar_conteudo(codReserva, desc,dataI,dataF,horaI,horaF,codQ, diassemana){

			$("input[name*='codReserva']").val(codReserva);
			
			var semana = new Array();
			semana = diassemana;
		    var days = ['Domingo','Segunda', 'Tera', 'Quarta', 'Quinta', 'Sexta', 'S&aacute;bado'];//0 a 6
		    var selectedValues2 = new Array();

		    for (var i = 0, j = 0, len = days.length; i < len; i++) {
		    	if(diassemana[i] == '1') {
			    	selectedValues2[j] = days[i];
		    		j++;
		    	}
		    }
			$("select[name='dias_semana']").val(selectedValues2).trigger("change");

			//lista de quadras
				var codQuadras = codQ.split(";");
				$("select[name='quadras']").val(codQuadras).trigger("change");
			//titulo ou descricao
				$("input[name*='descricao']").val(desc);
			//dia do mes
				$('#datacombopicker').data('daterangepicker').setStartDate(dataI);
				$('#datacombopicker').data('daterangepicker').setEndDate(dataF);
			//horario de inicio e fim
				$("input[name='timepickerInicial']").data("timepicker").setTime(horaI);
				$("input[name='timepickerFinal']").data("timepicker").setTime(horaF);
				
			//Desabilita o campo
				//$("input[name='descricao']").attr('disabled','disabled');
		}
	</script>


	<%-- PESQUISAR --%>
	<script type="text/javascript">
	
		$(document).ready(function() {
			//https://select2.github.io/examples.html#events
			$("select[name='tipo_quadra']").val("").trigger("change");
			var $eventSelect = $("select[name*='tipo_quadra']");
			$eventSelect.on("change", function (e) {
				if($eventSelect.val()!=null && $eventSelect.val()!="")
					pesquisar_quadras($eventSelect.val());	
			});
		});
	
		function pesquisar_quadras(esporte){

			$(".statusMessage").addClass("hide");
			
			var dataInicial = $("#datacombopicker").data('daterangepicker').startDate.format('DD/MM/YYYY');
			var dataFinal = $("#datacombopicker").data('daterangepicker').endDate.format('DD/MM/YYYY');
			var horaInicial = $("input[name='timepickerInicial']").data("timepicker").getTime();
			var horaFinal = $("input[name='timepickerFinal']").data("timepicker").getTime();
			
			var URLAJAX = "minhaquadra/quadra/buscar/esporte/data";
		    $.ajax({
			    url: URLAJAX,//VIA GET PASSAR NA URL O PARAMETRO
			    type: "POST",
			    async: false,//!IMPORTANT incluir async:false
			    data: {
			    	"esporte": ""+esporte,
			    	"dataInicial": ""+dataInicial,
			    	"dataFinal": ""+dataFinal,
			    	"horaInicial": ""+horaInicial,
			    	"horaFinal": ""+horaFinal
		    		}
		    })
		    .done(function(data) {
		    	if(data!='undefined'){
		    		var listaQuadras = data.split(";");
				    var found = 0;
		    		$("select[name*='quadras']").html("");
				    for (var i = 0, j = 0, len = listaQuadras.length; i < len; i+=3) {
				    	if(listaQuadras[i].length > 0){
				    		var CODIGO = i;
				    		var NOME = i+1;
				    		var STATUS = i+2;
				    		var indiceOf = listaQuadras[STATUS].search("Dispon");//-1 nao encontrou
				    		if(indiceOf>-1){
				    			found = 1;
					    		$("select[name*='quadras']").append("<option value='"+listaQuadras[CODIGO]+"'>"+listaQuadras[CODIGO]+"-"+listaQuadras[STATUS]+"</option>");
					    		$("select[name*='quadras']").trigger('change');
				    		}
				    		else{
					    		$("select[name*='quadras']").append("<option value='"+listaQuadras[CODIGO]+"' disabled='disabled'>"+listaQuadras[CODIGO]+"-"+listaQuadras[STATUS]+"</option>");
				    		}
				    	} 
		    		}
					if(found == 0){
						atualizarMensagens(-1);
						$(".statusMessage.callout-warning").removeClass("hide");
						$(".statusMessage.callout-warning p").html("Somente foram encontradas quadras fechadas para este tipo.");					
					}else{
						atualizarMensagens(-1);
						$(".statusMessage.callout-success").removeClass("hide");
						$(".statusMessage.callout-success p").html("Selecione as quadras dispon&iacute;veis.");
					}
				}
				//atualizarMensagens(1)
			})
			.fail(function(data) {
				$("select[name*='quadras'] option").html("");
				$("select[name*='quadras']").val("").trigger('change');
				atualizarMensagens(-1);
				$(".statusMessage.callout-warning").removeClass("hide");
				$(".statusMessage.callout-warning p").html("N&atilde;o existem quadras cadastradas para este tipo.");
			});
		}
	</script>	
	
	<script>
		function isHoraInicialMenorHoraFinal(horaInicial, horaFinal)
		{ 
			horaIni = horaInicial.split(':'); horaFim = horaFinal.split(':'); 
			
			// Verifica as horas. Se forem diferentes,  s ver se a inicial 
			//  menor que a final. 
			hIni = parseInt(horaIni[0], 10); 
			hFim = parseInt(horaFim[0], 10); 
			if(hIni != hFim) 
				return hIni < hFim; 
			
			// Se as horas so iguais, verifica os minutos ento. 
			mIni = parseInt(horaIni[1], 10); 
			mFim = parseInt(horaFim[1], 10); 
			if(mIni != mFim) 
				return mIni < mFim; 
		}
	</script>
	
	
	
	
	
	