﻿<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri = "http://java.sun.com/jsp/jstl/functions"%>

<jsp:include page="main/header.jsp" />
<jsp:include page="main/menu-esquerdo.jsp" />

<%-- CONTEUDO CENTRAL --%>
<div class="content-wrapper">
	<section class="content-header">
		<h1>
			Reservas de Torneios <small> Cadastro e edição</small>
		</h1>
		<ol class="breadcrumb">
			<li><a href="#"><i class="fa fa-dashboard"></i>Relação de Torneios</a></li>
			<li>Reservas</li>
			<li class="active">Torneios</li>
		</ol>
	</section>

	<section class="content">

		<div class="row">

		<div class="col-xl-3 col-lg-5 col-md-12">
			<div class="box box-solid box-info">
				<div class="box-header text-center">
					<h3 class="box-title">Atualizar reservas de Torneios</h3>
				</div>

	            <form action="#" method="post">
					<div class="box-body">
					
					<div class="col-sm-12">
						<div class="col-sm-3 form-group">
							<label>Cód:</label>
							<input disabled="disabled" type="text" class="form-control" name="codReserva" placeholder="Novo"/>
						</div>
							
						<div class="col-sm-9">
							<div class="form-group">
								<label for="descricao" class=" control-label">Título do evento</label>
								<input type="text" class="form-control" name="descricao" placeholder="Descrição">
							</div>
						</div>
					</div>
					
					<div class="col-sm-12">
						<div class="col-sm-12 form-group">
							<label>Selecione o período:</label>
							<div class="input-group">
								<input type="text" class="form-control pull-right" id="datacombopicker">
								<div class="input-group-addon showdatacombopicker">
									<i class="fa fa-calendar"></i>
								</div>
							</div>
						</div>
					</div>

					<div class="col-sm-12">
							<!-- time Picker -->
							<div class="col-sm-6 form-group">
							  <div class="bootstrap-timepicker">
								  <label>Início ás:</label>
								  
								  <div class="input-group">
									<input type="text" name="timepickerInicial" class="form-control timepicker">
									<div class="input-group-addon showtimepicker">
									  <i class="fa fa-clock-o"></i>
									</div>
								  </div>
							  </div>
							</div>
								
						<div class="col-sm-6 form-group">
						  <div class="bootstrap-timepicker">
							  <label>T&eacute;rmino &aacute;s:</label>
							  
							  <div class="input-group">
								<input type="text" name="timepickerFinal" class="form-control timepicker">
								<div class="input-group-addon showtimepicker">
								  <i class="fa fa-clock-o"></i>
								</div>
							  </div>
							</div>
						</div>
					</div>


					<div class="col-sm-12">
						<div class="col-sm-6 form-group">
							<label>Selecione o dia inicial</label>
							<select class="form-control select2" name="dias_semana_I" data-placeholder="Selecione o dia da semana">
								<option>Domingo</option>
								<option>Segunda</option>
								<option>Terça</option>
								<option>Quarta</option>
								<option>Quinta</option>
								<option>Sexta</option>
								<option>Sábado</option>
							</select>
						</div>
						<div class="col-sm-6 form-group">
							<label>Selecione o dia final</label>
							<select class="form-control select2" name="dias_semana_F" data-placeholder="Selecione o dia da semana">
								<option>Domingo</option>
								<option>Segunda</option>
								<option>Terça</option>
								<option>Quarta</option>
								<option>Quinta</option>
								<option>Sexta</option>
								<option>Sábado</option>
							</select>
						</div>
					</div>
					
					<div class="col-sm-12">
						<div class="col-sm-6 form-group">
							<label>Tipo de Quadra: </label>
							<select class="form-control select2" name="tipo_quadra" data-placeholder="Selecione o tipo">
						    	<c:forEach var="tiposquadras" items="${tiposquadras}">
						    		<option>${tiposquadras.descricao}</option>
						    	</c:forEach>
							</select>
						</div>
						<div class="col-sm-6 form-group">
							 <label>Quadra disponíveis: </label>
							<select class="form-control select2" name="quadras" multiple="multiple" data-placeholder="Selecione as quadras">

							</select>
						</div>
					</div>

				</div>
	
				<div class="box-footer">
					<div class="col-sm-12">
						<input type="reset" class="btn btn-default" value="Limpar"/>
						<input type="submit" id="cadastrar" class="btn btn-info pull-right" value="Salvar" /><!-- onclick="gravar_dados()" !-->
					</div>
				</div>
	
	            </form>
	
		        <div class="hide statusMessage callout">
					<p></p>
		        </div>
		        <!--<div class="hide statusMessage callout callout-warning">
					<p></p>
		        </div>
		       <div class="hide statusMessage callout callout-info">
		          <p></p>
		        </div>
		        <div class="hide statusMessage callout callout-success">
					<p></p>
		        </div>!-->

			</div>
		</div>


		<!-- LISTAGEM DE QUADRAS -->
		<div class="col-xl-9 col-lg-7 col-md-12">

			<div class="box box-info">
				<div class="box-header text-center">
					<h3 class="box-title">Relação das Torneios.</h3>
				</div>
				<!-- /.box-header -->
				<div class="box-body">
					<table id="example1" class="table table-bordered table-striped">

						<thead>
							<tr>
								<th>Cód</th><!-- Aberto de tênis master -->
								<th>Título</th><!-- Aberto de tênis master -->
								<!-- <th>Evento</th>Torneio -->
								<th>Quadra</th><!-- 1,2,3 -->
								<th>Início</th><!-- 12/12/2012 -->
								<th>Fim</th><!-- 31/12/2012 -->
								<th>Horário</th><!-- 11h a 12h -->
								<th>Semana</th><!-- Seg a Sex -->
								<th>Ações</th><!-- Seg a Sex -->
							</tr>
						</thead>

						<tbody>
							<c:forEach var="reservas" items="${reservas}">
								<tr>
									<td class="text-center">${reservas.codReserva}</td>
									<td>${reservas.torneio.descricao}</td><%-- campo da tabela torneio --%>
									<!--  <td>${reservas.tipoReserva}</td> !-->
									<td>
										<c:set var="campoCodQuadras" value="" />
										<c:forEach var="quadras" items="${reservas.quadras}">
											<c:set var="campoCodQuadras" value="${campoCodQuadras};${quadras.codQuadra}" />
										</c:forEach>
										<c:out value="${fn:replace(campoCodQuadras, ';', ' ')}" />
									</td>
									<fmt:formatDate type="date" pattern="dd/MM/yyyy" value="${reservas.dataInicial}" var="campoDataI" />
									<td><c:out value="${campoDataI}"/></td>
									<fmt:formatDate type="date" pattern="dd/MM/yyyy" value="${reservas.dataFinal}" var="campoDataF" />
									<td><c:out value="${campoDataF}"/></td>
									<td><fmt:formatDate type="time" pattern="HH:mm" value="${reservas.horaInicial}" /> &aacute;
										<fmt:formatDate type="time" pattern="HH:mm" value="${reservas.horaFinal}" />
									</td>
									<td>
											<c:choose>
												<c:when test="${reservas.torneio.diaSemanaInicio==0}">DOM</c:when>
												<c:when test="${reservas.torneio.diaSemanaInicio==1}">SEG</c:when>
												<c:when test="${reservas.torneio.diaSemanaInicio==2}">TER</c:when>
												<c:when test="${reservas.torneio.diaSemanaInicio==3}">QUA</c:when>
												<c:when test="${reservas.torneio.diaSemanaInicio==4}">QUI</c:when>
												<c:when test="${reservas.torneio.diaSemanaInicio==5}">SEX</c:when>
												<c:when test="${reservas.torneio.diaSemanaInicio==6}">SAB</c:when>
											</c:choose>
											&nbsp;&agrave;&nbsp;
											<c:choose>
												<c:when test="${reservas.torneio.diaSemanaFinal==0}">DOM</c:when>
												<c:when test="${reservas.torneio.diaSemanaFinal==1}">SEG</c:when>
												<c:when test="${reservas.torneio.diaSemanaFinal==2}">TER</c:when>
												<c:when test="${reservas.torneio.diaSemanaFinal==3}">QUA</c:when>
												<c:when test="${reservas.torneio.diaSemanaFinal==4}">QUI</c:when>
												<c:when test="${reservas.torneio.diaSemanaFinal==5}">SEX</c:when>
												<c:when test="${reservas.torneio.diaSemanaFinal==6}">SAB</c:when>
											</c:choose>
									</td>
									<td>
										<div class="btn-group">
											<div class="col text-center align-self-center">
												<button type="button" onclick="editar_conteudo('${reservas.codReserva}','${reservas.torneio.descricao}','${campoDataI}','${campoDataF}','${reservas.horaInicial}','${reservas.horaFinal}','${reservas.torneio.diaSemanaInicio}','${reservas.torneio.diaSemanaFinal}', '${campoCodQuadras}')"
													class="editar_conteudo btn btn-default btn-sm">
													<i class="fa fa-edit"></i>
												</button>
												<button type="button" onclick="excluir_registro(${reservas.codReserva})" class="excluir_registro btn btn-default btn-sm"><i class="fa fa-trash-o"></i></button>
											</div>
										</div>
									</td>
								</tr>
							</c:forEach>

						</tbody>

					</table>
				</div>
				<!-- /.box-body -->
			</div>
			<!-- /.box -->

		</div>
		<!-- .col -->

	</div>


</section>
</div>


<%-- CARREGAR PRIMEIRO O FOOTER, PARA TER ACESSO AO JQUERY E DEMAIS PLUGINS --%>
<jsp:include page="main/footer.jsp" />

<%-- PLUGINS UTILIZADOS SOMENTE PARA ESTA PAGINA --%>
	<script src="${pageContext.request.contextPath}/plugins/daterangepicker/moment.js"></script>
	<script src="${pageContext.request.contextPath}/plugins/daterangepicker/daterangepicker.js"></script>
	<%-- <script src="${pageContext.request.contextPath}/plugins/datepicker/bootstrap-datepicker.js"></script> --%>
	<script src="${pageContext.request.contextPath}/plugins/timepicker/bootstrap-timepicker.min.js"></script>

<%-- Page script --%>
	<script type="text/javascript">
		$(function() {
			//Initialize Select2 Elements
			$(".select2").select2();

			//iCheck for checkbox and radio inputs
			$('input[type="checkbox"].minimal, input[type="radio"].minimal').iCheck({checkboxClass : 'icheckbox_minimal-blue', radioClass : 'iradio_minimal-blue'});
			//Red color scheme for iCheck
			$('input[type="checkbox"].minimal-red, input[type="radio"].minimal-red').iCheck({checkboxClass : 'icheckbox_minimal-red',radioClass : 'iradio_minimal-red'});
			//Flat red color scheme for iCheck
			$('input[type="checkbox"].flat-red, input[type="radio"].flat-red').iCheck({checkboxClass : 'icheckbox_flat-green',radioClass : 'iradio_flat-green'});
		});

		$("#example1").DataTable();

		//http://www.daterangepicker.com/
		$(function () {
			//Date range picker
			$('#datacombopicker').daterangepicker({
				timePicker: false,
				timePickerIncrement: 15, locale:{format: 'DD/MM/YYYY'},
				opens: 'right',
				}, function(start, end, label) {
					//console.log('Nova data selecionada: ' + start.format('DD/MM/YYYY') + ' a ' + end.format('DD/MM/YYYY') );
				}
			);
				$('.showdatacombopicker').click(function(){
					$(this).prev().click();
				});


			//https://jdewit.github.io/bootstrap-timepicker/
			$(".timepicker").timepicker({
				showInputs: false,
				showMeridian: false,//24HS
				minuteStep: 15
			});
				$('.showtimepicker').click(function(){
					$(this).prev().click();
				});
		});

		$(function () {
			$("form").bind("reset", function(e){
				e.preventDefault();
				$("input[name='codReserva']").val("");
				$('#datacombopicker').data('daterangepicker').setStartDate(new Date());
				$('#datacombopicker').data('daterangepicker').setEndDate(new Date());
				$("select[name='dias_semana_I']").val("").trigger("change");
				$("select[name='dias_semana_F']").val("").trigger("change");
				$("select[name='tipo_quadra']").val("").trigger("change");
				$("input[name*='timepickerInicial']").timepicker('setTime', "");
				$("input[name*='timepickerFinal']").timepicker('setTime', "");
				$("input[name*='descricao']").val("");
			});
		});

		//DAR UM RESET NO LOAD DA PAGINA, PARA LIMPAR CAMPOS
		$(document).ready(function() {
			$("form").trigger("reset");
		});
		
		$(document).ready(function() {
			$(".dataTables_filter").append("<input type='button' value='Atualizar' class='btn btn-info pull-right' />");
			$( "input[value*='Atualizar']" ).click(function() {
				location.href = "reservas_torneio";
			});
		});
	</script>

	<%-- MENSAGEM DE SUCESSO OU FALHA --%>
	<script type="text/javascript">
		function atualizarMensagens(okAjaxRetorno){
			var statusMessage = okAjaxRetorno;
			$(".statusMessage").addClass("hide");

			if(statusMessage>=1){
				$(".statusMessage.callout-success").removeClass("hide");
				$(".statusMessage.callout-success p").html("Dados processados com sucesso.");

			}else if(statusMessage==0){
				$(".statusMessage.callout-danger").removeClass("hide");
				$(".statusMessage.callout-danger p").html("Não foi possível processar a informação.");

			}
		}
	</script>

	<%-- GRAVAR OU ATUALIZAR --%>
	<script type="text/javascript">
		$("#cadastrar").click(function(){
			//function gravar_dados(){
			//Reservas
			var codReserva = $("input[name*='codReserva']").val();//PK
			var dataInicial = $("#datacombopicker").data('daterangepicker').startDate.format('DD/MM/YYYY');
			var dataFinal = $("#datacombopicker").data('daterangepicker').endDate.format('DD/MM/YYYY');
			var horaInicial = $("input[name='timepickerInicial']").data("timepicker").getTime();
			var horaFinal = $("input[name='timepickerFinal']").data("timepicker").getTime();

			var descricao = $("input[name=descricao]").val();
			var sem_inicio = $("select[name='dias_semana_I']").select2("val");
			var sem_final = $("select[name='dias_semana_F']").select2("val");

			var quadras = $("select[name='quadras']").select2("val");//(3) ["1", "2", "3"]
			var codTipoReserva = 0;//pegar futuramente do codigo da reserva
			
			var okhora = isHoraInicialMenorHoraFinal(horaInicial, horaFinal);
			
			if(descricao.length <= 1){
				Mensagem(erro, "Preencha a descrição.");
				$("input[name=descricao]").focus();
				return false;
			}
			else if(okhora == false){
				Mensagem(erro, "Hora Inicial deve ser vir antes da Hora Final");
				$("input[name='timepickerInicial']").focus();
				return false;
			}
			else if(sem_inicio == null){
				Mensagem(erro, "Escolha o dia da semana de ínicio");
				$("select[name='dias_semana_I']").select2('open');					
				return false;
			}
			else if(sem_final == null){
				Mensagem(erro, "Escolha o dia da semana que termina");
				$("select[name='dias_semana_F']").select2('open');					
				return false;
			}
			else if(quadras == null){
				Mensagem(erro, "Escolha as quadras participantes");
				if($("select[name='tipo_quadra']").select2("val") == null){
					$("select[name='tipo_quadra']").select2('open');
				}else{
					$("select[name='quadras']").select2('open');					
				}				
				return false;				
			}else{
			
				var tipoReserva = 'T';
				var URLAJAX = "minhaquadra/reservas/cadastrar/torneio";
			    $.ajax({
				    url: URLAJAX,
				    type: "PUT",
				    async: false,//!IMPORTANT incluir async:false
				    data: {
			    		"descricao":descricao, 
			    		"codReserva":codReserva, 
			    		"tipoReserva":tipoReserva, 
			    		"codTipoReserva":codTipoReserva, 
			    		"dataInicial":dataInicial, "dataFinal":dataFinal, 
			    		"horaInicial":horaInicial, "horaFinal":horaFinal, 
			    		"sem_inicio":sem_inicio, "sem_final":sem_final, 
			    		"quadras":""+quadras 
				    }
			    })
			    .done(function(data) {
					atualizarMensagens(data)
				})
				.fail(function(data) {
					atualizarMensagens(-1);
				});
			    
			}

		});
	</script>

	<%-- EXCLUIR --%>
	<script type="text/javascript">
		function excluir_registro(codReserva){

			var URLAJAX = "minhaquadra/reservas/excluir/registro";
			$(".statusMessage").addClass("hide");

		    $.ajax({
			    url: URLAJAX,
			    type: "DELETE",
			    async: false,//!IMPORTANT incluir async:false
			    data: {"codReserva":codReserva}
		    })
		    .done(function(data) {
				atualizarMensagens(data)
			})
			.fail(function(data) {
				atualizarMensagens(-1);
			});
		}
	</script>

	<%-- EDITAR --%>
	<script type="text/javascript">
		function editar_conteudo(codReserva, desc,dataI,dataF,horaI,horaF,semI,semF,codQ){
			
			$("input[name='codReserva']").val(codReserva);
			//lista de quadras
				var codQuadras = codQ.split(";");
				codQuadras.shift();//REMOVE O PRIMEIRO ELEMENTO VAZIO
				$("select[name='tipo_quadra']").val(codQuadras).trigger("change");
			//dias da semana
			    var days = ['Domingo','Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado'];//0 a 6
			    var selectedValues2 = new Array();
			    selectedValues2[0] = days[semI];
			    selectedValues2[1] = days[semF];
				$("select[name='dias_semana_I']").val(selectedValues2[0]).trigger("change");
				$("select[name='dias_semana_F']").val(selectedValues2[1]).trigger("change");
			//titulo ou descricao
				$("input[name*='descricao']").val(desc);
			//dia do mes
				$('#datacombopicker').data('daterangepicker').setStartDate(dataI);
				$('#datacombopicker').data('daterangepicker').setEndDate(dataF);
			//horario de inicio e fim
				$("input[name='timepickerInicial']").data("timepicker").setTime(horaI);
				$("input[name='timepickerFinal']").data("timepicker").setTime(horaF);
				
			//Desabilita o campo
				//$("input[name='descricao']").attr('disabled','disabled');
		}
	</script>

	

	<%-- PESQUISAR --%>
	<script type="text/javascript">
	
		$(document).ready(function() {
			//https://select2.github.io/examples.html#events
			$("select[name='tipo_quadra']").val("").trigger("change");
			var $eventSelect = $("select[name*='tipo_quadra']");
			$eventSelect.on("change", function (e) {
				if($eventSelect.val()!=null && $eventSelect.val()!="")
					pesquisar_quadras($eventSelect.val());	
			});
		});
	
		function pesquisar_quadras(esporte){

			$(".statusMessage").addClass("hide");
			
			var dataInicial = $("#datacombopicker").data('daterangepicker').startDate.format('DD/MM/YYYY');
			var dataFinal = $("#datacombopicker").data('daterangepicker').endDate.format('DD/MM/YYYY');
			var horaInicial = $("input[name='timepickerInicial']").data("timepicker").getTime();
			var horaFinal = $("input[name='timepickerFinal']").data("timepicker").getTime();
			
			var URLAJAX = "minhaquadra/quadra/buscar/esporte/data";
		    $.ajax({
			    url: URLAJAX,//VIA GET PASSAR NA URL O PARAMETRO
			    type: "POST",
			    async: false,//!IMPORTANT incluir async:false
			    data: {
			    	"esporte": ""+esporte,
			    	"dataInicial": ""+dataInicial,
			    	"dataFinal": ""+dataFinal,
			    	"horaInicial": ""+horaInicial,
			    	"horaFinal": ""+horaFinal
		    		}
		    })
		    .done(function(data) {
		    	if(data!='undefined'){
		    		var listaQuadras = data.split(";");
				    var found = 0;
		    		$("select[name*='quadras']").html("");
				    for (var i = 0, j = 0, len = listaQuadras.length; i < len; i+=3) {
				    	if(listaQuadras[i].length > 0){
				    		var CODIGO = i;
				    		var NOME = i+1;
				    		var STATUS = i+2;
				    		var indiceOf = listaQuadras[STATUS].search("Dispon");//-1 nao encontrou
				    		if(indiceOf>-1){
				    			found = 1;
					    		$("select[name*='quadras']").append("<option value='"+listaQuadras[CODIGO]+"'>"+listaQuadras[CODIGO]+"-"+listaQuadras[STATUS]+"</option>");
					    		$("select[name*='quadras']").trigger('change');
				    		}
				    		else{
					    		$("select[name*='quadras']").append("<option value='"+listaQuadras[CODIGO]+"' disabled='disabled'>"+listaQuadras[CODIGO]+"-"+listaQuadras[STATUS]+"</option>");
				    		}
				    	} 
		    		}
					if(found == 0){
						atualizarMensagens(-1);					
					}else{
						atualizarMensagens(-1);
						Mensagem(sucesso, "Selecione as quadras dispon&iacute;veis.");
					}
				}
				//atualizarMensagens(1)
			})
			.fail(function(data) {
				atualizarMensagens(-1);
				$("select[name*='quadras'] option").html("");
				$("select[name*='quadras']").val("").trigger('change');
				Mensagem(erro, "N&atilde;o foi poss&iacute;vel pesquisar as quadras.");
			});
		}
	</script>
	
	<script>
		function isHoraInicialMenorHoraFinal(horaInicial, horaFinal)
		{ 
			horaIni = horaInicial.split(':'); horaFim = horaFinal.split(':'); 
			
			// Verifica as horas. Se forem diferentes, é só ver se a inicial 
			// é menor que a final. 
			hIni = parseInt(horaIni[0], 10); 
			hFim = parseInt(horaFim[0], 10); 
			if(hIni != hFim) 
				return hIni < hFim; 
			
			// Se as horas são iguais, verifica os minutos então. 
			mIni = parseInt(horaIni[1], 10); 
			mFim = parseInt(horaFim[1], 10); 
			if(mIni != mFim) 
				return mIni < mFim; 
		}
	</script>