<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<jsp:include page="main/header.jsp" />
<jsp:include page="main/menu-esquerdo.jsp" />


  <%-- DataTables --%>
  <link rel="stylesheet" href="${pageContext.request.contextPath}/plugins/datatables/dataTables.bootstrap.css">

  <%-- CONTEUDO CENTRAL --%>
  <div class="content-wrapper">
	<section class="content-header">
	  <h1>Alterar Senha</h1>
	  <ol class="breadcrumb">
		<li><a href="#"><i class="fa fa-dashboard"></i> Level</a></li>
		<li class="active">Here</li>
	  </ol>
	</section>

	<section class="content">

		<div class="row">
		
			<div class="col-md-6 col-md-auto">
		
				<%-- CADASTRO DE TIPOS DE QUADRAS --%>
		        <div class="box box-solid box-info">
		            <div class="box-header with-border text-center">
		              <h3 class="box-title">Alterar Senha</h3>
		            </div><!-- /.box-header -->
		            
		            <form id="btnFuncionarios" class="form-horizontal" action="#" method="post">
		             
		              <div class="box-body">
		                <div class="form-group">
		                  <label for="descricao1" class="col-md-4 control-label">Matrcula</label>

		                  <div class="col-md-6">
		                    <input type="text" class="form-control" name="matricula" value=${usuario.matricula } readonly>
		                  </div>
		                </div>
		                <div class="form-group">
		                  <label for="descricao1" class="col-md-4 control-label">Nome</label>
		                  
		                  <div class="col-md-6">
		                    <input type="text" class="form-control" name="nome" value=${usuario.nome } readonly>
		                  </div>
		                </div>
		                
		                <div class="form-group">
		                  <label for="descricao1" class="col-md-4 control-label">Senha</label>
		                
		                  <div class="col-md-6">
		                    <input type="password" class="form-control" name="senha" id="txtSenha" onkeyup="ComparaSenhas()">
		                  </div>
		                </div>
		                
		                <div class="form-group">
		                  <label for="descricao1" class="col-md-4 control-label">Confirmar Senha</label>
		                
		                  <div class="col-md-6">
		                    <input type="password" class="form-control" name="confirma_senha" id="txtConfirmarSenha" onkeyup="ComparaSenhas()">
		                  </div>
		                </div>
		              </div>
		            
		              <div class="box-footer">
		                <button type="reset" class="btn btn-default">Cancelar</button>
		                <button type="submit" id="cadastrarFuncionario"
		                			class="btn btn-info pull-right">Salvar</button>
		              </div><!-- /.box-footer -->
		            </form>

			        <div class="hide statusMessage callout">
						<p></p>
			        </div>
		            
		        </div><!-- box box-success -->
		        
			</div><!-- .col -->
			
		</div>

	</section><!-- /.content -->
  </div><!-- /.content-wrapper -->

<%-- CARREGAR PRIMEIRO O FOOTER, PARA TER ACESSO AO JQUERY E DEMAIS PLUGINS --%>
<jsp:include page="main/footer.jsp" />

	<%-- DataTables --%>
	<script src="${pageContext.request.contextPath}/plugins/datatables/jquery.dataTables.min.js"></script>
	<script src="${pageContext.request.contextPath}/plugins/datatables/dataTables.bootstrap.min.js"></script>
	<!-- Select2 -->
	<script src="${pageContext.request.contextPath}/plugins/select2/select2.full.min.js"></script>
	
	<%-- Page script --%>
	<script>
    var form = $('#form1');
	  	$(function () {
		//Initialize Select2 Elements
		    $(".select2").select2();
		

		    //iCheck for checkbox and radio inputs
		    $('input[type="checkbox"].minimal, input[type="radio"].minimal').iCheck({
		      checkboxClass: 'icheckbox_minimal-blue',
		      radioClass: 'iradio_minimal-blue'
		    });
		    //Red color scheme for iCheck
		    $('input[type="checkbox"].minimal-red, input[type="radio"].minimal-red').iCheck({
		      checkboxClass: 'icheckbox_minimal-red',
		      radioClass: 'iradio_minimal-red'
		    });
		    //Flat red color scheme for iCheck
		    $('input[type="checkbox"].flat-red, input[type="radio"].flat-red').iCheck({
		      checkboxClass: 'icheckbox_flat-green',
		      radioClass: 'iradio_flat-green'
		    });
		    
		});
	</script>

	<%-- COMPARA SENHA --%>
	<script>
		function ComparaSenhas(){
			var senha = $("input[name*='senha']").val();
			var confSenha = $("input[name*='confirma_senha']").val();

			if(senha.length < 4){
				Mensagem(erro,"Preencha as senhas com no mmino 4 caracteres.");
				$("#cadastrarFuncionario").addClass("hide");
				return false;
			}
			
			if(senha != confSenha){
				Mensagem(erro,"Senhas no so idnticas.");
				$("#cadastrarFuncionario").addClass("hide");
				
			}else{
				$(".statusMessage.callout-danger").addClass("hide");
				$("#cadastrarFuncionario").removeClass("hide");
			}
		}	
	</script>
	
	<%-- CADASTRAR SENHA --%>
	<script>
		$(document).ready(function() {
			$(".dataTables_filter").append("<input type='button' value='Atualizar' class='btn btn-info pull-right' />");
			$( "input[value*='Atualizar']" ).click(function() {
				location.href = "acessos_cadastro";
			});
		});

		$( "#cadastrarFuncionario" ).click(function() {
			var URLAJAX = "minhaquadra/usuario/alterarSenha/banco";
			var matricula = $("input[name*='matricula']").val();
			var senha = $("input[name*='senha']").val();

			if(senha.length < 4){
				Mensagem(erro,"Preencha as senhas com no mmino 4 caracteres.");
				$("#cadastrarFuncionario").addClass("hide");
				return false;
				
			}else {
			    $.ajax({
				    url: URLAJAX,
				    type: "PUT",
				    async: false,//!IMPORTANT incluir async:false
				    data: { "matricula":matricula, "senha":senha },
				    dataType: "json"
			    })
			    .done(function(data) {
					console.log( "sucess" + data );
					if(data==1){
						Mensagem(sucesso,"Dados gravados com sucesso.");
					}else{
						Mensagem(erro,"No foi possvel gravar os dados.");
					}
				})
				.fail(function(data) {
					Mensagem(erro,"No foi possvel gravar os dados.");
				});
			}
		});
	</script>
	  
	<%-- page script --%>
	<script>
	  $(function () {
	    $("#example1").DataTable();
	    $('#example2').DataTable({
	      "paging": true,
	      "lengthChange": false,
	      "searching": false,
	      "ordering": true,
	      "info": true,
	      "pageLength": 5,
	      "autoWidth": false
	    });
	  });
	</script>