package br.com.gestor.controller;

import java.io.IOException;

import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.ApplicationPath;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Application;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;

import br.com.gestor.bean.Acessos;
import br.com.gestor.bean.Itens;
import br.com.gestor.bean.Quadras;
import br.com.gestor.bean.Usuario;
import br.com.gestor.dao.AcessosDao;
import br.com.gestor.dao.ItensDao;
import br.com.gestor.dao.QuadrasDao;

@ApplicationPath("/minhaquadra")//TEM BARRA INICIAL
@Path("acesso")//NAO TEM BARRA INICIAL
public class AcessoCtrl extends Application {

   private static final int SUCCESS_RECORD = 1;
   private static final int FAILURE_RECORD = 0;

    //http://localhost:8080/quadras/minhaquadra/acesso/console/123
    @GET
	@Path("console/{objeto}")
	public String getQuadras(@PathParam("objeto") int n){
		System.err.println(n);
		return String.valueOf(n);
	}

	//http://localhost:8080/quadras/minhaquadra/acesso/cadastrar/banco
	@PUT
	@Path("cadastrar/banco")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)//APPLICATION_FORM_URLENCODED NAO ACEITA @GET
	public int cadastroAcesso(
			@FormParam("codAcesso") int codAcesso,
			@FormParam("descricao") String descricao,
			@FormParam("eAdm") int eAdm,
			@FormParam("eQuadras") int eQuadras,
//			@FormParam("eTipos") int eTipos,
//			@FormParam("eFilasEspera") int eFilasEspera,
			@FormParam("eReservas") int eReservas,
			@FormParam("eManutencoes") int eManutencoes,
			@FormParam("eItens") int eItens,
//			@FormParam("eColetas") int eColetas,
			@FormParam("eRelatorios") int eRelatorios,
			@Context HttpServletResponse servletResponse) throws IOException{

		Acessos acesso = new Acessos();

		acesso.setCodAcesso(codAcesso);
    	acesso.setDescricao(descricao);
    	acesso.setAdm(eAdm);
    	acesso.setQuadras(eQuadras);
//    	acesso.setTipoQuadras(eTipos);
//    	acesso.setFilasEspera(eFilasEspera);
    	acesso.setReservas(eReservas);
    	acesso.setManutencoes(eManutencoes);
    	acesso.setItens(eItens);
//    	acesso.setColetas(eColetas);
    	acesso.setRelatorios(eRelatorios);
		
//		AcessosDao dao = new AcessosDao();

		int result = acesso.cadastrar();
		if(result>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}

	//http://localhost:8080/quadras/minhaquadra/acesso/excluir/banco
	@DELETE
	@Path("excluir/banco")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
	public int excluirAcesso(
			@FormParam("codigo") int codigo,
			@Context HttpServletResponse servletResponse) throws IOException{

		Acessos acesso = new Acessos();
		acesso.setCodAcesso(codigo);
//		AcessosDao dao = new AcessosDao();

		int result = acesso.deletar();
		if(result>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}
}