package br.com.gestor.controller;

import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.ApplicationPath;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Application;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;

import com.google.gson.Gson;

import br.com.gestor.bean.Itens;
import br.com.gestor.bean.Quadras;
import br.com.gestor.dao.ItensDao;
import br.com.gestor.dao.QuadrasDao;

@ApplicationPath("/minhaquadra")//TEM BARRA INICIAL
@Path("item")//NAO TEM BARRA INICIAL
public class ItensCtrl extends Application {
	private static final long serialVersionUID = 1L;

   	private static final int SUCCESS_RECORD = 1;
   	private static final int FAILURE_RECORD = 0;

    //http://localhost:8080/quadras/minhaquadra/item/console/123
    @GET
	@Path("console/{objeto}")
	public String getItens(@PathParam("objeto") int n){
		System.err.println(n);
		return String.valueOf(n);
	}

	//http://localhost:8080/quadras/minhaquadra/item/cadastrar/banco
	@PUT
	@Path("cadastrar/banco")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)//APPLICATION_FORM_URLENCODED NAO ACEITA @GET
	public int cadastro(
			@FormParam("codItem") int codItem,
			@FormParam("descricao") String descricao,
			@FormParam("valor") float valor,
			@Context HttpServletResponse servletResponse) throws IOException{

    	Itens item = new Itens(descricao, valor);
    	item.setCodItem(codItem);
    	
		int result = item.cadastrar();
		if(result>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}

	//http://localhost:8080/quadras/minhaquadra/itens/excluir/banco
	@DELETE
	@Path("excluir/banco")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
	public int excluir(
			@FormParam("codigo") int codigo,
			@Context HttpServletResponse servletResponse) throws IOException{

		Itens item = new Itens();
		item.setCodItem(codigo);

		int result = item.deletar();
		if(result>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}
}