﻿package br.com.gestor.controller;

import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.ApplicationPath;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Application;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;

import br.com.gestor.bean.Associados;
import br.com.gestor.bean.Escolinha;
import br.com.gestor.bean.Itens;
import br.com.gestor.bean.Manutencoes;
import br.com.gestor.bean.Quadras;
import br.com.gestor.bean.Reservas;
import br.com.gestor.bean.Torneio;
import br.com.gestor.dao.ItensDao;
import br.com.gestor.dao.ManutencoesDao;
import br.com.gestor.dao.QuadrasDao;
import br.com.gestor.dao.ReservasDao;

//http://stackoverflow.com/questions/20670310/why-would-java-lang-illegalstateexception-the-resource-configuration-is-not-mo
//http://stackoverflow.com/questions/26152578/learning-rest-stuck-on-illegalstateexception

@ApplicationPath("/minhaquadra")
@Path("reservas")
public class ReservasCtrl extends Application {

   private static final int SUCCESS_RECORD = 1;
   private static final int FAILURE_RECORD = 0;

	//http://localhost:8080/quadras/minhaquadra/reservas/excluir/escolinha
	@DELETE
	@Path("excluir/registro")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
	public int excluirRegistro(
			@FormParam("codReserva") int codReserva,
			@Context HttpServletResponse servletResponse) throws IOException{

    	ReservasDao reservasDao = new ReservasDao();
    	int result = reservasDao.excluirRegistroReserva(codReserva);
    	
		if(result>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}
  

	//http://localhost:8080/quadras/minhaquadra/reservas/cadastrar/escolinha
	@PUT
	@Path("cadastrar/escolinha")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
	public int cadastrarEscolinha(
			@FormParam("codReserva") int codReserva,
			@FormParam("tipoReserva") String tipoReserva,
			@FormParam("descricao") String descricao,
			@FormParam("codTipoReserva") int codTipoReserva,
			@FormParam("dataInicial") String dataInicialParam,
			@FormParam("dataFinal") String dataFinalParam,
			@FormParam("horaInicial") String horaInicialParam,
			@FormParam("horaFinal") String horaFinalParam,
			@FormParam("dias_semana") String dias_semana,
			@FormParam("quadras") String quadrasParam,
			@Context HttpServletResponse servletResponse) throws IOException, ParseException{

		SimpleDateFormat dataFormat = new SimpleDateFormat("dd/MM/yyyy");
		Date dataInicial = dataFormat.parse(dataInicialParam);
		Date dataFinal = dataFormat.parse(dataFinalParam);
		
		SimpleDateFormat horaFormat = new SimpleDateFormat("HH:mm");
		Date horaInicial = horaFormat.parse(horaInicialParam);
		Date horaFinal = horaFormat.parse(horaFinalParam);
		
		Escolinha escolinha = new Escolinha();
		escolinha.setDescricao(descricao);

		if(!dias_semana.equalsIgnoreCase("null")){
			String [] semanaUsuario = dias_semana.split(",");
			for (String usuario : semanaUsuario) {
				switch (usuario) {
					case "Domingo": escolinha.setDom(true); break;
					case "Segunda": escolinha.setSeg(true); break;
					case "Terça": escolinha.setTer(true); break;
					case "Quarta": escolinha.setQua(true); break;
					case "Quinta": escolinha.setQui(true); break;
					case "Sexta": escolinha.setSex(true); break;
					case "Sábado": escolinha.setSab(true); break;
					//default: break;
				}
			}
		}
		
		List<Quadras> listaquadras = new ArrayList<Quadras>();
			String [] listaSplit = quadrasParam.split(",");
			for (String cod : listaSplit) {
				if(!cod.equalsIgnoreCase("null") && cod.length() > 0){
					Quadras quadras = new Quadras();
					quadras.setCodQuadra(Integer.parseInt(cod));
					listaquadras.add(quadras);
				}
		}
		
		Reservas novareserva = new Reservas(codReserva, tipoReserva, codTipoReserva, dataInicial, dataFinal, horaInicial, horaFinal, listaquadras, null, escolinha, null, null);
		
    	ReservasDao reservasDao = new ReservasDao(); 	
    	
    	int OPERACAO_FLAG = 0;
    	if(codReserva > 0){
			//REMOVER E CADASTRAR
    			//Primeiro exclui a reserva anterior, liberando quadras
    			OPERACAO_FLAG = reservasDao.excluirRegistroReserva(codReserva);  	
    			//Depois cadastra uma nova reserva
    			OPERACAO_FLAG = reservasDao.cadastrarReservasEscolinhas(novareserva);
    	}else{
    		//SOMENTE CADASTRAR
			OPERACAO_FLAG = reservasDao.cadastrarReservasEscolinhas(novareserva);    	
    	}
    	//novareserva.setCodReserva(OPERACAO_FLAG);
    	
    	if(OPERACAO_FLAG>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}
	
	//http://localhost:8080/quadras/minhaquadra/reservas/cadastrar/torneio
	@PUT
	@Path("cadastrar/torneio")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
	public int cadastrarTorneio(
			@FormParam("codReserva") int codReserva,
			@FormParam("tipoReserva") String tipoReserva,
			@FormParam("descricao") String descricao,
			@FormParam("codTipoReserva") int codTipoReserva,
			@FormParam("dataInicial") String dataInicialParam,
			@FormParam("dataFinal") String dataFinalParam,
			@FormParam("horaInicial") String horaInicialParam,
			@FormParam("horaFinal") String horaFinalParam,
			@FormParam("sem_inicio") String sem_inicio,
			@FormParam("sem_final") String sem_final,
			@FormParam("quadras") String quadrasParam,
			@Context HttpServletResponse servletResponse) throws IOException, ParseException{
		
		SimpleDateFormat dataFormat = new SimpleDateFormat("dd/MM/yyyy");
		Date dataInicial = dataFormat.parse(dataInicialParam);
		Date dataFinal = dataFormat.parse(dataFinalParam);
		
		SimpleDateFormat horaFormat = new SimpleDateFormat("HH:mm");
		Date horaInicial = horaFormat.parse(horaInicialParam);
		Date horaFinal = horaFormat.parse(horaFinalParam);

		String [] semana = new String[]{"Domingo", "Segunda", "Terça", "Quarta", "Quinta", "Sexta", "Sábado"};//0 a 6
		Torneio torneio = new Torneio();
		torneio.setDescricao(descricao);
		int i = 0;
		for (String token : semana) {
			if(token.equalsIgnoreCase(sem_inicio))
				torneio.setDiaSemanaInicio(i);
			if(token.equalsIgnoreCase(sem_final))
				torneio.setDiaSemanaFinal(i);
		i++;
		}
		
		List<Quadras> listaquadras = new ArrayList<Quadras>();
			String [] listaSplit = quadrasParam.split(",");
			for (String cod : listaSplit) {
				if(!cod.equalsIgnoreCase("null") && cod.length() > 0){
					Quadras quadras = new Quadras();
					quadras.setCodQuadra(Integer.parseInt(cod));
					listaquadras.add(quadras);
				}
		}
		
		Reservas novareserva = new Reservas(codReserva, tipoReserva, codTipoReserva, dataInicial, dataFinal, horaInicial, horaFinal, listaquadras, torneio, null, null, null);
		
    	ReservasDao reservasDao = new ReservasDao();
		
    	int OPERACAO_FLAG = 0;
    	if(codReserva > 0){
			//REMOVER E CADASTRAR
    			//Primeiro exclui a reserva anterior, liberando quadras
    			OPERACAO_FLAG = reservasDao.excluirRegistroReserva(codReserva);  	
    			//Depois cadastra uma nova reserva
    			OPERACAO_FLAG = reservasDao.cadastrarReservasTorneios(novareserva);
	
    	}else{
    		//SOMENTE CADASTRAR
			OPERACAO_FLAG = reservasDao.cadastrarReservasTorneios(novareserva);    	
    	}
    	
		if(OPERACAO_FLAG>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}
	
	//http://localhost:8080/quadras/minhaquadra/reservas/cadastrar/associado
	@PUT
	@Path("cadastrar/associado")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
	public int cadastrarAssociado(
			@FormParam("codReserva") int codReservaParam,
			@FormParam("tipoReserva") String tipoReservaParam,
			@FormParam("codTipoReserva") int codTipoReservaParam,
			@FormParam("dataInicial") String dataInicialParam,
			@FormParam("dataFinal") String dataFinalParam,
			@FormParam("horaInicial") String horaInicialParam,
			@FormParam("horaFinal") String horaFinalParam,
			@FormParam("quadras") String quadrasParam,
			@FormParam("tipo_quadra") String tipo_quadraParam,
			@FormParam("nome") String nomeParam,
			@FormParam("matricula") int matriculaInteiroParam,
			@Context HttpServletResponse servletResponse) throws IOException, ParseException{
		
		SimpleDateFormat dataFormat = new SimpleDateFormat("dd/MM/yyyy");
		Date dataInicial = dataFormat.parse(dataInicialParam);
		Date dataFinal = dataFormat.parse(dataFinalParam);
		
		SimpleDateFormat horaFormat = new SimpleDateFormat("HH:mm");
		Date horaInicial = horaFormat.parse(horaInicialParam);
		Date horaFinal = horaFormat.parse(horaFinalParam);
		
		List<Quadras> listaquadras = new ArrayList<Quadras>();
			String [] listaSplit = quadrasParam.split(",");
			for (String cod : listaSplit) {
				if(!cod.equalsIgnoreCase("null") && cod.length() > 0){
					Quadras quadras = new Quadras();
					quadras.setCodQuadra(Integer.parseInt(cod));
					listaquadras.add(quadras);
				}
		}

		String tipoQuadras = tipo_quadraParam;
		
		Associados associados = new Associados();
		associados.setMatricula(matriculaInteiroParam);
		associados.setNome(nomeParam);		
		
		Reservas novareserva = new Reservas(codReservaParam, tipoReservaParam, codTipoReservaParam, dataInicial, dataFinal, horaInicial, horaFinal, listaquadras, null, null, associados, null);
		
    	ReservasDao reservasDao = new ReservasDao();
    	
    	int OPERACAO_FLAG = 0;
    	if(codReservaParam > 0){
			//REMOVER E CADASTRAR
    			//Primeiro exclui a reserva anterior, liberando quadras
    			OPERACAO_FLAG = reservasDao.excluirRegistroReserva(codReservaParam);
    			//Depois cadastra uma nova reserva
    			OPERACAO_FLAG = reservasDao.cadastrarReservasAssociados(novareserva);
    	}else{
    		//SOMENTE CADASTRAR
    			OPERACAO_FLAG = reservasDao.cadastrarReservasAssociados(novareserva);    	
    	}
    	
		if(OPERACAO_FLAG>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}

	//http://localhost:8080/quadras/minhaquadra/reservas/buscar/associado
	@PUT
	@Path("buscar/associado")
	@Produces(MediaType.APPLICATION_JSON)
	public Associados BuscarAssociado(
			@FormParam("matricula") String catMatricula,
			@Context HttpServletResponse servletResponse) throws IOException, ParseException{
		String categoria = catMatricula.substring(0,1);
		int matricula = Integer.parseInt(catMatricula.substring(catMatricula.indexOf("-")+1, catMatricula.length()));
		
		Associados associado = new Associados();
		associado.setCategoria(categoria);
		associado.setMatricula(matricula);
		
		associado = new ReservasDao().BuscaAssociado(associado);
		
		return associado;
	}

	
	//http://localhost:8080/quadras/minhaquadra/reservas/listar/calendario
	@GET
	@Path("listar/calendario")
	@Produces(MediaType.APPLICATION_JSON)
	public ArrayList<Object> listarReservas(){
		
		ReservasDao reservasDao = new ReservasDao();
		ArrayList<Reservas> calendario = new ArrayList<>();
		calendario = reservasDao.listarCalendarioReservas();

		ArrayList<Object> reservas = new ArrayList<>();
		Map<String, String> lista = new HashMap<String, String>();
		Calendar calendar = new GregorianCalendar();
		
		for (Reservas rs : calendario) {
			lista = new HashMap<String, String>();//RESET Map<String, String> lista
				//Dados de titulacao
				lista.put("categoria", rs.getTipoReserva());
				lista.put("descricao", rs.getDescricao());
				lista.put("codReserva", String.valueOf(rs.getCodReserva()));
				//Data de ínicio
				calendar.setTime(rs.getDataInicial());
					lista.put("dia1",  String.valueOf(calendar.get(Calendar.DAY_OF_MONTH)));
					lista.put("mes1",  String.valueOf(calendar.get(Calendar.MONTH)));
					lista.put("ano1",  String.valueOf(calendar.get(Calendar.YEAR)));
				calendar.setTime(rs.getHoraInicial());
					lista.put("hora1", String.valueOf(calendar.get(Calendar.HOUR_OF_DAY)));
					lista.put("min1",  String.valueOf(calendar.get(Calendar.MINUTE)));
				//Data de Fim
				calendar.setTime(rs.getDataFinal());
					lista.put("dia2",  String.valueOf(calendar.get(Calendar.DAY_OF_MONTH)));
					lista.put("mes2",  String.valueOf(calendar.get(Calendar.MONTH)));
					lista.put("ano2",  String.valueOf(calendar.get(Calendar.YEAR)));
				calendar.setTime(rs.getHoraFinal());
					lista.put("hora2", String.valueOf(calendar.get(Calendar.HOUR_OF_DAY)));
					lista.put("min2",  String.valueOf(calendar.get(Calendar.MINUTE)));
			reservas.add(lista);
		}
		
		return reservas;		
	} 

	//http://localhost:8080/quadras/minhaquadra/reservas/cadastrar/manutencao
	@PUT
	@Path("cadastrar/manutencao")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)//APPLICATION_FORM_URLENCODED NAO ACEITA @GET
	public int cadastroManutencoes(
			@FormParam("horaInicial") String horaInicialParam,
			@FormParam("dataInicial") String dataInicialParam,
			
			@FormParam("horaFinal") String horaFinalParam,
			@FormParam("dataFinal") String dataFinalParam,

			@FormParam("quadra") String codQuadra,
			@FormParam("arrayCodsItens") String arrayCodsItens,
			@FormParam("arrayQtdsItens") String arrayQtdsItens,
			@Context HttpServletResponse servletResponse) throws IOException, ParseException{

//		ReservasDao daoReservas = new ReservasDao();
//		ManutencoesDao daoManutencoes = new ManutencoesDao();
//		ItensDao daoItens = new ItensDao();
//		QuadrasDao daoQuadras = new QuadrasDao();
		
		Reservas reserva= new Reservas();
		Manutencoes manutencao = new Manutencoes();
    	Quadras quadra = new Quadras();
    	
		ArrayList<Itens> listItens = new ArrayList<Itens>();
    	ArrayList<Integer> listQtds = new ArrayList<Integer>();
    	ArrayList<Quadras> listQuadras = new ArrayList<Quadras>();
   	
    	float valorTotal = 0;
    	
    	//Fazer array de itens e valores
    	List<String> listCodsItens = new ArrayList<String>(Arrays.asList(arrayCodsItens.split(";")));
    	List<String> listQtdsItens = new ArrayList<String>(Arrays.asList(arrayQtdsItens.split(";")));
    	
    	for(int i = 0; i < listCodsItens.size(); i++ ){
    		listQtds.add(Integer.parseInt(listQtdsItens.get(i)));
    		
    		if(listQtds.get(i) != 0){
	    		Itens item = new Itens();
	    		item.setCodItem(Integer.parseInt(listCodsItens.get(i)));
	    		item.buscar();
	    		listItens.add(item);
	    		
	    		valorTotal += listQtds.get(i) * item.getValor();
    		}
    	}

    	//Inserir Manutencao
    	manutencao.setItensManutencao(listItens);
    	manutencao.setQtds(listQtds);
    	manutencao.setValor_total(valorTotal);    	
		
//    	int result = daoManutencoes.insert(manutencao);
//    	manutencao.setCodIManutencao(result);
    	
    	//Inserir Reserva
		SimpleDateFormat dataFormat = new SimpleDateFormat("dd/MM/yyyy");
//		Date dataInicial = dataFormat.parse(dataInicialParam);
//		Date dataFinal = dataFormat.parse(dataFinalParam);
		
		SimpleDateFormat horaFormat = new SimpleDateFormat("HH:mm");
//		Date horaInicial = horaFormat.parse(horaInicialParam);
//		Date horaFinal = horaFormat.parse(horaFinalParam);

		quadra.setCodQuadra(Integer.parseInt(codQuadra));
		listQuadras.add(quadra);
		
		reserva.setTipoReserva("M");
		reserva.setCodTipoReserva(manutencao.getCodIManutencao());
		reserva.setDataInicial( dataFormat.parse(dataInicialParam) );
		reserva.setDataFinal( dataFormat.parse(dataFinalParam) );
		reserva.setHoraInicial( horaFormat.parse(horaInicialParam) );
		reserva.setHoraFinal( horaFormat.parse(horaFinalParam) );
		reserva.setQuadras(listQuadras);
		reserva.setManutencoes(manutencao);
		
		int result = reserva.cadastrar();
		if(result>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}

}
