package br.com.gestor.controller;

import java.io.IOException;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.ws.rs.ApplicationPath;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Application;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.handler.MessageContext;

import br.com.gestor.bean.Acessos;
import br.com.gestor.bean.Itens;
import br.com.gestor.bean.Quadras;
import br.com.gestor.bean.Usuario;
import br.com.gestor.dao.AcessosDao;
import br.com.gestor.dao.ItensDao;
import br.com.gestor.dao.QuadrasDao;
import br.com.gestor.dao.UsuarioDao;
import br.com.gestor.model.Criptografia;

@ApplicationPath("/minhaquadra")//TEM BARRA INICIAL
@Path("usuario")//NAO TEM BARRA INICIAL
public class UsuarioCtrl extends Application {

	private static final int SUCCESS_RECORD = 1;
   	private static final int FAILURE_RECORD = 0;
   
   	@Resource
   	private WebServiceContext ctx;

    //http://localhost:8080/quadras/minhaquadra/usuario/console/123
    @GET
	@Path("console/{objeto}")
	public String getQuadras(@PathParam("objeto") int n){
		System.err.println(n);
		return String.valueOf(n);
	}

	//http://localhost:8080/quadras/minhaquadra/usuario/alterarSenha/banco
	@PUT
	@Path("alterarSenha/banco")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)//APPLICATION_FORM_URLENCODED NAO ACEITA @GET
	public int alterarSenha(
			@FormParam("matricula") int matricula,
			@FormParam("senha") String senha,
			@Context HttpServletResponse servletResponse) throws IOException{

	    Usuario usuario = new Usuario();
	    usuario.setMatricula(matricula);
	    usuario.buscar();

	    usuario.setSenha(senha);
		
		int result = usuario.cadastrar();
		if(result>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}

	//http://localhost:8080/quadras/minhaquadra/usuario/buscar/banco
	@POST
	@Path("buscar/banco")
	@Produces(MediaType.TEXT_PLAIN)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
	public String buscarFuncionario(
			@FormParam("matricula") int matricula,
			@Context HttpServletResponse servletResponse) throws IOException{

		return new UsuarioDao().BuscarFuncionario(matricula);
	}

	//http://localhost:8080/quadras/minhaquadra/usuario/cadastrar/banco
	@PUT
	@Path("cadastrar/banco")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)//APPLICATION_FORM_URLENCODED NAO ACEITA @GET
	public int cadastrar(
			@FormParam("matricula") int matricula,
			@FormParam("nome") String nome,
			@FormParam("acesso") String descAcesso,
			@Context HttpServletResponse servletResponse) throws IOException{

		Acessos acesso = new Acessos();
		acesso.setDescricao(descAcesso);
		acesso.buscar();
		
		Usuario usuario = new Usuario();
		usuario.setMatricula(matricula);
		usuario.setNome(nome);
		usuario.setAcesso(acesso);
		usuario.setSenha( ""+matricula );
				
		int result = usuario.cadastrar();
		if(result>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}
	
	//http://localhost:8080/quadras/minhaquadra/usuario/deletar/banco
	@DELETE
	@Path("deletar/banco")
	@Produces(MediaType.APPLICATION_JSON)
	@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
	public int deletar(
			@FormParam("matricula") int matricula,
			@Context HttpServletResponse servletResponse) throws IOException{
		Usuario usuario = new Usuario();
		usuario.setMatricula(matricula);
		
		int result = usuario.deletar();
		if(result>0)
			return SUCCESS_RECORD;
		return FAILURE_RECORD;
	}
}