package br.com.gestor.dao;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;

import br.com.gestor.bean.Acessos;
import br.com.gestor.bean.Manutencoes;
import br.com.gestor.model.ConnectionFactory;
import br.com.gestor.model.Criptografia;

public class AcessosDao extends ConnectionFactory{
	
    private Connection conn = null;
    private CallableStatement cstm = null;
    private PreparedStatement pstm = null;
    private ResultSet rset = null;

    public int deletar(Acessos acesso) {
    	int qtdeUpd = 0;
        try{
            conn = ConnectionFactory.abrirConexoes();

            cstm = conn.prepareCall("{ ? = call ACESSOS_DELETE(?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, acesso.getCodAcesso());

            qtdeUpd = cstm.executeUpdate();
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
    	return qtdeUpd;
    }

    public int cadastrar(Acessos acesso) {
    	int qtdeUpd = 0;
        try{
            conn = ConnectionFactory.abrirConexoes();

            cstm = conn.prepareCall("{ ? = call ACESSOS_INSERT(?,?,?,?,?,?,?,?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, acesso.getCodAcesso());
            cstm.setString(3, acesso.getDescricao());
            cstm.setInt(4, acesso.getAdm());
            cstm.setInt(5, acesso.getQuadras());
//            cstm.setInt(6, acesso.getTipoQuadras());
//            cstm.setInt(7, acesso.getFilasEspera());
            cstm.setInt(6, acesso.getReservas());
            cstm.setInt(7, acesso.getManutencoes());
            cstm.setInt(8, acesso.getItens());
//            cstm.setInt(11, acesso.getColetas());
            cstm.setInt(9, acesso.getRelatorios());

            qtdeUpd = cstm.executeUpdate();
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
    	return qtdeUpd;
    }

    public ArrayList<Acessos> listarAcessos(Acessos acesso){

    	ArrayList<Acessos> lista = new ArrayList<Acessos>();
            
    	try {
        	conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{?= call ACESSOS_GETS(?,?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, acesso.getCodAcesso());
            cstm.setString(3, acesso.getDescricao());
            cstm.execute();
            rset = cstm.getResultSet();

            while(rset.next()){
            	acesso = new Acessos();
            	acesso.setCodAcesso(rset.getInt("CODACESSO"));
            	acesso.setDescricao(rset.getString("DESCRICAO"));
            	acesso.setAdm(rset.getInt("ADM"));
            	acesso.setQuadras(rset.getInt("QUADRAS"));
//            	acesso.setTipoQuadras(rset.getInt("TIPOS_QUADRAS"));
//            	acesso.setFilasEspera(rset.getInt("FILAS_DE_ESPERA"));
            	acesso.setReservas(rset.getInt("RESERVAS"));
            	acesso.setManutencoes(rset.getInt("MANUTENCOES"));
            	acesso.setItens(rset.getInt("ITENS_MANUTENCOES"));
//            	acesso.setColetas(rset.getInt("COLETAS"));
            	acesso.setRelatorios(rset.getInt("RELATORIOS"));
            	
                lista.add(acesso);
            }
            
        } catch (SQLException ex) {
            throw new RuntimeException("Erro ao consultar uma lista de Acessos. Origem="+ex.getMessage());
        }finally{
          ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        return lista;
    }
    
    public Acessos buscaAcesso(Acessos acesso){

    	try {
        	conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{?= call ACESSOS_GETS(?,?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, acesso.getCodAcesso());
            cstm.setString(3, acesso.getDescricao());
            cstm.execute();
            rset = cstm.getResultSet();

            while(rset.next()){
            	acesso.setCodAcesso(rset.getInt("CODACESSO"));
            	acesso.setDescricao(rset.getString("DESCRICAO"));
            	acesso.setAdm(rset.getInt("ADM"));
            	acesso.setQuadras(rset.getInt("QUADRAS"));
//            	acesso.setTipoQuadras(rset.getInt("TIPOS_QUADRAS"));
//            	acesso.setFilasEspera(rset.getInt("FILAS_DE_ESPERA"));
            	acesso.setReservas(rset.getInt("RESERVAS"));
            	acesso.setManutencoes(rset.getInt("MANUTENCOES"));
            	acesso.setItens(rset.getInt("ITENS_MANUTENCOES"));
//            	acesso.setColetas(rset.getInt("COLETAS"));
            	acesso.setRelatorios(rset.getInt("RELATORIOS"));
            }
            
        } catch (SQLException ex) {
            throw new RuntimeException("Erro ao consultar uma lista de Acessos. Origem="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);//Não fechar a conexão, pois o continua no BuscaFuncionario
        }
        return acesso;
    }
}