package br.com.gestor.dao;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.ArrayList;
import java.util.List;

import br.com.gestor.bean.Itens;
import br.com.gestor.model.ConnectionFactory;

public class ItensDao extends ConnectionFactory{

    private Connection conn = null;
    private CallableStatement cstm = null;
    private PreparedStatement pstm = null;
    private ResultSet rset = null;

    public int deletar(Itens item) {
    	int qtdeUpd = 0;
        try{
            conn = ConnectionFactory.abrirConexoes();

            cstm = conn.prepareCall("{ ? = call ITEM_DELETE(?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, item.getCodItem());

            qtdeUpd = cstm.executeUpdate();
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
    	return qtdeUpd;
    }

    public int cadastrar(Itens item) {
    	int qtdeUpd = 0;
    	try{
            conn = ConnectionFactory.abrirConexoes();

            cstm = conn.prepareCall("{ ? = call ITEM_INSERT(?,?,?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, item.getCodItem());
            cstm.setString(3, item.getDescricao());
            cstm.setFloat(4, item.getValor());

            qtdeUpd = cstm.executeUpdate();

    	} catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
    	return qtdeUpd;
    }

    public ArrayList<Itens> listarItens(Itens item){
    	ArrayList<Itens> lista = new ArrayList<>();
        try{
            conn = ConnectionFactory.abrirConexoes();

            cstm = conn.prepareCall("{ ? = call ITEM_GETS(?,?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, item.getCodItem());
            cstm.setString(3, item.getDescricao());

            cstm.execute();
            rset = cstm.getResultSet();

            while(rset.next()){
                Itens itens = new Itens(rset.getString("descricao"), rset.getFloat("valor"));
                itens.setCodItem(rset.getInt("codItem"));
                lista.add(itens);
            }
            return lista;
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
     }

    public Itens buscarItem(Itens item){
        try{
            conn = ConnectionFactory.abrirConexoes();

            cstm = conn.prepareCall("{ ? = call ITEM_GETS(?,?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, item.getCodItem());
            cstm.setString(3, item.getDescricao());

            cstm.execute();
            rset = cstm.getResultSet();

            while(rset.next()){
                item = new Itens(rset.getString("descricao"), rset.getFloat("valor"));
                item.setCodItem(rset.getInt("codItem"));
            }
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        
        return item;
     }
}