package br.com.gestor.dao;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.ArrayList;
import java.util.Date;

import org.apache.log4j.Logger;

import br.com.gestor.bean.Quadras;
import br.com.gestor.bean.TipoQuadra;
import br.com.gestor.model.ConnectionFactory;


public class QuadrasDao extends ConnectionFactory{

    private static Connection conn = null;
    private static CallableStatement cstm = null;
    private static PreparedStatement pstm = null;
    private static ResultSet rset = null;
    static Logger log = Logger.getLogger(QuadrasDao.class);

    public int excluirDoBancoQuadras(Quadras quadra) {

    	int qtdeUpd = 0;//n de registros removidos
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call QUADRA_DELETE(?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, quadra.getCodQuadra());
            
            qtdeUpd = cstm.executeUpdate();
            
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
    	return qtdeUpd;
    }

	public int pesquisaTipoPorCodigo(String tipoDescrito) {

		int tipo = 0;
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call TIPO_QUADRA_GET_COD(?) }");
            cstm.registerOutParameter(1, Types.NVARCHAR);
            cstm.setString(2, tipoDescrito);

            cstm.execute();
            rset = cstm.getResultSet();
            while(rset.next()){
            	tipo = rset.getInt(1);//Somente o primeiro retornado
            }
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
    	return tipo;
	}

	public TipoQuadra pesquisaTipo(TipoQuadra tipo){
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call TIPO_QUADRA_GET(?, ?) }");
            cstm.registerOutParameter(1, Types.NVARCHAR);
            cstm.setInt(2, tipo.getCodTipo());
            cstm.setString(3, tipo.getDescricao());

            cstm.execute();
            rset = cstm.getResultSet();
            if(rset.next()){
            	tipo.setCodTipo(rset.getInt("CODTIPO"));
            	tipo.setDescricao(rset.getString("DESCRICAO"));
            }
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
    	return tipo;
    }

	public int gravarNoBancoQuadra(Quadras quadra) {
    	int qtdeUpd = 0;
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call QUADRA_INSERT(?, ?, ?, ?, ?) }");//@check = QUADRA_INSERT @TIPO, @DESCRICAO, @SITUACAO, @COBERTA
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, quadra.getCodQuadra());
            cstm.setInt(3, quadra.getTipo());
            cstm.setString(4, quadra.getDescricao());
            cstm.setString(5, String.valueOf(quadra.geteDisponivel()).substring(0,1));//1caracter
            cstm.setString(6, String.valueOf(quadra.geteCoberta()).substring(0,1));//1caracter

            qtdeUpd = cstm.executeUpdate();
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
    	return qtdeUpd;
    }

	public int gravarNoBancoTipoQuadra(TipoQuadra tipo) {
    	int qtdeUpd = 0;
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call TIPO_QUADRA_INSERT(?) }");//@check = TIPO_QUADRA_INSERT @DESCRICAO
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setString(2, tipo.getDescricao());

            qtdeUpd = cstm.executeUpdate();
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
    	return qtdeUpd;
	}

    public ArrayList<Quadras> listarTodasQuadras(){

    	ArrayList<Quadras> lista = new ArrayList<>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call QUADRA_GETS }");
            cstm.registerOutParameter(1, Types.INTEGER);
            boolean sucesso = cstm.execute();

            rset = cstm.getResultSet();
            while(rset.next()){//CODQUADRA TIPO DESCRICAO SITUACAO COBERTA CODTIPO ESPORTE
            	Quadras quadras = new Quadras(rset.getInt("CODQUADRA"), rset.getInt("TIPO"), rset.getString("DESCRICAO"), rset.getInt("SITUACAO"), rset.getInt("COBERTA"), null);
            	quadras.setEsporte(rset.getString("ESPORTE"));
            	lista.add(quadras);
            }

        } catch (Exception ex) {
        	log.error(ex.getMessage(), new SQLException(ex.getMessage()));
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        return lista;
     }

    public ArrayList<Quadras> listarsQuadrasPorTipo(int pktipo){

    	ArrayList<Quadras> lista = new ArrayList<>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call QUADRA_GET(?) }");//Nao tem o esporte==tipoquadra.descricao
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, pktipo);
            boolean sucesso = cstm.execute();

            rset = cstm.getResultSet();
            while(rset.next()){
            	Quadras quadras = new Quadras(rset.getInt("CODQUADRA"), rset.getInt("TIPO"), rset.getString("DESCRICAO"), rset.getInt("SITUACAO"), rset.getInt("COBERTA"), null);
            	lista.add(quadras);
            }

        } catch (Exception ex) {
        	log.error(ex.getMessage(), new SQLException(ex.getMessage()));
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        return lista;
     }

    public ArrayList<TipoQuadra> listarTodosTiposQuadras(){

    	ArrayList<TipoQuadra> lista = new ArrayList<TipoQuadra>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call TIPO_QUADRA_GETS() }");
            cstm.registerOutParameter(1, Types.INTEGER);
            boolean sucesso = cstm.execute();

            rset = cstm.getResultSet();
            while(rset.next()){
            	TipoQuadra tipo = new TipoQuadra();
            	tipo.setCodTipo(Integer.parseInt(rset.getString("CODTIPO")));
                tipo.setDescricao(rset.getString("DESCRICAO"));
                lista.add(tipo);
            }
        } catch (Exception ex) {
        	log.error(ex.getMessage(), new SQLException(ex.getMessage()));
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        return lista;
    }
    
    public ArrayList<Quadras> pesquisarPorTipoListarTodasQuadras(String esporte){

    	ArrayList<Quadras> lista = new ArrayList<>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call QUADRA_GET_TIPO(?) }");//Nao tem o esporte==tipoquadra.descricao
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setString(2, esporte);
            boolean sucesso = cstm.execute();
            
            rset = cstm.getResultSet();
            if(rset!=null){
	            while(rset.next()){
	            	
	            	Quadras quadras = new Quadras(rset.getInt("CODQUADRA"), rset.getInt("TIPO"), rset.getString("DESCRICAO"), rset.getInt("COBERTA"), rset.getInt("SITUACAO"), null);
	            	quadras.setEsporte(rset.getString("ESPORTE"));
	            	lista.add(quadras);
	            }
            }

        } catch (Exception ex) {
        	log.error(ex.getMessage(), new SQLException(ex.getMessage()));
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        return lista;
    } 
    
    public ArrayList<Quadras> pesquisarPorQuadrasDisponiveisViaHORA(String esporte, Date horaInicial, Date horaFinal){

    	ArrayList<Quadras> lista = new ArrayList<>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call QUADRA_GET_HORA_DISPONIVEL(?,?,?) }");//Nao tem o esporte==tipoquadra.descricao
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setString(2, esporte);
            cstm.setTime(3, new java.sql.Time (horaInicial.getTime()));
        	cstm.setTime(4, new java.sql.Time (horaFinal.getTime()));
            boolean sucesso = cstm.execute();
            
            rset = cstm.getResultSet();
            if(rset!=null){
	            while(rset.next()){
	            	//SELECT DISTINCT QUADRAS.CODQUADRA, QUADRAS.DESCRICAO, QUADRAS.SITUACAO, TIPOS_QUADRAS.DESCRICAO AS ESPORTE
	            	int codQuadra = rset.getInt("CODQUADRA");
            		int tipo = -1;//rset.getInt("TIPO");
        			String descricao = rset.getString("DESCRICAO");
     				int eDisponivel = rset.getInt("SITUACAO");
					int eCoberta = -1;//rset.getInt("COBERTA");
					TipoQuadra tipoquadra = null;
	            	Quadras quadras = new Quadras(codQuadra, tipo, descricao, eDisponivel, eCoberta, tipoquadra);
	            	//quadras.setEsporte(rset.getString("ESPORTE"));
	            	lista.add(quadras);
	            }
            }

        } catch (Exception ex) {
        	log.error(ex.getMessage(), new SQLException(ex.getMessage()));
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        return lista;
    }
    
    public ArrayList<Quadras> pesquisarPorQuadrasDisponiveisViaData(String esporte, Date dataInicial, Date dataFinal, Date horaInicial, Date horaFinal){

    	ArrayList<Quadras> lista = new ArrayList<>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call QUADRA_GET_DATA_DISPONIVEL(?,?,?,?,?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setString(2, esporte);
        	cstm.setDate(3, new java.sql.Date (dataInicial.getTime()));
        	cstm.setDate(4, new java.sql.Date (dataFinal.getTime()));
        	cstm.setTime(5, new java.sql.Time (horaInicial.getTime()));
        	cstm.setTime(6, new java.sql.Time (horaFinal.getTime()));
            boolean sucesso = cstm.execute();
            
            rset = cstm.getResultSet();
            if(rset!=null){
	            while(rset.next()){
	            	int codQuadra = rset.getInt("CODQUADRA");
        			String descricao = rset.getString("DESCRICAO");
     				int eDisponivel = rset.getInt("SITUACAO");
     				
	            	Quadras quadras = new Quadras(codQuadra, -1, descricao, eDisponivel, -1, null);
	            	lista.add(quadras);
	            }
            }

        } catch (Exception ex) {
        	log.error(ex.getMessage(), new SQLException(ex.getMessage()));
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        return lista;
    }

    @SuppressWarnings("finally")
	public Quadras buscarQuadra(String descQuadra){
    	Quadras quadra = null;
    	
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call QUADRA_GET_DESCRICAO(?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setString(2, descQuadra);
            boolean sucesso = cstm.execute();

            rset = cstm.getResultSet();
            while(rset.next()){
            	quadra = new Quadras(rset.getInt("CODQUADRA"), rset.getInt("TIPO"), rset.getString("DESCRICAO"), rset.getInt("SITUACAO"), rset.getInt("COBERTA"), null);
            	quadra.setEsporte(rset.getString("ESPORTE"));
            }

        } catch (Exception ex) {
        	log.error(ex.getMessage(), new SQLException(ex.getMessage()));
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
            return quadra;
        }
     }    
}
