﻿package br.com.gestor.dao;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Time;
import java.sql.Types;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import br.com.gestor.bean.Associados;
import br.com.gestor.bean.Escolinha;
import br.com.gestor.bean.Itens;
import br.com.gestor.bean.Manutencoes;
import br.com.gestor.bean.Quadras;
import br.com.gestor.bean.Reservas;
import br.com.gestor.bean.Torneio;
import br.com.gestor.model.ConnectionFactory;

public class ReservasDao extends ConnectionFactory{

/** PESQUISAR REGISTROS */
	private List<Quadras> pesquisaQuadrasReservadas(int codReserva, int codTipoReserva, String tipoReserva) {
		
	    Connection conn = null;
	    CallableStatement cstm = null;
	    ResultSet rset = null;
	    
		List<Quadras> quadras = new ArrayList<>();
	    try{
	        conn = ConnectionFactory.abrirConexoes();
	        cstm = conn.prepareCall("{ ? = call RESERVAS_QUADRAS_GET(?, ?, ?) }");
	        cstm.registerOutParameter(1, Types.INTEGER);
	        cstm.setInt(2, codReserva);
	        cstm.setInt(3, codTipoReserva);
	        cstm.setString(4, tipoReserva);
	        cstm.execute();
	
	        rset = cstm.getResultSet();
	        while(rset.next()){
	        	
	    		Quadras setquadraCOD = new Quadras();
	    		setquadraCOD.setCodQuadra(rset.getInt("CODQUADRA"));
	    		setquadraCOD.setEsporte(rset.getString("ESPORTE"));//IGUAL A TIPOS_QUADRAS[DESCRICAO] AS ESPORTE
	
	        	quadras.add(setquadraCOD);
	        }
	    } catch (Exception ex) {
	    	ex.printStackTrace();
	    }finally{
	    	//ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
	    }
	    
	    return quadras;
	}

/** LISTAR REGISTROS */
	public ArrayList<Reservas> listarReservasTorneios() {
	    
		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		ArrayList<Reservas> reservasLista = new ArrayList<>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call TORNEIO_GETS }");
            cstm.registerOutParameter(1, Types.INTEGER);
            boolean sucesso = cstm.execute();
            
            rset = cstm.getResultSet();
            while(rset.next()){

            	int codReserva = rset.getInt("CODRESERVA");
            	int codTipoReserva = rset.getInt("CODTIPO_RESERVA");
            	String tipoReserva = rset.getString("TIPO_RESERVA");
            	switch (tipoReserva) {
					case "T":
						tipoReserva = "Torneio";
						break;
					default:
						tipoReserva = "Outros";
				}
            	Date dataInicial = rset.getDate("DATA_INICIAL");
            	Date dataFinal = rset.getDate("DATA_FINAL");
            	Time horaInicial = rset.getTime("HORA_INICIAL");
            	Time horaFinal = rset.getTime("HORA_FINAL");  	
            	
            	Torneio torneio = new Torneio();
            	torneio.setCodTorneio(rset.getInt("CODTORNEIO"));
            	torneio.setDescricao(rset.getString("DESCRICAO"));
            	torneio.setDiaSemanaInicio(rset.getInt("SEM_INICIO"));
            	torneio.setDiaSemanaFinal(rset.getInt("SEM_FINAL"));            	
            	
            	List<Quadras> quadras = pesquisaQuadrasReservadas(codReserva, codTipoReserva, "T");

            	Reservas reserva = new Reservas(codReserva, tipoReserva, codTipoReserva, dataInicial, dataFinal, horaInicial, horaFinal, quadras, torneio, null, null, null);
            	reservasLista.add(reserva);
            	
            }
        } catch (Exception ex) {
        	ex.printStackTrace();
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }
        return reservasLista;
	}

	public ArrayList<Reservas> listarReservasEscolinhas() {
		
		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		ArrayList<Reservas> reservasLista = new ArrayList<>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call ESCOLINHA_GETS }");
            cstm.registerOutParameter(1, Types.INTEGER);
            boolean sucesso = cstm.execute();
            
            rset = cstm.getResultSet();
            while(rset.next()){

            	int codReserva = rset.getInt("CODRESERVA");
            	int codTipoReserva = rset.getInt("CODTIPO_RESERVA");
            	String tipoReserva = rset.getString("TIPO_RESERVA");
            	switch (tipoReserva) {
					case "E":
						tipoReserva = "Escolinha";
						break;
					default:
						tipoReserva = "Outros";
				}
            	Date dataInicial = rset.getDate("DATA_INICIAL");
            	Date dataFinal = rset.getDate("DATA_FINAL");
            	Time horaInicial = rset.getTime("HORA_INICIAL");
            	Time horaFinal = rset.getTime("HORA_FINAL");

            	Escolinha escolinha = new Escolinha();
            	escolinha.setCodEscolinha(rset.getInt("CODESCOLINHA"));
            	escolinha.setDescricao(rset.getString("DESCRICAO"));
            	escolinha.setDom(rset.getBoolean("DOM"));//false || true
            	escolinha.setSeg(rset.getBoolean("SEG"));
            	escolinha.setTer(rset.getBoolean("TER"));
            	escolinha.setQua(rset.getBoolean("QUA"));
            	escolinha.setQui(rset.getBoolean("QUI"));
            	escolinha.setSex(rset.getBoolean("SEX"));
            	escolinha.setSab(rset.getBoolean("SAB"));
            	
            	List<Quadras> quadras = pesquisaQuadrasReservadas(codReserva, codTipoReserva, "E");

            	Reservas reserva = new Reservas(codReserva, tipoReserva, codTipoReserva, dataInicial, dataFinal, horaInicial, horaFinal, quadras, null, escolinha, null, null);
            	reservasLista.add(reserva);
            	
            }
        } catch (Exception ex) {
        	ex.printStackTrace();
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }
        return reservasLista;
	}
	
	public ArrayList<Reservas> listarReservasParaAssociados() {
	    
		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		ArrayList<Reservas> reservasLista = new ArrayList<>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call RESERVAS_ASSOCIADOS_GET }");
            cstm.registerOutParameter(1, Types.INTEGER);
            boolean sucesso = cstm.execute();
            
            rset = cstm.getResultSet();
            while(rset.next()){

            	int codReserva = rset.getInt("CODRESERVA");
            	int codTipoReserva = rset.getInt("CODTIPO_RESERVA");
            	String tipoReserva = rset.getString("TIPO_RESERVA");
            	switch (tipoReserva) {
					case "A":
						tipoReserva = "Associados";
						break;
					default:
						tipoReserva = "Outros";
				}
            	Date dataInicial = rset.getDate("DATA_INICIAL");
            	Date dataFinal = rset.getDate("DATA_FINAL");
            	Time horaInicial = rset.getTime("HORA_INICIAL");
            	Time horaFinal = rset.getTime("HORA_FINAL");

            	int codAssociado = rset.getInt("CODSOCIO");
            	int matricula = rset.getInt("MATRICULA");
            	String categoria = rset.getString("CATEGORIA");

            	int numDependentes = rset.getInt("NUM_DEP");
            	String nome = rset.getString("NOME");
            	String sobrenome = rset.getString("SBNOME");
            	String celular = "";//rset.getString("CELULAR");
            	
            	Associados associados = new Associados(codAssociado, categoria, matricula, numDependentes, nome, sobrenome, celular);
            	
            	//RESERVAS_QUADRAS_GET(?, ?) - NOVA PROCEDURE BUSCANDO AS QUADRAS PARA ESTA RESERVA
            	List<Quadras> quadras = pesquisaQuadrasReservadas(codReserva, codTipoReserva, "A");
            	
            	Reservas reserva = new Reservas(codReserva, tipoReserva, codTipoReserva, dataInicial, dataFinal, horaInicial, horaFinal, quadras, null, null, associados, null);
            	reservasLista.add(reserva);
            	
            }
        } catch (Exception ex) {
        	ex.printStackTrace();
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }
        return reservasLista;
	}
	
	public ArrayList<Reservas> listarReservasParaManutencoes() {
	    
		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		ArrayList<Reservas> reservasLista = new ArrayList<>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call MANUTENCAO_GETS }");
            cstm.registerOutParameter(1, Types.INTEGER);
            boolean sucesso = cstm.execute();
            
            rset = cstm.getResultSet();
            while(rset.next()){

            	int codReserva = rset.getInt("CODRESERVA");
            	int codTipoReserva = rset.getInt("CODTIPO_RESERVA");
            	String tipoReserva = rset.getString("TIPO_RESERVA");
            	switch (tipoReserva) {
					case "M":
						tipoReserva = "Manutenções";
						break;
					default:
						tipoReserva = "Outros";
				}
            	Date dataInicial = rset.getDate("DATA_INICIAL");
            	Date dataFinal = rset.getDate("DATA_FINAL");
            	Time horaInicial = rset.getTime("HORA_INICIAL");
            	Time horaFinal = rset.getTime("HORA_FINAL");

            	int codIManutencao = rset.getInt("CODMANUTENCAO");
            	float valor_total = rset.getFloat("VALOR_TOTAL");

            	Manutencoes manutencao = new Manutencoes();
            	manutencao.setCodIManutencao(codIManutencao);
            	manutencao.setValor_total(valor_total);
            	
            	//RESERVAS_QUADRAS_GET(?, ?) - NOVA PROCEDURE BUSCANDO AS QUADRAS PARA ESTA RESERVA
            	List<Quadras> quadras = pesquisaQuadrasReservadas(codReserva, codTipoReserva, "M");
            	
            	Reservas reserva = new Reservas(codReserva, tipoReserva, codTipoReserva, dataInicial, dataFinal, horaInicial, horaFinal, quadras, null, null, null, manutencao);
            	reserva.setManutencoes(manutencao);
            	reservasLista.add(reserva);
            	
            }
        } catch (Exception ex) {
        	ex.printStackTrace();
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }
        return reservasLista;
	}
	
	public ArrayList<Associados> listarAssociadosDadosPessoais() {
	    
		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		ArrayList<Associados> reservasLista = new ArrayList<>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call ASSOCIADO_GETS }");
            cstm.registerOutParameter(1, Types.INTEGER);
            boolean sucesso = cstm.execute();
            
            rset = cstm.getResultSet();
            while(rset.next()){

            	int codAssociado = rset.getInt("CODASSOCIADO");
            	int matricula = rset.getInt("MATRICULA");
            	String categoria = rset.getString("CATEGORIA");
            	/*switch (categoria) {
					case "B":
						categoria = "BBB";
						break;
					case "R":
						categoria = "RRR";
						break;
					default:
						categoria = "Outros";
				}*/
            	int numDependentes = rset.getInt("NUM_DEP");
            	String nome = rset.getString("NOME");
            	String sobrenome = rset.getString("SOBRE_NOME");
            	String celular = rset.getString("CELULAR");
            	
            	
            	Associados associados = new Associados(codAssociado, categoria, matricula, numDependentes, nome, sobrenome, celular);
            	reservasLista.add(associados);
            	
            }
        } catch (Exception ex) {
        	ex.printStackTrace();
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }
        return reservasLista;
	}
	
	public ArrayList<Reservas> listarCalendarioReservas(){
		
		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		ArrayList<Reservas> reservasLista = new ArrayList<>();
        try{
        	//SELECT CODRESERVA, TIPO_RESERVA, DATA_INICIAL, DATA_FINAL, HORA_INICIAL, HORA_FINAL, DESCRICAO FROM RESERVAS 
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call RESERVA_GETS }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.execute();
            
            rset = cstm.getResultSet();
            while(rset.next()){

            	String descricao = "";
            	int codReserva = rset.getInt("CODRESERVA");//sem uso na jsp
            	int codTipoReserva = rset.getInt("CODTIPO_RESERVA");//sem uso na jsp
            	String tipoReserva = rset.getString("TIPO_RESERVA");
            	switch (tipoReserva) {
					case "T":
						tipoReserva = "Torneio";
						descricao = rset.getString("DESCRICAO");
						break;
					case "E":
						tipoReserva = "Escolinha";
						descricao = rset.getString("DESCRICAO");
						break;
					case "A":
						tipoReserva = "Associado";
						descricao = "Associado";//nao tem coluna descricao
						break;
					case "M":
						tipoReserva = "Manutencao";//SEM ACENTO
						descricao = "Manutencao";//nao tem coluna descricao
						break;
					default:
						tipoReserva = "Outros";
						descricao = "Outros";
				}
            	Date dataInicial = rset.getDate("DATA_INICIAL");
            	Date dataFinal = rset.getDate("DATA_FINAL");
            	Time horaInicial = rset.getTime("HORA_INICIAL");
            	Time horaFinal = rset.getTime("HORA_FINAL");  	

            	Reservas reserva = new Reservas(codReserva, tipoReserva, codTipoReserva, dataInicial, dataFinal, horaInicial, horaFinal, null, null, null, null, null);
            	reserva.setDescricao(descricao);
            	
            	reservasLista.add(reserva);            	
            }
        } catch (Exception ex) {
        	ex.printStackTrace();
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }
        return reservasLista;
	}
	
/** EXCLUIR REGISTROS */
	public int excluirRegistroReserva(int codReserva) {
		
		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		int qtdeUpd = 0;
        try{
        	conn = ConnectionFactory.abrirConexoes();
        	cstm = conn.prepareCall("{ ? = call RESERVAS_QUADRAS_DEL(?) }");
        	cstm.registerOutParameter(1, Types.INTEGER);
        	cstm.setInt(2, codReserva);
        	qtdeUpd = cstm.executeUpdate();//QTDE de registros removidos
        	
            cstm = conn.prepareCall("{ ? = call RESERVA_DEL(?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, codReserva);
            qtdeUpd = cstm.executeUpdate();//QTDE de registros removidos

            //NAO SERAO EXCLUIDAS AS ESCOLINHAS E TORNEIOS, DE INICIO, AVALIAR
            
        } catch (Exception ex) {
        	ex.printStackTrace();
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }
		
		return qtdeUpd;
	}

/** CADASTRAR REGISTROS */
	public int cadastrarReservasTorneios(Reservas novareserva) {

		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		int qtdeUpd = 0;//qtde registros modificados com sucesso
        try{
        	conn = ConnectionFactory.abrirConexoes();
        conn.setAutoCommit(false);//PERMITE ROLLBACK, nao execute como transacoes independentes        	
        	
    	//Verifica se tem conflito de datas
    	int Data_flagConflitoUM = conflitoEntre_Datas(novareserva);
    	int Hora_flagConflitoUM = conflitoEntre_Horas(novareserva);
        
        	cstm = conn.prepareCall("{ ? = call TORNEIO_ADD(?,?,?) }");
        	cstm.registerOutParameter(1, Types.INTEGER);
        	cstm.setString(2, novareserva.getTorneio().getDescricao());
        	cstm.setInt(3, novareserva.getTorneio().getDiaSemanaInicio());//1 a 7, nao aceita zero
        	cstm.setInt(4, novareserva.getTorneio().getDiaSemanaFinal());//1 a 7
        	cstm.executeUpdate();
        	final int primaryKeyInsertedONE = cstm.getInt(1);
    		/*
        	System.out.println(UtilDatas.DateParaString(novareserva.getDataInicial(), "dd/MM/yyyy HH:mm:ss:SSS"));
        	
        	//Adiciona as horas selecionadas a data de intervalo dos torneios
        	String horaInicialParam = UtilDatas.DateParaString(novareserva.getHoraInicial(), "HH:mm");
        	novareserva.setDataInicial(UtilDatas.AlterarHoraStringemDate(novareserva.getDataInicial(), horaInicialParam));
        	//Adiciona tambem a data final do torneio
        	String horaFinalParam = UtilDatas.DateParaString(novareserva.getHoraFinal(), "HH:mm");
        	novareserva.setDataFinal(UtilDatas.AlterarHoraStringemDate(novareserva.getDataFinal(), horaFinalParam));

        	System.out.println(UtilDatas.DateParaString(novareserva.getDataInicial(), "dd/MM/yyyy HH:mm:ss:SSS"));
        	*/      	
        	
        	cstm = conn.prepareCall("{ ? = call RESERVA_ADD(?,?,?,?,?,?,?) }");
        	cstm.registerOutParameter(1, Types.INTEGER);
        	cstm.setInt(2, novareserva.getCodReserva());//PK, SE EXISTIR É UM UPDATE SET NA TABELA
        	cstm.setString(3, novareserva.getTipoReserva());
        	cstm.setInt(4, primaryKeyInsertedONE);
        	cstm.setDate(5, new java.sql.Date (novareserva.getDataInicial().getTime()));
        	cstm.setDate(6, new java.sql.Date (novareserva.getDataFinal().getTime()));
        	cstm.setTime(7, new java.sql.Time (novareserva.getHoraInicial().getTime()));//REMOVER DO CODIGO E DA TABELA
        	cstm.setTime(8, new java.sql.Time (novareserva.getHoraFinal().getTime()));//REMOVER DO CODIGO E DA TABELA
        	cstm.executeUpdate();
        	final int primaryKeyInsertedTWO = cstm.getInt(1);

        	//INSERIR NA TABELA RESERVAS_QUADRAS
        	int primaryKeyInsertedTHREE = 0;
        	List<Quadras> listaQuadras = novareserva.getQuadras();
        	for (Quadras quadras : listaQuadras) {
				int numCodQuadra = quadras.getCodQuadra();
				
	        	cstm = conn.prepareCall("{ ? = call RESERVAS_QUADRAS_ADD(?,?,?) }");
	        	cstm.registerOutParameter(1, Types.INTEGER);
	        	cstm.setInt(2, numCodQuadra);
	        	cstm.setInt(3, primaryKeyInsertedTWO);
	        	cstm.setString(4, novareserva.getTipoReserva());
	        	cstm.executeUpdate();
	        	primaryKeyInsertedTHREE = cstm.getInt(1);
        	}
        	
        	if (primaryKeyInsertedONE > 0 && primaryKeyInsertedTWO > 0 && primaryKeyInsertedTHREE > 0){
            	if(Data_flagConflitoUM == 0 && Hora_flagConflitoUM == 0){
            		qtdeUpd = 1;//TRUE, inserido com sucesso
            		conn.commit();//SE TUDO OCORREU BEM, COMMIT E EFETUE AS TRANSACOES
            	}else{
            		System.out.println("\n\nOCORREU CONFLITO DE DATA E/OU HORA\n");
            		conn.rollback();//SE OCORREU ERRO ROLLBACK DAS TRANSACOES
            	}
        	}else{
				conn.rollback();//SE OCORREU ERRO ROLLBACK DAS TRANSACOES
        	}
        } catch (Exception e) {
        	try {
				conn.rollback();//SE OCORREU ERRO ROLLBACK DAS TRANSACOES
			} catch (SQLException ex) {
				ex.printStackTrace();
			}
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }

		return qtdeUpd;
	}

	public int cadastrarReservasEscolinhas(Reservas novareserva) {
		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		int qtdeUpd = 0;//qtde registros modificados com sucesso
        try{
        	//INSERIR NA TABELA ESCOLINHA
        	conn = ConnectionFactory.abrirConexoes();
        	cstm = conn.prepareCall("{ ? = call ESCOLINHA_ADD(?,?,?,?,?,?,?,?) }");
        	cstm.registerOutParameter(1,  Types.INTEGER);
        	cstm.setString(2, novareserva.getEscolinha().getDescricao());
        	cstm.setInt(3, novareserva.getEscolinha().getDom());
        	cstm.setInt(4, novareserva.getEscolinha().getSeg());
        	cstm.setInt(5, novareserva.getEscolinha().getTer());
        	cstm.setInt(6, novareserva.getEscolinha().getQua());
        	cstm.setInt(7, novareserva.getEscolinha().getQui());
        	cstm.setInt(8, novareserva.getEscolinha().getSex());
        	cstm.setInt(9, novareserva.getEscolinha().getSab());
        	cstm.executeUpdate();
        	final int primaryKeyInsertedONE = cstm.getInt(1);

        	//INSERIR NA TABELA RESERVAS        	
        	cstm = conn.prepareCall("{ ? = call RESERVA_ADD(?,?,?,?,?,?,?) }");
        	cstm.registerOutParameter(1, Types.INTEGER);
        	cstm.setInt(2, novareserva.getCodReserva());//PK, SE EXISTIR É UM UPDATE SET NA TABELA
        	cstm.setString(3, novareserva.getTipoReserva()); 
        	cstm.setInt(4, primaryKeyInsertedONE);
        	cstm.setDate(5, new java.sql.Date (novareserva.getDataInicial().getTime()));
        	cstm.setDate(6, new java.sql.Date (novareserva.getDataFinal().getTime()));
        	cstm.setTime(7, new java.sql.Time (novareserva.getHoraInicial().getTime()));
        	cstm.setTime(8, new java.sql.Time (novareserva.getHoraFinal().getTime()));
        	cstm.executeUpdate();
        	final int primaryKeyInsertedTWO = cstm.getInt(1);

        	//INSERIR NA TABELA RESERVAS_QUADRAS
        	int primaryKeyInsertedTHREE = 0;
        	List<Quadras> listaQuadras = novareserva.getQuadras();
        	for (Quadras quadras : listaQuadras) {
				int numCodQuadra = quadras.getCodQuadra();
				
	        	cstm = conn.prepareCall("{ ? = call RESERVAS_QUADRAS_ADD(?,?,?) }");
	        	cstm.registerOutParameter(1, Types.INTEGER);
	        	cstm.setInt(2, numCodQuadra);
	        	cstm.setInt(3, primaryKeyInsertedTWO);
	        	cstm.setString(4, novareserva.getTipoReserva());
	        	cstm.executeUpdate();
	        	primaryKeyInsertedTHREE = cstm.getInt(1);
        	}
        	
        	if (primaryKeyInsertedTWO > 0)//primaryKeyInsertedONE > 0 &&  && primaryKeyInsertedTHREE > 0
        		qtdeUpd = primaryKeyInsertedTWO;//TRUE, inserido com sucesso
        } catch (Exception ex) {
        	ex.printStackTrace();
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }

		return qtdeUpd;
	}

	public int cadastrarReservasAssociados(Reservas novareserva) {

		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		int qtdeUpd = 0;//qtde registros modificados com sucesso
        try{
        	conn = ConnectionFactory.abrirConexoes();
        	
        	cstm = conn.prepareCall("{ ? = call RESERVA_ADD(?,?,?,?,?,?,?) }");
        	cstm.registerOutParameter(1, Types.INTEGER);
        	cstm.setInt(2, novareserva.getCodReserva());//PK, SE EXISTIR É UM UPDATE SET NA TABELA
        	cstm.setString(3, novareserva.getTipoReserva());//TIPO SEMPRE SERA 'A' inicial de Associado
        	cstm.setInt(4, novareserva.getAssociados().getMatricula());//CODIGO DO ASSOCIADO, SUA MATRICULA
        	cstm.setDate(5, new java.sql.Date (novareserva.getDataInicial().getTime()));
        	cstm.setDate(6, new java.sql.Date (novareserva.getDataFinal().getTime()));
        	cstm.setTime(7, new java.sql.Time (novareserva.getHoraInicial().getTime()));
        	cstm.setTime(8, new java.sql.Time (novareserva.getHoraFinal().getTime()));
        	cstm.executeUpdate();
        	final int primaryKeyInsertedONE = cstm.getInt(1);//codigo da PK que foi inserido

        	//INSERIR NA TABELA RESERVAS_QUADRAS
        	int primaryKeyInsertedTWO = 0;
        	List<Quadras> listaQuadras = novareserva.getQuadras();
        	for (Quadras quadras : listaQuadras) {
				int numCodQuadra = quadras.getCodQuadra();
				
	        	cstm = conn.prepareCall("{ ? = call RESERVAS_QUADRAS_ADD(?,?,?) }");
	        	cstm.registerOutParameter(1, Types.INTEGER);
	        	cstm.setInt(2, numCodQuadra);
	        	cstm.setInt(3, primaryKeyInsertedONE);
	        	cstm.setString(4, novareserva.getTipoReserva());
	        	cstm.executeUpdate();
	        	primaryKeyInsertedTWO = cstm.getInt(1);
        	}
        	
        	if (primaryKeyInsertedONE > 0 && primaryKeyInsertedTWO > 0)
        		qtdeUpd = 1;//TRUE, inserido com sucesso
        } catch (Exception ex) {
        	ex.printStackTrace();
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }

		return qtdeUpd;		
	}
	
	@SuppressWarnings("resource")
	public int cadastrarReservasManutencoes(Reservas novareserva) {

		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		int qtdeUpd = 0;//qtde registros modificados com sucesso
        try{
        	conn = ConnectionFactory.abrirConexoes();

        	//INSERIR NA TABELA MANUTENÇÃO
        	conn = ConnectionFactory.abrirConexoes();
        	cstm = conn.prepareCall("{ ? = call MANUTENCAO_INSERT(?) }");
        	cstm.registerOutParameter(1,  Types.INTEGER);
        	cstm.setFloat(2, novareserva.getManutencoes().getValor_total());
        	cstm.executeUpdate();
        	novareserva.setCodTipoReserva(cstm.getInt(1));
        	novareserva.getManutencoes().setCodIManutencao(cstm.getInt(1));

        	//INSERIR NA TABELA ITENS DE MANUTENÇÕES
            for (int i = 0; i < novareserva.getManutencoes().getQtd().size(); i++){
  		        cstm = conn.prepareCall("{ ? = call ITEM_MANUTENCAO_INSERT(?,?,?,?) }");
  		        cstm.registerOutParameter(1, Types.INTEGER);
  		        cstm.setFloat(2, novareserva.getManutencoes().getCodIManutencao());
  		        cstm.setInt(3, novareserva.getManutencoes().getItensManutencao().get(i).getCodItem() );
  		        cstm.setInt(4, novareserva.getManutencoes().getQtd().get(i) );
  		        cstm.setFloat(5, novareserva.getManutencoes().getItensManutencao().get(i).getValor() );
  		        cstm.execute();
  	        	cstm.clearParameters();
  	        }
            
        	//INSERIR NA TABELA RESERVAS        	
        	cstm = conn.prepareCall("{ ? = call RESERVA_ADD(?,?,?,?,?,?,?) }");
        	cstm.registerOutParameter(1, Types.INTEGER);
        	cstm.setInt(2, novareserva.getCodReserva());//PK, SE EXISTIR É UM UPDATE SET NA TABELA
        	cstm.setString(3, novareserva.getTipoReserva());//TIPO SEMPRE SERA 'A' inicial de Associado
        	cstm.setInt(4, novareserva.getCodTipoReserva());//CODIGO DO ASSOCIADO, SUA MATRICULA
        	cstm.setDate(5, new java.sql.Date (novareserva.getDataInicial().getTime()));
        	cstm.setDate(6, new java.sql.Date (novareserva.getDataFinal().getTime()));
        	cstm.setTime(7, new java.sql.Time (novareserva.getHoraInicial().getTime()));
        	cstm.setTime(8, new java.sql.Time (novareserva.getHoraFinal().getTime()));
        	cstm.executeUpdate();
        	final int primaryKeyInsertedONE = cstm.getInt(1);

        	//INSERIR NA TABELA RESERVAS_QUADRAS
        	List<Quadras> listaQuadras = novareserva.getQuadras();
        	for (Quadras quadras : listaQuadras) {
				int numCodQuadra = quadras.getCodQuadra();
				
	        	cstm = conn.prepareCall("{ ? = call RESERVAS_QUADRAS_ADD(?,?,?) }");
	        	cstm.registerOutParameter(1, Types.INTEGER);
	        	cstm.setInt(2, numCodQuadra);
	        	cstm.setInt(3, primaryKeyInsertedONE);
	        	cstm.setString(4, novareserva.getTipoReserva());
	        	cstm.executeUpdate();
        	}
        	
        	if (primaryKeyInsertedONE >= 0)
        		qtdeUpd = 1;//TRUE, inserido com sucesso
        } catch (Exception ex) {
        	ex.printStackTrace();
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }
		return qtdeUpd;		
	}

	public int conflitoEntre_Datas(Reservas novareserva){

		Connection conn = null;
		CallableStatement cstm = null;
		int statusAfterCommit = 0;
        try{
        	conn = ConnectionFactory.abrirConexoes();

			cstm = conn.prepareCall("{ ? = call dbo.fn_Datas_EmConflito(?,?) }");
			cstm.registerOutParameter(1, Types.INTEGER);//RETURN 1 SE TEM CONFLITO, ZERO SE ESTA LIVRE O HORARIO
        	cstm.setDate(2, new java.sql.Date (novareserva.getDataInicial().getTime()));
        	cstm.setDate(3, new java.sql.Date (novareserva.getDataFinal().getTime()));
			cstm.executeUpdate();
			final int getRowsNumber = cstm.getInt(1);
			
        	if (getRowsNumber > 0)
        		statusAfterCommit = 1;//TRUE == 1, EXISTE CONFLITO
        } catch (Exception ex) {
			ex.printStackTrace();
        }finally{
        	//nao fechar a conexao
        }
		return statusAfterCommit;
	}
	
	public int conflitoEntre_Horas(Reservas novareserva){

		Connection conn = null;
		CallableStatement cstm = null;
		int statusAfterCommit = 0;
        try{
        	conn = ConnectionFactory.abrirConexoes();

			cstm = conn.prepareCall("{ ? = call dbo.fn_Horas_EmConflito(?,?) }");
			cstm.registerOutParameter(1, Types.INTEGER);//RETURN 0 SIM tem conflito, 1 NÃO TEM CONFLITO
        	cstm.setTime(2, new java.sql.Time (novareserva.getHoraInicial().getTime()));
        	cstm.setTime(3, new java.sql.Time (novareserva.getHoraFinal().getTime()));
			cstm.executeUpdate();
			final int getRowsNumber = cstm.getInt(1);
			
        	if (getRowsNumber > 0)
        		statusAfterCommit = 1;//1 = HORARIO LIVRE
        	
        } catch (Exception ex) {
			ex.printStackTrace();
        }finally{
        	//nao fechar a conexao
        }
		return statusAfterCommit;
	}	

	public Associados BuscaAssociado(Associados associado){
		Connection conn = null;
		CallableStatement cstm = null;
		ResultSet rset = null;
		
    	try{
            conn = ConnectionFactory.abrirConexoes();

            cstm = conn.prepareCall("{ ? = call ASSOCIADO_GET(?,?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setString(2, associado.getCategoria() );
            cstm.setInt(3, associado.getMatricula());

            cstm.execute();
            rset = cstm.getResultSet();

            if(rset.next()){
                associado.setNome(rset.getString("nome"));
                associado.setSobrenome(rset.getString("sbnome"));
            }

    	} catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, null, conn);
        }
    	return associado;
	}
}