package br.com.gestor.dao;

import java.io.InputStream;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

import br.com.gestor.bean.Acessos;
import br.com.gestor.bean.Usuario;
import br.com.gestor.model.ConnectionFactory;
import br.com.gestor.model.Criptografia;

//http://blog.caelum.com.br/guardando-senhas-criptografadas-em-java/

public class UsuarioDao {

    private static Connection conn = null;
    private static CallableStatement cstm = null;
    private static PreparedStatement pstm = null;
    private static ResultSet rset = null;
    static Logger log = Logger.getLogger(QuadrasDao.class);
    
	public Usuario pesquisaUsuarioeSenha(String matricula, String senha) {

		Usuario usuario = null; 
		String senhaCrypto = Criptografia.MD5(senha);
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call USUARIO_GET_LOGIN(?, ?) }");
            cstm.registerOutParameter(1, Types.NVARCHAR);
            cstm.setString(2, matricula);
            cstm.setString(3, senhaCrypto);

            cstm.execute();
            cstm.execute();
            rset = cstm.getResultSet();
            if(rset.next()){
            	if( senhaCrypto.equalsIgnoreCase(rset.getString("SENHA"))){
            		//existe um usuario com essa senha, adicione a um bean usuario, null nao existe o usuario na base
            		usuario = new Usuario(rset.getInt("matricula"), rset.getString("nome"), null, rset.getString("senha"));
            		
            		Acessos acesso = new Acessos();
            		acesso.setCodAcesso( rset.getInt("acesso"));
            		acesso = new AcessosDao().listarAcessos(acesso).get(0);
            		
            		usuario.setAcesso(acesso);
            	}
            }
        } catch (Exception ex) {
        	log.error(ex.getMessage(), new SQLException(ex.getMessage()));
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        return usuario;
	}
	
	public ArrayList<Usuario> BuscarUsuarios(){

		ArrayList<Usuario> lista = new ArrayList<Usuario>();
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call USUARIOS_GETS }");
            cstm.registerOutParameter(1, Types.NVARCHAR);

            cstm.execute();
            rset = cstm.getResultSet();
            while(rset.next()){
            	Usuario usuario = new Usuario();
            	usuario.setMatricula(rset.getInt("MATRICULA"));
            	usuario.setNome(rset.getString("NOME"));
            	
            	if (rset.getInt("acesso") != 0){
	        		Acessos acesso = new Acessos();
	        		acesso.setCodAcesso( rset.getInt("acesso"));
	                
	            	usuario.setAcesso(acesso);
            	}

            	lista.add(usuario);
            }
        } catch (Exception ex) {
        	log.error(ex.getMessage(), new SQLException(ex.getMessage()));
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        return lista;
	}

	public Usuario BuscarUsuario(Usuario usuario){

        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call USUARIOS_GETS(?) }");
            cstm.registerOutParameter(1, Types.NVARCHAR);
            cstm.setInt(2, usuario.getMatricula());

            cstm.execute();
            rset = cstm.getResultSet();
            if(rset.next()){
            	usuario.setMatricula(rset.getInt("MATRICULA"));
            	usuario.setNome(rset.getString("NOME"));
            	
        		Acessos acesso = new Acessos();
        		acesso.setCodAcesso( rset.getInt("ACESSO"));
        		acesso.buscar();
                
            	usuario.setAcesso(acesso);
            }else{
            	usuario.setNome("NÃO ENCONTRADO");
            }
        } catch (Exception ex) {
        	log.error(ex.getMessage(), new SQLException(ex.getMessage()));
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        return usuario;
	}

	public String BuscarFuncionario(int matricula){

		String nome = "";
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call BUSCA_FUNCIONARIO(?) }");
            cstm.registerOutParameter(1, Types.NVARCHAR);
            cstm.setInt(2, matricula);

            cstm.execute();
            rset = cstm.getResultSet();
            if(rset.next()){
            	nome = rset.getString("NOME");
            }else{
            	nome = "NÃO ENCONTRADO";
            }
        } catch (Exception ex) {
        	log.error(ex.getMessage(), new SQLException(ex.getMessage()));
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
        return nome;
	}
	
	public int deletar(Usuario usuario){
		int qtdeUpd = 0;
        try{
            conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{ ? = call USUARIO_DELETE(?) }");
            cstm.registerOutParameter(1, Types.NVARCHAR);
            cstm.setInt(2, usuario.getMatricula());

            qtdeUpd = cstm.executeUpdate();
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
    	return qtdeUpd;
	}
	
    public int cadastrar(Usuario usuario){
    	int qtdeUpd = 0;
		String senhaCrypto = Criptografia.MD5(usuario.getSenha());
    	try {
        	conn = ConnectionFactory.abrirConexoes();
            cstm = conn.prepareCall("{?= call USUARIO_INSERT(?,?,?,?) }");
            cstm.registerOutParameter(1, Types.INTEGER);
            cstm.setInt(2, usuario.getMatricula());
            cstm.setString(3, usuario.getNome());
            cstm.setInt(4, usuario.getAcesso().getCodAcesso());
            cstm.setString(5, senhaCrypto);

            qtdeUpd = cstm.executeUpdate();
        } catch (SQLException ex) {
            throw new RuntimeException("Erro na consulta SQL ="+ex.getMessage());
        }finally{
        	ConnectionFactory.fecharConexoes(rset, cstm, pstm, conn);
        }
    	return qtdeUpd;
    }
}