package br.com.gestor.servlet;

/**
    Document: .TestServlet
    Created on : Nov 5, 2016, 9:28:18 PM
    Author     :
*/

import java.io.IOException;
import java.util.ArrayList;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.com.gestor.bean.Acessos;
import br.com.gestor.bean.Usuario;
import br.com.gestor.dao.AcessosDao;
import br.com.gestor.dao.UsuarioDao;
import br.com.gestor.servlet.ValidaSvt;

@WebServlet(urlPatterns={"/acessos_cadastro"})
public class AcessosSvt extends HttpServlet {
	private static final long serialVersionUID = 1L;

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

    	request.setAttribute("pageTitleCustomized", "Acessos - Painel");//<title>${pageTitleCustomized}</title>
    	request.setAttribute("urlMenuLeftSelected", "acessos_cadastro");//setar a url do href do menu

    	ValidaSvt x = new ValidaSvt();
		request.setAttribute("tela", x.ADM );  
		int libera = x.validaAcesso(request, response);
    	if (libera == x.FAIL) 
        	getServletContext().getRequestDispatcher("/sem_acesso.jsp").forward(request, response);
    	else if (libera == x.USER_NULL)
        	getServletContext().getRequestDispatcher("/sair").forward(request, response);
    	else{
			verListagem(request, response);
			verListagemUsuarios(request, response);
	
	    	RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/acessos_cadastro.jsp");
	    	dispatcher.forward(request, response);
    	}
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        this.doGet(request, response);
    }

    public void verListagem(HttpServletRequest request, HttpServletResponse response){
    	AcessosDao dao = new AcessosDao();
		ArrayList<Acessos> lista = dao.listarAcessos( new Acessos());
		request.setAttribute("acessos", lista);
    }

    public void verListagemUsuarios(HttpServletRequest request, HttpServletResponse response){
    	UsuarioDao dao = new UsuarioDao();
		ArrayList<Usuario> lista = dao.BuscarUsuarios();
		for (int index = 0; index < lista.size(); index++){
			lista.get(index).getAcesso().buscar();
    	}
		request.setAttribute("usuarios", lista);
    }
}