package br.com.gestor.servlet;

import java.io.IOException;
import java.util.ArrayList;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.com.gestor.bean.Associados;
import br.com.gestor.bean.Quadras;
import br.com.gestor.bean.Reservas;
import br.com.gestor.bean.TipoQuadra;
import br.com.gestor.dao.QuadrasDao;
import br.com.gestor.dao.ReservasDao;

@WebServlet(urlPatterns = {"/reservas_associados"})
public class ReservasAssociadosSvt extends HttpServlet {
	private static final long serialVersionUID = 1L;

	@Override
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

		request.setAttribute("pageTitleCustomized", "Reservas - Associados");// <title>${pageTitleCustomized}</title>
		request.setAttribute("urlMenuLeftSelected", "reservas_associados");// setar a url do href do menu

    	ValidaSvt x = new ValidaSvt();
		request.setAttribute("tela", x.RESERVAS );  
		int libera = x.validaAcesso(request, response);
    	if (libera == x.FAIL) 
        	getServletContext().getRequestDispatcher("/sem_acesso.jsp").forward(request, response);
    	else if (libera == x.USER_NULL)
        	getServletContext().getRequestDispatcher("/sair").forward(request, response);
    	else{
			verListagem(request, response);
	
			RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/reservas_associados.jsp");
			dispatcher.forward(request, response);
    	}
	}

	@Override
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		this.doGet(request, response);
	}

	public void verListagem(HttpServletRequest request, HttpServletResponse response) {
		
		QuadrasDao dao = new QuadrasDao();
		ArrayList<TipoQuadra> tiposquadras = dao.listarTodosTiposQuadras();
		request.setAttribute("tiposquadras", tiposquadras);

		ReservasDao reservasDao = new ReservasDao(); 
		ArrayList<Associados> associados = new ArrayList<>(); 
		associados = reservasDao.listarAssociadosDadosPessoais();
		request.setAttribute("associados", associados);
		  
		ArrayList<Reservas> reservas = new ArrayList<>(); 
		reservas = reservasDao.listarReservasParaAssociados();
		request.setAttribute("reservas", reservas);

	}


}
