﻿package br.com.gestor.servlet;

import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.com.gestor.bean.Escolinha;
import br.com.gestor.bean.Quadras;
import br.com.gestor.bean.Reservas;
import br.com.gestor.bean.TipoQuadra;
import br.com.gestor.dao.QuadrasDao;
import br.com.gestor.dao.ReservasDao;

@WebServlet(urlPatterns={"/reservas_escolinha"})
public class ReservasEscolinhaSvt extends HttpServlet {
	private static final long serialVersionUID = 1L;
	
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

    	request.setAttribute("pageTitleCustomized", "Reservas - Escolinha");//<title>${pageTitleCustomized}</title>
    	request.setAttribute("urlMenuLeftSelected", "reservas_escolinha");//setar a url do href do menu

    	ValidaSvt x = new ValidaSvt();
		request.setAttribute("tela", x.RESERVAS );  
		int libera = x.validaAcesso(request, response);
    	if (libera == x.FAIL) 
        	getServletContext().getRequestDispatcher("/sem_acesso.jsp").forward(request, response);
    	else if (libera == x.USER_NULL)
        	getServletContext().getRequestDispatcher("/sair").forward(request, response);
    	else{
			verListagem(request, response);
	
	    	RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/reservas_escolinha.jsp");
	    	dispatcher.forward(request, response);
    	}
    }

	@Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        this.doGet(request, response);
    }
	

    public void verListagem(HttpServletRequest request, HttpServletResponse response){
    	
		
		QuadrasDao dao = new QuadrasDao();
		ArrayList<TipoQuadra> tiposquadras = dao.listarTodosTiposQuadras();
		request.setAttribute("tiposquadras", tiposquadras);

    	ReservasDao reservasDao = new ReservasDao();
    	ArrayList<Reservas> reservas = new ArrayList<>();
    	reservas = reservasDao.listarReservasEscolinhas();    	
		request.setAttribute("reservas", reservas);

		ArrayList<Quadras> lista = dao.listarTodasQuadras();
		request.setAttribute("quadras", lista);
    }

}

/*
	Cookie[] cookies = request.getCookies();
	if( cookies != null ) {
		for (int i = 0; i < cookies.length; i++) {
			Cookie cookie = cookies[i];
			out.print("<" + cookie.getName() + " value='"+cookie.getValue()+"' style='display:none'>");
			out.print(cookie.getValue());
			out.println("</" + cookie.getName() + ">");
		}
	} else {
		out.print("<no-cookies> value='' style='display:none'>no-cookies</no-cookies>");
	}
	
	String resultado = (String)request.getAttribute("resultado");
	out.println(resultado);
*/