package br.com.gestor.servlet;

/**
    Document: .TestServlet
    Created on : Nov 5, 2016, 9:28:18 PM
    Author     :
*/

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.com.gestor.bean.Itens;
import br.com.gestor.bean.Manutencoes;
import br.com.gestor.bean.TipoQuadra;
import br.com.gestor.bean.Quadras;
import br.com.gestor.bean.Reservas;
import br.com.gestor.dao.ManutencoesDao;
import br.com.gestor.dao.ItensDao;
import br.com.gestor.dao.QuadrasDao;
import br.com.gestor.dao.ReservasDao;

@WebServlet(urlPatterns={"/manutencoes_cadastro"})
public class ReservasManutencoesSvt extends HttpServlet {
	private static final long serialVersionUID = 1L;

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

    	request.setAttribute("pageTitleCustomized", "Manutencoes - Painel");//<title>${pageTitleCustomized}</title>
    	request.setAttribute("urlMenuLeftSelected", "manutencoes_cadastro");//setar a url do href do menu

    	ValidaSvt x = new ValidaSvt();
		request.setAttribute("tela", x.MANUTENCOES );  
		int libera = x.validaAcesso(request, response);
    	if (libera == x.FAIL){ 
        	getServletContext().getRequestDispatcher("/sem_acesso.jsp").forward(request, response);
    	}else if (libera == x.USER_NULL){
        	getServletContext().getRequestDispatcher("/sair").forward(request, response);
    	}else{
	    	verListagemItens(request,response);
	    	verListagemManutencoes(request, response);
	    	verListagemTiposQuadras(request, response);		
			
	    	request.setAttribute("c", "");
	
	    	RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/manutencoes_cadastro.jsp");
	    	dispatcher.forward(request, response);
    	}
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        this.doGet(request, response);
    }

    public void verListagemManutencoes(HttpServletRequest request, HttpServletResponse response){

    	ReservasDao dao = new ReservasDao();
		ArrayList<Reservas> lista = dao.listarReservasParaManutencoes();
		request.setAttribute("reservas", lista);
    }

    public void verListagemItens(HttpServletRequest request, HttpServletResponse response){
		ArrayList<Itens> lista = new ItensDao().listarItens(new Itens());
		request.setAttribute("itens", lista);
    }

    public void verListagemTiposQuadras(HttpServletRequest request, HttpServletResponse response) throws IOException{
    	ArrayList<TipoQuadra> lista = new QuadrasDao().listarTodosTiposQuadras();
		request.setAttribute("tipos", lista);
    }

    public void verListagemQuadras(HttpServletRequest request, HttpServletResponse response){
		int codTipo = Integer.parseInt(request.getParameter("codTipo"));
		
    	ArrayList<Quadras> lista = new QuadrasDao().listarsQuadrasPorTipo(codTipo);
		request.setAttribute("quadras", lista);
    }
    
//    public void novaManutencao(HttpServletRequest request, HttpServletResponse response){
//    	ArrayList<Itens> list_itens = new ArrayList<>();
//    	ArrayList<Integer> list_qtds = new ArrayList<>();
//    	
//    	float valor_total = (float) 0.0;
//    	int i = 1;
//    	
//    	while(request.getParameter("codItem"+i) != null ){
//        	Itens item = new Itens();
//        	item.setCodItem(Integer.parseInt(request.getParameter("codItem"+i)));
//        	item = new ItensDao().listarItens(item).get(0);
//        	int qtd = Integer.parseInt(request.getParameter("qtdItem"+i));
//    		
//        	valor_total += qtd*item.getValor();
//    				
//    		list_qtds.add(qtd);
//    		list_itens.add(item);
//    				
//    		i++;
//    	}
//    	
//    	ManutencoesDao dao = new ManutencoesDao();
//
//    	Manutencoes manutencao = new Manutencoes();
//    	manutencao.setValor_total(valor_total);
//    	manutencao.setItensManutencao(list_itens);
//    	manutencao.setQtds(list_qtds);
//    	boolean sucesso = dao.insert(manutencao);
//    	
//    	System.out.println(sucesso);
//    }
}
