package br.com.gestor.servlet;

/**
    Document: .TestServlet
    Created on : Nov 5, 2016, 9:28:18 PM
    Author     :
*/

import java.io.IOException;
import java.util.ArrayList;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import br.com.gestor.bean.Acessos;
import br.com.gestor.bean.Itens;
import br.com.gestor.bean.Usuario;
import br.com.gestor.dao.AcessosDao;
import br.com.gestor.dao.ItensDao;
import br.com.gestor.dao.UsuarioDao;

public class ValidaSvt extends HttpServlet {
	private static final long serialVersionUID = 1L;
	final int ADM = 1;
	final int QUADRAS = 2;
//	final int TIPOS = 3;
	final int ITENS = 4;
	final int MANUTENCOES = 5;
//	final int FILAS_ESPERA = 6;
	final int RESERVAS = 7;
//	final int COLETAS = 8;
	final int RELATORIOS = 9;

	final int FAIL = 0;
	final int OK = 1;
	final int USER_NULL = 2;

    @Override
    public void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
    	validaAcesso(request, response);;
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        this.doGet(request, response);
    }
    
    @SuppressWarnings("finally")
	public int validaAcesso(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException{
    	int acesso = FAIL;
		
    	try{
		    HttpSession session = request.getSession(false);
		    Usuario usuario =  (Usuario) session.getAttribute("usuario");
		
    		int tela = (int) request.getAttribute("tela");

	    	if(tela == ADM && usuario.getAcesso().getAdm()==1){
	    		acesso = OK;
	    	}else{
	    	
		    	switch (tela){
	    		case QUADRAS:
	    			acesso = usuario.getAcesso().getQuadras();
	    			break;
//	    		case TIPOS:
//	    			acesso = usuario.getAcesso().getTipoQuadras();
//	    			break;
	    		case ITENS:
	    			acesso = usuario.getAcesso().getItens();
	    			break;
	    		case MANUTENCOES:
	    			acesso = usuario.getAcesso().getManutencoes();
	    			break;
//	    		case FILAS_ESPERA:
//	    			acesso = usuario.getAcesso().getFilasEspera();
//	    			break;
	    		case RESERVAS:
	    			acesso = usuario.getAcesso().getReservas();
	    			break;
//	    		case COLETAS:
//	    			acesso = usuario.getAcesso().getColetas();
//	    			break;
	    		case RELATORIOS:
	    			acesso = usuario.getAcesso().getRelatorios();
	    			break;
		    	}
		    }
	    }catch(Exception ex){
	    	acesso =  USER_NULL;
	    }finally{
	    	return acesso;
	    }
    }
}