﻿package br.com.test.java;

import java.text.ParseException;
import java.util.Calendar;
import java.util.Date;

public class TestaSQLServer {

	static final int SET_CALENDAR_INIT_ONE = 1;
	static String formatoData = "dd/MM/yyyy HH:mm:ss:SSS";
	
	public static void main(String[] args) throws ParseException {

		String trocaHora = "05:59";
		String strData = "30/06/1990 23:59:59:999";
		Date dateOriginal = StringParaDate(strData, formatoData);
		
		Date retorno = AlterarDataStringemDate(dateOriginal, "02/09/1985");
		System.out.println(DateParaString(retorno, formatoData));
		
		retorno = AlterarHoraStringemDate(retorno, trocaHora);
		System.out.println(DateParaString(retorno, formatoData));
		  
	}

	private static Date AlterarHoraStringemDate(Date date, String timeStr){

		String[] timeSplit = timeStr.split(":");
		int horaformato24 = 0, minuto = 0, segundo = 0, milisegundos = 0; 
		if(timeSplit.length > 0){
			 if(timeSplit.length > 0 && timeSplit[0] != null)
				 horaformato24 = Integer.parseInt(timeSplit[0]);
			 if(timeSplit.length > 1 && timeSplit[1] != null)
				 minuto =  Integer.parseInt(timeSplit[1]);
			 if(timeSplit.length > 2 && timeSplit[2] != null)
				 segundo =  Integer.parseInt(timeSplit[2]);
			 if(timeSplit.length > 3 && timeSplit[3] != null)
				 milisegundos = Integer.parseInt(timeSplit[3]);
		}
		
		Calendar now = Calendar.getInstance();
		now.setTime(date);//SETA A DATA ORIGINAL
		now.set(Calendar.HOUR_OF_DAY, horaformato24);//formato 24horas
		now.set(Calendar.MINUTE, minuto);
		now.set(Calendar.SECOND, segundo);
		now.set(Calendar.MILLISECOND, milisegundos);
		return now.getTime();
	} 
	
	private static Date AlterarDataStringemDate(Date date, String dataStr10digitos){

		String[] dateSplit = dataStr10digitos.split("/");
		int diaDoMes = 0, mes = 0, ano4digitos = 0; 
		if(dateSplit.length > 0){
			 if(dateSplit.length > 0 && dateSplit[0] != null)
				 diaDoMes =  Integer.parseInt(dateSplit[0]);
			 if(dateSplit.length > 1 && dateSplit[1] != null)
				 mes =  Integer.parseInt(dateSplit[1]);
			 if(dateSplit.length > 2 && dateSplit[2] != null)
				 ano4digitos = Integer.parseInt(dateSplit[2].substring(0, 4));
		}
		final int MINUS_CALENDAR_INIT_ONE = 1;
		Calendar now = Calendar.getInstance();
			now.setTime(date);//SETA A DATA ORIGINAL
			now.set(Calendar.DAY_OF_MONTH, diaDoMes);
			now.set(Calendar.MONTH, mes-MINUS_CALENDAR_INIT_ONE);
			now.set(Calendar.YEAR, ano4digitos);
		return now.getTime();
	}
	
	private static Date AlterarHoraemDate(Date date, int horaformato24, int minuto, int segundo, int milisegundos){
		Calendar now = Calendar.getInstance();
			now.setTime(date);//SETA A DATA ORIGINAL
			now.set(Calendar.HOUR_OF_DAY, horaformato24);//formato 24horas
			now.set(Calendar.MINUTE, minuto);
			now.set(Calendar.SECOND, segundo);
			now.set(Calendar.MILLISECOND, milisegundos);
		return now.getTime();
	}
	
	/** converte uma String para o formato Date */
	private static Date StringParaDate(String str, String formatoData) throws ParseException{
		java.text.DateFormat formatter = new java.text.SimpleDateFormat(formatoData);
		return (Date)formatter.parse(str);
	}

	/** converte uma Date para o formato String */
	private static String DateParaString(Date date, String formatoData){
		java.text.SimpleDateFormat sdf2 = new java.text.SimpleDateFormat(formatoData);
		return sdf2.format(date);
	}
}

